# File changed

import sys
import numpy as np
import numba
from numba import njit, b1, i4, i8, f8
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
MOD = 998244353

@njit
def mpow(a, n):
    p = 1
    while n:
        if (n & 1):
            p = ((p * a) % MOD)
        a = ((a * a) % MOD)
        n >>= 1
    return p

@njit
def build(raw_data):
    bit = raw_data.copy()
    for i in range(len(bit)):
        j = (i + (i & (- i)))
        if (j < len(bit)):
            bit[j] += bit[i]
            bit[j] %= MOD
    return bit

@njit
def get_sum(bit, i):
    s = 0
    while i:
        s += bit[i]
        i -= (i & (- i))
    return (s % MOD)

@njit
def add(bit, i, x):
    while (i < len(bit)):
        bit[i] += x
        bit[i] %= MOD
        i += (i & (- i))

@njit
def main(K, A):
    N = len(A)
    p = ((1 - mpow(K, (MOD - 2))) % MOD)
    p_inv = mpow(p, (MOD - 2))
    bit_active = np.zeros((N + 1), np.int64)
    bit_cnt = np.zeros((N + 1), np.int64)
    half = ((MOD + 1) // 2)
    ans = 0
    ans += (((((K * (K - 1)) // 2) % MOD) * half) % MOD)
    ans %= MOD
    for i in range(K):
        x = A[i]
        add(bit_cnt, x, 1)
        add(bit_active, x, mpow(p_inv, (K - 1)))
    for i in range(K, N):
        x = A[i]
        low_cnt = get_sum(bit_cnt, x)
        high_cnt = (i - low_cnt)
        pt = mpow(p, i)
        active_sum_low = ((get_sum(bit_active, x) * pt) % MOD)
        active_sum_high = ((K - 1) - active_sum_low)
        add(bit_cnt, x, 1)
        add(bit_active, x, mpow(p_inv, i))
        inv = 0
        inv += ((active_sum_low * half) % MOD)
        inv += (high_cnt - active_sum_high)
        inv += ((active_sum_high * half) % MOD)
        inv %= MOD
        ans += inv
        ans %= MOD
    return ans
(N, K) = map(int, readline().split())
A = np.array(read().split(), np.int64)
print(main(K, A))

