# File changed

import os
import sys
import numpy as np

def solve(inp):
    'Solves the problem

    Args:
        inp (list): A list of inputs.

    Returns:
        list: A list of outputs.
    '
    def floor_sum(n, m, a, b):
        'Calculates the floor sum

        Args:
            n (int): The first number.
            m (int): The second number.
            a (int): The third number.
            b (int): The fourth number.

        Returns:
            int: The floor sum.
        '
        result = 0
        while True:
            result += (((((n - 1) * n) * (a // m)) // 2) + (n * (b // m)))
            a %= m
            b %= m
            y_max = (((a * n) + b) // m)
            if (y_max == 0):
                break
            x_max = ((y_max * m) - b)
            result += ((n - (((x_max + a) - 1) // a)) * y_max)
            (n, m, a, b) = (y_max, a, m, ((a - (x_max % a)) % a))
        return result
    t = inp[0]
    ans = np.zeros(t, np.int64)
    for i in range(t):
        (n, m, a, b) = inp[((i * 4) + 1):((i * 4) + 5)]
        ans[i] = floor_sum(n, m, a, b)
    return ans
if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
    from numba.pycc import CC
    cc = CC('my_module')
    cc.export('solve', '(i8[:],)')(solve)
    cc.compile()
    exit()
if (os.name == 'posix'):
    from my_module import solve
else:
    from numba import njit
    solve = njit('(i8[:],)', cache=True)(solve)
    print('compiled', file=sys.stderr)
inp = np.fromstring(sys.stdin.read(), dtype=np.int64, sep=' ')
ans = solve(inp)
print('\n'.join(map(str, ans)))


