# File changed

from numba import jit, njit, i8
import numpy as np

@njit(i8(i8, i8, i8), cache=True)
def modpow(a, p, m):
    r = 1
    while p:
        if (p & 1):
            r = ((r * a) % m)
        a = ((a * a) % m)
        p >>= 1
    return r

@njit(i8[:](i8[:], i8[:]), cache=True)
def ntt(s, t):
    mod = 998244353
    pr = 5
    (sl, tl) = (len(s), len(t))
    k = 1
    M = 2
    while (M < ((sl + tl) - 1)):
        k += 1
        M *= 2
    w = np.zeros((M // 2), np.int64)
    y = np.zeros((M // 2), np.int64)

    def init():
        nonlocal w, y, M, mod, pr
        z = modpow(pr, ((mod - 1) // M), mod)
        x = modpow(z, (mod - 2), mod)
        j = (M // 4)
        while j:
            w[j] = z
            z = ((z * z) % mod)
            y[j] = x
            x = ((x * x) % mod)
            j //= 2
        y[0] = 1
        w[0] = 1
        j = (M // 2)
        js = 2
        while (js < j):
            z = w[js]
            x = y[js]
            for k2 in range(js):
                w[(k2 + js)] = ((w[k2] * z) % mod)
                y[(k2 + js)] = ((y[k2] * x) % mod)
            js *= 2

    def fft(a, k):
        nonlocal w, y, mod
        m = (2 ** k)
        u = 1
        v = (m // 2)
        i = k
        while i:
            jh = 0
            while (jh < u):
                wj = w[jh]
                j = ((jh * v) * 2)
                je = (j + v)
                while (j < je):
                    ajv = ((wj * a[(j + v)]) % mod)
                    a[(j + v)] = ((a[j] + mod) - ajv)
                    if (a[(j + v)] >= mod):
                        a[(j + v)] -= mod
                    a[j] = (a[j] + ajv)
                    if (a[j] >= mod):
                        a[j] -= mod
                    j += 1
                jh += 1
            u *= 2
            v //= 2
            i -= 1

    def ifft(a, k):
        nonlocal w, y, mod
        m = (2 ** k)
        u = (m // 2)
        v = 1
        i = 1
        while (i <= k):
            jh = 0
            while (jh < u):
                wj = y[jh]
                j = ((jh * v) * 2)
                je = (j + v)
                while (j < je):
                    ajv = ((a[j] + mod) - a[(j + v)])
                    if (ajv >= mod):
                        ajv -= mod
                    a[j] = (a[j] + a[(j + v)])
                    if (a[j] >= mod):
                        a[j] -= mod
                    a[(j + v)] = ((wj * ajv) % mod)
                    j += 1
                jh += 1
            u //= 2
            v *= 2
            i += 1
    init()
    u = np.zeros(M, np.int64)
    u[:sl] = s
    fft(u, k)
    v = np.zeros(M, np.int64)
    v[:tl] = t
    fft(v, k)
    u *= v
    u %= mod
    ifft(u, k)
    u *= modpow((2 ** k), (mod - 2), mod)
    u %= mod
    return u[:((sl + tl) - 1)]
import sys
readline = sys.stdin.buffer.readline
(N, M) = map(int, readline().split())
A = np.array(readline().split(), np.int64)
B = np.array(readline().split(), np.int64)
print(' '.join(map(str, ntt(A, B))))

'''

# Test code

# Test 1

# Test 2

# Test 3

# Test 4

# Test 5

# Test 6

# Test 7

# Test 8

# Test 9

# Test 10

# Test 11

# Test 12

# Test 13

# Test 14

# Test 15

# Test 16

# Test 17

# Test 18

# Test 19

# Test 20

# Test 21

# Test 22

# Test 23

# Test 24

# Test 25

# Test 26

# Test 27

# Test 28

# Test 29

# Test 30

# Test 31

# Test 32

# Test 33

# Test 34

# Test 35

# Test 36

# Test 37

# Test 38

# Test 39

# Test 40

# Test 41

# Test 42

# Test 43

# Test 44

# Test 45

# Test 46

# Test 47

# Test 48

# Test 49

# Test 50

# Test 51

# Test 52

# Test 53

# Test 54

# Test 55

# Test 56

# Test 57

# Test 58

# Test 59

# Test 60

# Test 61

# Test 62

# Test 63

# Test 64

# Test 65

# Test 66

# Test 67

# Test 