# File changed

from functools import cmp_to_key

thresholdnaive = 10
thresholddoubling = 40

def sa_naive(s):
  def cmp(r, l):
    if l == r:
      return -1
    while (l < n and r < n):
      if s[l] != s[r]:
        return 1 if s[l] < s[r] else -1
      l += 1
      r += 1
    return 1 if l == n else -1
  n = len(s)
  sa = [i for i in range(n)]
  sa.sort(key=cmp_to_key(cmp))
  return sa

def sa_doubling(s):
  n = len(s)
  sa = [i for i in range(n)]
  rnk = s
  tmp = [0] * n
  k = 1
  while k < n:

    def cmp(y, x):
      if rnk[x] != rnk[y]:
        return 1 if rnk[x] < rnk[y] else -1
      rx = rnk[(x + k)] if (x + k < n) else -1
      ry = rnk[(y + k)] if (y + k < n) else -1
      return 1 if rx < ry else -1
    sa.sort(key=cmp_to_key(cmp))
    tmp[sa[0]] = 0
    for i in range(1, n):
      tmp[sa[i]] = tmp[sa[(i - 1)]] + (1 if cmp(sa[i], sa[(i - 1)]) == 1 else 0)
    (tmp, rnk) = (rnk, tmp)
    k *= 2
  return sa

def sa_is(s, upper):
  n = len(s)
  if n == 0:
    return []
  if n == 1:
    return [0]
  if n == 2:
    if s[0] < s[1]:
      return [0, 1]
    else:
      return [1, 0]
  if n < thresholdnaive:
    return sa_naive(s)
  if n < thresholddoubling:
    return sa_doubling(s)
  sa = [0] * n
  ls = [False] * n
  for i in range(n - 2, -1, -1):
    ls[i] = ls[i + 1] if s[i] == s[i + 1] else s[i] < s[i + 1]
  suml = [0] * (upper + 1)
  sums = [0] * (upper + 1)
  for i in range(n):
    if not ls[i]:
      sums[s[i]] += 1
    else:
      suml[s[i] + 1] += 1
  for i in range(upper + 1):
    sums[i] += suml[i]
    if i < upper:
      suml[i + 1] += sums[i]

  def induce(lms):
    for i in range(n):
      sa[i] = -1
    buf = [0] * (upper + 1)
    for i in range(len(sums)):
      buf[i] = sums[i]
    for d in lms:
      if d == n:
        continue
      sa[buf[s[d]]] = d
      buf[s[d]] += 1
    for i in range(len(suml)):
      buf[i] = suml[i]
    sa[buf[s[n - 1]]] = n - 1
    buf[s[n - 1]] += 1
    for i in range(n):
      v = sa[i]
      if (v >= 1 and not ls[v - 1]):
        sa[buf[s[v - 1]]] = v - 1
        buf[s[v - 1]] += 1
    for i in range(len(suml)):
      buf[i] = suml[i]
    for i in range(n - 1, -1, -1):
      v = sa[i]
      if (v >= 1 and ls[v - 1]):
        buf[s[v - 1] + 1] -= 1
        sa[buf[s[v - 1] + 1]] = v - 1
  lmsmap = [-1] * (n + 1)
  m = 0
  for i in range(1, n):
    if not ls[i - 1] and ls[i]:
      lmsmap[i] = m
      m += 1
  lms = []
  for i in range(1, n):
    if not ls[i - 1] and ls[i]:
      lms.append(i)
  induce(lms)
  if m:
    sortedlms = []
    for v in sa:
      if lmsmap[v] != -1:
        sortedlms.append(v)
    recs = [0] * m
    recupper = 0
    recs[lmsmap[sortedlms[0]]] = 0
    for i in range(1, m):
      l, r = sortedlms[i - 1], sortedlms[i]
      endl = lms[lmsmap[l] + 1] if lmsmap[l] + 1 < m else n
      endr = lms[lmsmap[r] + 1] if lmsmap[r] + 1 < m else n
      same = True
      if endl - l != endr - r:
        same = False
      else:
        while l < endl:
          if s[l] != s[r]:
            break
          l += 1
          r += 1
        if l == n or s[l] != s[r]:
          same = False
      if not same:
        recupper += 1
      recs[lmsmap[sortedlms[i]]] = recupper
    recsa = sa_is(recs, recupper)
    for i in range(m):
      sortedlms[i] = lms[recsa[i]]
    induce(sortedlms)
  return sa

def suffix_array(s, upper):
  sa = sa_is(s, upper)
  return sa

def suffix_array(s):
  if type(s) == str:
    return suffix_array_str(s)

  def cmp(r, l):
    return 1 if s[l] < s[r] else -1
  n = len(s)
  idx = [i for i in range(n)]
  idx.sort(key=cmp_to_key(cmp))
  s2 = [