# File changed

import numpy as np
import sys
sys.setrecursionlimit((10 ** 9))
inf = (10 ** 18)

def solve(N, A):
    maxim = ((10 ** 6) + 10)
    spf = np.zeros((maxim + 1), dtype=np.int64)
    for i in range(maxim):
        spf[i] = i
    i = 2
    while ((i * i) <= maxim):
        if (spf[i] != i):
            i += 1
            continue
        j = (i * i)
        while (j <= maxim):
            if (spf[j] != j):
                j += i
                continue
            spf[j] = i
            j += i
        i += 1
    pairwise = True
    allp = set()
    for a in A:
        m = set()
        n = a
        while (n > 1):
            m.add(spf[n])
            n //= spf[n]
        P = m
        nocollapse = (len(allp) + len(P))
        for p in P:
            allp.add(p)
        res = len(allp)
        if (nocollapse != res):
            pairwise = False
            break
    return pairwise

def main():

    def iterate_tokens():
        for line in sys.stdin:
            for word in line.split():
                (yield word)
    tokens = iterate_tokens()
    N = int(next(tokens))
    A = [int(next(tokens)) for _ in range(N)]
    pairwise = solve(N, np.array(A))
    if pairwise:
        print('pairwise coprime')
    else:
        gcm = np.gcd.reduce(A)
        if (gcm == 1):
            print('setwise coprime')
        else:
            print('not coprime')

def cc_export():
    from numba.pycc import CC
    cc = CC('my_module')
    cc.export('solve', '(i8,i8[:],)')(solve)
    cc.compile()
if (__name__ == '__main__'):
    try:
        from my_module import solve
    except:
        cc_export()
        exit()
    main()

'''
