# File changed

import os
import sys
import numpy as np
from heapq import heappop, heappush, heapify

def solve(inp):

    def fenwick_add(arr, n, i, x):
        while (i <= n):
            arr[i] += x
            i += (i & (- i))

    def fenwick_sum(arr, i):
        result = 0
        while (i > 0):
            result += arr[i]
            i ^= (i & (- i))
        return result

    def fenwick_lower_bound(arr, n, log_n, x):
        sum_ = 0
        pos = 0
        for i in range(log_n, (- 1), (- 1)):
            k = (pos + (1 << i))
            if ((k < n) and ((sum_ + arr[k]) < x)):
                sum_ += arr[k]
                pos += (1 << i)
        return (pos + 1)

    def bit_length(x):
        res = 0
        while x:
            res += 1
            x >>= 1
        return res
    h = inp[0]
    w = inp[1]
    aaa = inp[2::2]
    bbb = inp[3::2]
    w1 = (w + 1)
    log_w = bit_length(w1)
    arr = np.zeros((w1 + 1), dtype=np.int64)
    for j in range(1, w1):
        arr[j] = (j & (- j))
    fenwick_add(arr, w1, w1, (10 ** 18))
    horizontal = np.zeros((w + 1), dtype=np.int64)
    horizontal_rev = np.arange((w + 1), dtype=np.int64)
    q = [(0, j) for j in range(1, (w + 1))]
    heapify(q)
    ans = np.full(h, (- 1), dtype=np.int64)
    for row in range(h):
        a = aaa[row]
        b = bbb[row]
        k = (1 if (a == 1) else (fenwick_sum(arr, (a - 1)) + 1))
        c = fenwick_lower_bound(arr, w1, log_w, k)
        stack = []
        while (c <= (b + 1)):
            stack.append(c)
            if (c == w1):
                break
            k += 1
            c = fenwick_lower_bound(arr, w1, log_w, k)
        if (len(stack) == 0):
            ans[row] = ((row + q[0][0]) + 1)
            continue
        if (stack[(- 1)] == w1):
            found_nearest = True
            stack.pop()
        else:
            found_nearest = False
        stack.reverse()
        for c in stack:
            if found_nearest:
                fenwick_add(arr, w1, c, (- 1))
                horizontal[horizontal_rev[c]] = (- 1)
            elif (c == (b + 1)):
                found_nearest = True
            else:
                orig = horizontal_rev[c]
                horizontal[orig] = ((b + 1) - orig)
                horizontal_rev[(b + 1)] = orig
                fenwick_add(arr, w1, c, (- 1))
                fenwick_add(arr, w1, (b + 1), 1)
                heappush(q, (horizontal[orig], orig))
                found_nearest = True
        while (q and (q[0][0] != horizontal[q[0][1]])):
            heappop(q)
        if (len(q) == 0):
            break
        ans[row] = ((row + q[0][0]) + 1)
    return ans
if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
    from numba.pycc import CC
    cc = CC('my_module')
    cc.export('solve', '(i8[:],)')(solve)
    cc.compile()
    exit()
if (os.name == 'posix'):
    from my_module import solve
else:
    from numba import njit
    solve = njit('(i8[:],)', cache=True)(solve)
    print('compiled', file=sys.stderr)
inp = np.fromstring(sys.stdin.read(), dtype=np.int64, sep=' ')
ans = solve(inp)
print('\n'.join(map(str, ans)))
