import sys

class SWAG:
    def __init__(self):
        self.fold_l = []
        self.r = []
        self.fold_r = ~(1 << 60)
    def push(self, a):
        if self.fold_r < a:
            self.fold_r = a
        self.r.append(a)
    def pop(self):
        if not self.fold_l:
            self.r.reverse()
            self.fold_l = self.r
            self.r = []
            self.fold_r = ~(1 << 60)
            fold_l = self.fold_l
            for i in range(len(fold_l) - 1):
                if fold_l[i + 1] < fold_l[i]:
                    fold_l[i + 1] = fold_l[i]
        self.fold_l.pop()
    def get(self):
        if not self.fold_l:
            return self.fold_r
        elif not self.r:
            return self.fold_l[-1]
        else:
            return max(self.fold_l[-1], self.fold_r)

@pytest.mark.parametrize('n, k, p, c, ans', [
    (3, 1, [0, 1, 2], [1, 2, 3], 3),
    (3, 2, [0, 1, 2], [1, 2, 3], 3),
    (3, 3, [0, 1, 2], [1, 2, 3], 3),
    (3, 4, [0, 1, 2], [1, 2, 3], 3),
    (3, 5, [0, 1, 2], [1, 2, 3], 3),
    (3, 6, [0, 1, 2], [1, 2, 3], 3),
    (3, 7, [0, 1, 2], [1, 2, 3], 3),
    (3, 8, [0, 1, 2], [1, 2, 3], 3),
    (3, 9, [0, 1, 2], [1, 2, 3], 3),
    (3, 10, [0, 1, 2], [1, 2, 3], 3),
    (3, 11, [0, 1, 2], [1, 2, 3], 3),
    (3, 12, [0, 1, 2], [1, 2, 3], 3),
    (3, 13, [0, 1, 2], [1, 2, 3], 3),
    (3, 14, [0, 1, 2], [1, 2, 3], 3),
    (3, 15, [0, 1, 2], [1, 2, 3], 3),
    (3, 16, [0, 1, 2], [1, 2, 3], 3),
    (3, 17, [0, 1, 2], [1, 2, 3], 3),
    (3, 18, [0, 1, 2], [1, 2, 3], 3),
    (3, 19, [0, 1, 2], [1, 2, 3], 3),
    (3, 20, [0, 1, 2], [1, 2, 3], 3),
    (3, 21, [0, 1, 2], [1, 2, 3], 3),
    (3, 22, [0, 1, 2], [1, 2, 3], 3),
    (3, 23, [0, 1, 2], [1, 2, 3], 3),
    (3, 24, [0, 1, 2], [1, 2, 3], 3),
    (3, 25, [0, 1, 2], [1, 2, 3], 3),
    (3, 26, [0, 1, 2], [1, 2, 3], 3),
    (3, 27, [0, 1, 2], [1, 2, 3], 