# File changed

import os
import sys
import numpy as np

def solve(inp):
    n = inp[0]
    xxx = inp[1::2]
    yyy = inp[2::2]
    xxx_idx = np.argsort(xxx)
    yyy_idx = np.argsort(yyy)
    xxx_num = np.argsort(xxx_idx)
    yyy_num = np.argsort(yyy_idx)

    def get_xy_by_xi(xi):
        i = xxx_idx[xi]
        return (xxx[i], yyy[i])

    def calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, lpxi, rnxi, rook_cnt):
        (lpx, lpy) = get_xy_by_xi(lpxi)
        (rnx, rny) = get_xy_by_xi(rnxi)
        diag_t = ((abs((rnx - lpx)) + abs((rny - lpy))) - rook_cnt)
        lllt = (((llt + abs((rnx - lx))) + abs((rny - ly))) + diag_t)
        llrt = (((llt + abs((lx - lpx))) + abs((ly - lpy))) + diag_t)
        lrlt = (((lrt + abs((rnx - rx))) + abs((rny - ry))) + diag_t)
        lrrt = (((lrt + abs((rx - lpx))) + abs((ry - lpy))) + diag_t)
        rllt = (((rlt + abs((rnx - lx))) + abs((rny - ly))) + diag_t)
        rlrt = (((rlt + abs((lx - lpx))) + abs((ly - lpy))) + diag_t)
        rrlt = (((rrt + abs((rnx - rx))) + abs((rny - ry))) + diag_t)
        rrrt = (((rrt + abs((rx - lpx))) + abs((ry - lpy))) + diag_t)
        llt = min(lllt, lrlt)
        lrt = min(llrt, lrrt)
        rlt = min(rllt, rrlt)
        rrt = min(rlrt, rrrt)
        return (lpx, lpy, rnx, rny, llt, lrt, rlt, rrt)
    free = np.zeros(n, dtype=np.int8)
    for i in range(n):
        xi = xxx_num[i]
        yi = yyy_num[i]
        px_i = ((- 1) if (xi == 0) else xxx_idx[(xi - 1)])
        nx_i = ((- 2) if (xi == (n - 1)) else xxx_idx[(xi + 1)])
        py_i = ((- 3) if (yi == 0) else yyy_idx[(yi - 1)])
        ny_i = ((- 4) if (yi == (n - 1)) else yyy_idx[(yi + 1)])
        if ((px_i == py_i) or (px_i == ny_i)):
            free[(xi - 1)] = 1
        if ((nx_i == py_i) or (nx_i == ny_i)):
            free[xi] = 1
    free_l = np.zeros(n, dtype=np.int64)
    free_r = np.zeros(n, dtype=np.int64)
    l = 0
    for xi in range((n - 1)):
        if (free[xi] == 0):
            l = (xi + 1)
        free_l[(xi + 1)] = l
    r = (n - 1)
    free_r[r] = r
    for xi in range((n - 2), (- 1), (- 1)):
        if (free[xi] == 0):
            r = xi
        free_r[xi] = r
    extra_l = np.zeros(n, dtype=np.int64)
    extra_r = np.zeros(n, dtype=np.int64)
    INF = (10 ** 18)
    lxi = 0
    while (lxi < n):
        rxi = free_r[lxi]
        if (lxi == rxi):
            lxi = (rxi + 1)
            continue
        li = xxx_idx[lxi]
        ri = xxx_idx[rxi]
        lyi = yyy_num[li]
        ryi = yyy_num[ri]
        (lyi, ryi) = (min(lyi, ryi), max(lyi, ryi))
        original_li = lxi
        lx = xxx[li]
        ly = yyy[li]
        rx = xxx[ri]
        ry = yyy[ri]
        (llt, lrt, rlt, rrt) = (0, INF, INF, 0)
        while True:
            px_i = ((- 1) if (lxi == 0) else xxx_idx[(lxi - 1)])
            py_i = ((- 2) if (lyi == 0) else yyy_idx[(lyi - 1)])
            nx_i = ((- 3) if (rxi == (n - 1)) else xxx_idx[(rxi + 1)])
            ny_i = ((- 4) if (ryi == (n - 1)) else yyy_idx[(ryi + 1)])
            if (px_i == py_i):
                lpxi = free_l[(lxi - 1)]
                rook_cnt = (lxi - lpxi)
                if (nx_i == ny_i):
                    rnxi = free_r[(rxi + 1)]
                    rook_cnt += (rnxi - rxi)
                    (lx, ly, rx, ry, llt, lrt, rlt, rrt) = calc_time(lx, ly, rx, ry, llt, lrt, rlt, rrt, lpxi, rnxi, rook_cnt)
                    lxi = lpxi
                    rxi = rnxi
                    uyi = yyy_num[xxx_idx[lxi]]
                    vyi = yyy_num[xxx_idx[rxi]]
                    (lyi, ryi) = (min(lyi, ryi, uyi, vyi), max(lyi, ryi, uyi, vyi))
                else:
                    (lx, ly, rx, ry, llt, lrt, rlt, rrt) = calc_time(lx, ly, rx