# File changed

import sys
import numpy as np

def addBIT(itemCount, items, i, value):
    while (i <= itemCount):
        items[i] += value
        i += (i & (- i))

def sumFromStart(items, end):
    summary = 0
    i = end
    while (i > 0):
        summary += items[i]
        i -= (i & (- i))
    return summary

def sumBIT(items, start, end):
    summary = (sumFromStart(items, end) - sumFromStart(items, (start - 1)))
    return summary

def main(N, Q, C, queries, orderByR, mostRightColorIndex, bitArray):
    ans = np.zeros(Q, dtype=np.int64)
    qindex = 0
    for n in range(N):
        if (Q <= qindex):
            break
        if (0 < mostRightColorIndex[C[n]]):
            addBIT(N, bitArray, mostRightColorIndex[C[n]], (- 1))
        mostRightColorIndex[C[n]] = (n + 1)
        addBIT(N, bitArray, (n + 1), 1)
        while ((qindex < Q) and ((n + 1) == queries[orderByR[qindex]][1])):
            tmpindex = orderByR[qindex]
            start = queries[tmpindex][0]
            end = queries[tmpindex][1]
            ans[tmpindex] = sumBIT(bitArray, start, end)
            qindex += 1
    return ans
if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
    from numba import njit
    from numba.pycc import CC
    cc = CC('my_module')
    cc.export('addBIT', '(i8,i8[:],i8,i8)')(addBIT)
    addBIT = njit(addBIT)
    cc.export('sumFromStart', '(i8[:],i8)')(sumFromStart)
    sumFromStart = njit(sumFromStart)
    cc.export('sumBIT', '(i8[:],i8,i8)')(sumBIT)
    sumBIT = njit(sumBIT)
    cc.export('main', 'i8[:](i8,i8,i8[:],i8[:,:],i8[:],i8[:],i8[:])')(main)
    cc.compile()
    exit(0)
from my_module import main, addBIT, sumBIT

def input():
    return sys.stdin.readline()
(N, Q) = map(int, input().split())
C = np.array(input().split(), int)
queries = np.empty((Q, 2), int)
for q in range(Q):
    (l, r) = map(int, input().split())
    queries[q][0] = l
    queries[q][1] = r
orderByR = np.argsort(queries[(:, 1)])
mostRightColorIndex = np.zeros((N + 1), int)
bitArray = np.zeros((N + 1), int)
for a in main(N, Q, C, queries, orderByR, mostRightColorIndex, bitArray):
    print(a)

