# File changed

import sys
import numpy as np

def add_bit(item_count, items, i, value):
    while i <= item_count:
        items[i] += value
        i += (i & (- i))

def sum_from_start(items, end):
    summary = 0
    i = end
    while i > 0:
        summary += items[i]
        i -= (i & (- i))
    return summary

def sum_bit(items, start, end):
    summary = (sum_from_start(items, end) - sum_from_start(items, (start - 1)))
    return summary

def main(n, q, c, queries, order_by_r, most_right_color_index, bit_array):
    ans = np.zeros(q, dtype=np.int64)
    qindex = 0
    for n in range(n):
        if q <= qindex:
            break
        if 0 < most_right_color_index[c[n]]:
            add_bit(n, bit_array, most_right_color_index[c[n]], (- 1))
        most_right_color_index[c[n]] = (n + 1)
        add_bit(n, bit_array, (n + 1), 1)
        while (qindex < q) and ((n + 1) == queries[order_by_r[qindex]][1]):
            tmpindex = order_by_r[qindex]
            start = queries[tmpindex][0]
            end = queries[tmpindex][1]
            ans[tmpindex] = sum_bit(bit_array, start, end)
            qindex += 1
    return ans
if sys.argv[(- 1)] == 'ONLINE_JUDGE':
    from numba import njit
    from numba.pycc import CC
    cc = CC('my_module')
    cc.export('add_bit', '(i8,i8[:],i8,i8)')(add_bit)
    add_bit = njit(add_bit)
    cc.export('sum_from_start', '(i8[:],i8)')(sum_from_start)
    sum_from_start = njit(sum_from_start)
    cc.export('sum_bit', '(i8[:],i8,i8)')(sum_bit)
    sum_bit = njit(sum_bit)
    cc.export('main', 'i8[:](i8,i8,i8[:],i8[:,:],i8[:],i8[:],i8[:])')(main)
    cc.compile()
    exit(0)
from my_module import main, add_bit, sum_bit

def input():
    return sys.stdin.readline()
(n, q) = map(int, input().split())
c = np.array(input().split(), int)
queries = np.empty((q, 2), int)
for q in range(q):
    (l, r) = map(int, input().split())
    queries[q][0] = l
    queries[q][1] = r
order_by_r = np.argsort(queries[(:, 1)])
most_right_color_index = np.zeros((n + 1), int)
bit_array = np.zeros((n + 1), int)
for a in main(n, q, c, queries, order_by