import sys
import numpy as np
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

def resolve(XYP):
  (x, y, p) = (XYP[::3], XYP[1::3], XYP[2::3])
  N = len(x)
  xcost = np.empty(((1 << N), N), np.int64)
  xcost[0] = (np.abs(x) * p)
  for n in range(N):
    b = (1 << n)
    xcost[b:(2 * b)] = np.minimum(xcost[:b], np.abs(((x - x[n]) * p)))
  ycost = np.empty(((1 << N), N), np.int64)
  ycost[0] = (np.abs(y) * p)
  for n in range(N):
    b = (1 << n)
    ycost[b:(2 * b)] = np.minimum(ycost[:b], np.abs(((y - y[n]) * p)))
  popcount = np.zeros((1 << N), np.int64)
  for n in range(N):
    popcount[(1 << n):(1 << (n + 1))] = (popcount[:(1 << n)] + 1)
  inf = (10 ** 18)
  ans = np.full((N + 1), inf, np.int64)
  for s in range((1 << N)):
    size = popcount[s]
    t = s
    while True:
      u = (s ^ t)
      cost = np.minimum(xcost[t], ycost[u]).sum()
      ans[size] = min(ans[size], cost)
      if (t == 0):
        break
      t = ((t - 1) & s)
  return ans

if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
  import numba
  from numba.pycc import CC
  i8 = numba.int64
  cc = CC('my_module')

  def cc_export(f, signature):
    cc.export(f.__name__, signature)(f)
    return numba.njit(f)
  resolve = cc_export(resolve, (i8[:],))
  cc.compile()

from my_module import resolve
N = int(readline())
XYP = np.array(read().split(), np.int64)
ans = resolve(XYP)
print('\n'.join(map(str, ans.tolist())))

