import pytest

@pytest.mark.parametrize('n, s, expected', [
    (1, ['AC'], 'AC x 1'),
    (1, ['WA'], 'WA x 1'),
    (1, ['TLE'], 'TLE x 1'),
    (1, ['RE'], 'RE x 1'),
    (2, ['AC', 'AC'], 'AC x 2'),
    (2, ['AC', 'WA'], 'AC x 1\nWA x 1'),
    (2, ['AC', 'TLE'], 'AC x 1\nTLE x 1'),
    (2, ['AC', 'RE'], 'AC x 1\nRE x 1'),
    (2, ['WA', 'AC'], 'WA x 1\nAC x 1'),
    (2, ['WA', 'WA'], 'WA x 2'),
    (2, ['WA', 'TLE'], 'WA x 1\nTLE x 1'),
    (2, ['WA', 'RE'], 'WA x 1\nRE x 1'),
    (2, ['TLE', 'AC'], 'TLE x 1\nAC x 1'),
    (2, ['TLE', 'WA'], 'TLE x 1\nWA x 1'),
    (2, ['TLE', 'TLE'], 'TLE x 2'),
    (2, ['TLE', 'RE'], 'TLE x 1\nRE x 1'),
    (2, ['RE', 'AC'], 'RE x 1\nAC x 1'),
    (2, ['RE', 'WA'], 'RE x 1\nWA x 1'),
    (2, ['RE', 'TLE'], 'RE x 1\nTLE x 1'),
    (2, ['RE', 'RE'], 'RE x 2'),
])
def test_print_verdict(capsys, n, s, expected):
    print('AC x ',s.count('AC'))
    print('WA x ',s.count('WA'))
    print('TLE x ',s.count('TLE'))
    print('RE x ',s.count('RE'))
    captured = capsys.readouterr()
    assert captured.out == expected

