# File changed

import numpy as np
import numba as nb

@nb.njit('(i1[:],)', cache=True)
def solve(s):
    n = len(s)
    size = (n // 2)
    mod = 998244353
    dpcan = np.zeros(((n + 1), (size + 1), (size + 1)), dtype=np.int8)
    dpcnt = np.zeros(((n + 1), (size + 1), (size + 1)), dtype=np.int64)
    dpcnt[(n, 0)] = 1
    for j in range(size):
        dpcnt[(n, (j + 1))] = (np.cumsum(dpcnt[(n, j)]) % mod)
    for i in range((n - 1), (- 1), (- 1)):
        if (s[i] == 0):
            for j in range((size + 1)):
                dpcnt[(i, j)] = (np.cumsum(dpcnt[((i + 1), j)]) % mod)
        else:
            for k in range((size + 1)):
                dpcnt[(i, :, k)] = (np.cumsum(dpcnt[((i + 1), :, k)]) % mod)
    dpcan[(0, 0, 0)] = 1
    for i in range(n):
        dpcan[(i + 1)] |= dpcan[i]
        if (s[i] == 0):
            dpcan[((i + 1), 1:, :(- 1))] |= dpcan[(i, :(- 1), 1:)]
        else:
            dpcan[((i + 1), :(- 1), 1:)] |= dpcan[(i, 1:, :(- 1))]
        if (i < (n - 1)):
            if ((s[i] == 0) or (s[(i + 1)] == 0)):
                dpcan[((i + 2), 1:, :)] |= dpcan[(i, :(- 1), :)]
            if ((s[i] == 1) or (s[(i + 1)] == 1)):
                dpcan[((i + 2), :, 1:)] |= dpcan[(i, :, :(- 1))]
    dpcan[(1:, 0, 0)] = 0
    ans = 0
    for i in range(n, (- 1), (- 1)):
        for j in range((size + 1)):
            for k in range((size + 1)):
                if (dpcan[(i, j, k)] == 0):
                    continue
                ans = ((ans + dpcnt[(i, j, k)]) % mod)
                (a, b) = (j, k)
                for h in range((i - 1), (- 1), (- 1)):
                    if (s[h] == 0):
                        a -= 1
                    else:
                        b -= 1
                    if ((a < 0) or (b < 0)):
                        break
                    dpcan[(h, a, b)] = 0
    return ans

s = np.array([int(c) for c in input()], dtype=np.int8)
print(solve(s))



