# File changed

import sys

def find_permutation(aaa, use):
    '\n    iの残り使用数がaaa[i-1]の状態で\n    集合useにある文字群(1～k)を後ろに繋げる方法で\n    それよりさらに後が破綻しないような繋げ方のうち\n    辞書順最小のものを求める。\n\n    ただし（この関数からは見えないが）現在確定済み配列の\n    末尾 (k - |use|) 個は、useに含まれない要素が1回ずつ登場することを前提とする。\n    （つまり、この関数の結果を繋げると、末尾 k 個が順列になる）\n\n    どうやっても破綻する場合はNoneを返す。\n\n    :param aaa:\n    :param use:\n    :return:\n    '
    maxa = (- 1)
    mina = 1005
    maxfixed = (- 1)
    for i in range(k):
        a = aaa[i]
        if ((i + 1) in use):
            mina = min(mina, a)
            maxa = max(maxa, a)
        else:
            maxfixed = max(maxfixed, a)
    if (max(maxa, (maxfixed + 1)) > (2 * mina)):
        return None
    if (maxa < (2 * mina)):
        return sorted(use)
    front = []
    rear = []
    either = []
    for i in use:
        if (aaa[(i - 1)] == maxa):
            front.append(i)
        elif (aaa[(i - 1)] == mina):
            rear.append(i)
        else:
            either.append(i)
    maxfront = front[(- 1)]
    for i in either:
        if (i < maxfront):
            front.append(i)
        else:
            rear.append(i)
    front.sort()
    rear.sort()
    front.extend(rear)
    return front

def solve(k, aaa):
    if (k == 1):
        return ([1] * aaa[0])
    mina = min(aaa)
    maxa = max(aaa)
    if ((mina * 2) < maxa):
        return [(- 1)]
    ans = []
    ans.extend(find_permutation(aaa, set(range(1, (k + 1)))))
    for i in range(k):
        aaa[i] -= 1
    remaining = sum(aaa)
    while remaining:
        use = set(range(1, (k + 1)))
        candidates = []
        for r in range(k):
            result = find_permutation(aaa, use)
            if (result is not None):
                candidates.append(result)
            use.remove(ans[((- r) - 1)])
        adopted = min(candidates)
        ans.extend(adopted)
        for i in adopted:
            aaa[(i - 1)] -= 1
        remaining -= len(adopted)
    return ans
(k, *aaa) = map(int, sys.stdin.buffer.read().split())
print(*solve(k, aaa))

