from collections import deque
import sys


@pytest.fixture
def H():
    return 5

@pytest.fixture
def W():
    return 5

@pytest.fixture
def K():
    return 2

@pytest.fixture
def xs():
    return 0

@pytest.fixture
def ys():
    return 0

@pytest.fixture
def xg():
    return 4

@pytest.fixture
def yg():
    return 4

@pytest.fixture
def m():
    return [
        ['@', '@', '@', '@', '@'],
        ['@', '@', '@', '@', '@'],
        ['@', '@', '@', '@', '@'],
        ['@', '@', '@', '@', '@'],
        ['@', '@', '@', '@', '@'],
    ]

@pytest.fixture
def M():
    return [
        [-1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1],
    ]

def bfs(M, sy, sx):
    queue = deque([[xs, ys]])
    M[sy][sx] = 0
    while queue:
        # queueには訪れた地点が入っている。そこから、4方向に移動できるか考え、queueから消す。
        x1, y1 = queue.popleft()  # queueに入っていたものを消す。
        if [x1, y1] == [xg, yg]:  # もしゴールについていたならば、そのときの手数を出す。
            return M[x1][y1]
        
        for dx, dy in ([1, 0], [-1, 0], [0, 1], [0, -1]):
            for k in range(1, K + 1):
                new_x = x1 + dx * k
                new_y = y1 + dy * k

                if (0 <= new_x < H) and (0 <= new_y < W):
                    if m[new_x][new_y] == "@":
                        break
                    elif M[new_x][new_y] == -1:  # まだ来たことない点だったという条件
                        M[new_x][new_y] = M[x1][y1] + 1
                        queue.append([new_x, new_y])  # 新しい点を足す。
                    elif M[new_x][new_y] < M[x1][y1] + 1:
                        break
                else:
                    break


def test_bfs(H, W, K, xs, ys, xg, yg, m, M):
    bfs(M, xs, ys)
    assert M[xg][yg] == 2

