from numba import njit
import numpy as np

@njit('i8(i8, i8, i8)', cache=True)
def mod_pow(x, a, mod):
    ret = 1
    cur = x
    while a:
        if (a & 1):
            ret = ((ret * cur) % mod)
        cur = ((cur * cur) % mod)
        a >>= 1
    return ret

@njit('UniTuple(i8[:], 2)(i8, i8)', cache=True)
def prepare(n, mod):
    factorials = np.ones((n + 1), dtype=np.int64)
    for i in range(2, (n + 1)):
        factorials[i] = ((factorials[(i - 1)] * i) % mod)
    finvs = np.ones((n + 1), dtype=np.int64)
    finvs[n] = mod_pow(factorials[n], (mod - 2), mod)
    for i in range(n, 1, (- 1)):
        finvs[(i - 1)] = ((finvs[i] * i) % mod)
    return (factorials, finvs)

@njit('i8(i8, i8)', cache=True)
def solve(n, a):
    mod = ((10 ** 9) + 7)
    (facts, finvs) = prepare(n, mod)
    invs = [((facts[(i - 1)] * finvs[i]) % mod) for i in range((n + 1))]
    r = (n - a)
    ans = 0
    for l in range(a):
        tmp1 = ((((facts[a] * finvs[l]) % mod) * finvs[(a - l)]) % mod)
        tmp2 = ((facts[((n - l) - 1)] * (a - l)) % mod)
        ans = ((ans + ((((- 1) ** (l & 1)) * tmp1) * tmp2)) % mod)
    for k in range(1, a):
        for l in range(k):
            tmp1 = ((((facts[k] * finvs[l]) % mod) * finvs[(k - l)]) % mod)
            tmp2 = ((((facts[((n - l) - 1)] * (k - l)) % mod) * invs[((r + k) - l)]) % mod)
            ans = ((ans + ((((- 1) ** (l & 1)) * tmp1) * tmp2)) % mod)
    return ans
(n, a) = map(int, input().split())
print(solve(n, a))



