# File changed


def productall(a):
    'Calculates the product of all elements in the array

    Args:
        a (list): The array of elements to calculate the product of.

    Returns:
        list: The product of all elements in the array.
    '
    N = len(a)
    if (N == 0):
        return [1]
    A = (([1] * N) + a[:])
    P = ((10 ** 9) + 7)
    k = 100
    K = (k * 8)
    pa1 = ((1 << ((k * 4) + 16)) - ((1 << ((k * 4) + 16)) % P))
    pa2 = ((1 << ((k * 2) + 24)) - ((1 << ((k * 2) + 24)) % P))
    pa3 = ((1 << (k + 28)) - ((1 << (k + 28)) % P))

    def modP(x):
        'Modifies the value of x to be within the range of the modulus

        Args:
            x (int): The value to modify.

        Returns:
            int: The modified value of x.
        '
        x -= (((x & m1) >> ((k * 4) + 16)) * pa1)
        x -= (((x & m2) >> ((k * 2) + 24)) * pa2)
        x -= (((x & m3) >> (k + 28)) * pa3)
        return x
    for i in range(N)[::(- 1)]:
        if ((i == (N - 1)) or (i and ((1 << (i.bit_length() - 1)) == i))):
            if (i == (N - 1)):
                c = 2
            else:
                c *= 2
            m1 = int(((('1' * ((k * 4) - 16)) + ('0' * ((k * 4) + 16))) * c), 2)
            m2 = int(((('1' * ((k * 6) - 24)) + ('0' * ((k * 2) + 24))) * c), 2)
            m3 = int(((('1' * ((k * 7) - 28)) + ('0' * (k + 28))) * c), 2)
        A[i] = modP((A[(2 * i)] * A[((2 * i) + 1)]))
    t = (bin(A[1])[2:] + '_')
    return [(int(t[(((- (i + 1)) * K) - 1):(((- i) * K) - 1)], 2) % P) for i in range((((len(t) + K) - 2) // K))]

def par(a):
    'Finds the parent of the given element

    Args:
        a (int): The element to find the parent of.

    Returns:
        int: The parent of the given element.
    '
    L = []
    while (P[a] != a):
        L.append(a)
        a = P[a]
    for l in L:
        P[l] = a
    return a

def unite(a, b):
    'Unites the two given elements

    Args:
        a (int): The first element to unite.
        b (int): The second element to unite.
    '
    pa = par(a)
    pb = par(b)
    if (pa == pb):
        return
    if (LEN[pa] < LEN[pb]):
        (a, b, pa, pb) = (b, a, pb, pa)
    P[pb] = pa
    if (LEN[pa] == LEN[pb]):
        LEN[pa] += 1
    CNT[pa] += CNT[pb]

def cnt(a):
    'Counts the number of elements in the given element

    Args:
        a (int): The element to count the number of elements in.

    Returns:
        int: The number of elements in the given element.
    '
    return CNT[par(a)]
N = int(input())
P = [i for i in range(N)]
LEN = ([1] * N)
CNT = ([1] * N)
FULL = ([0] * N)
A = [(int(a) - 1) for a in input().split()]
for (i, a) in enumerate(A):
    if (a < 0):
        continue
    if (par(i) != par(a)):
        unite(i, a)
    else:
        FULL[i] = 1
for i in range(N):
    if FULL[i]:
        FULL[par(i)] = 1
X = []
Y = []
for i in range(N):
    if (par(i) == i):
        if (FULL[i] == 0):
            X.append(CNT[i])
        else:
            Y.append(CNT[i])
M = len(X)
mod = ((10 ** 9) + 7)
ans = ((((sum(X) + sum(Y)) - len(