# File changed

import sys
import numpy as np
from numba import njit
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

@njit('(i8,i4[::1])', cache=True)
def solve(dep, T):
    'Solves the problem

    Args:
        dep (int): The number of days to solve for.
        T (np.array): The array of 0s and 1s representing the days.

    Returns:
        np.array: The array of solutions.
    '
    if (dep == 0):
        return np.array([0], np.int32)
    A = np.empty((3 ** dep), np.int32)
    for d in range(3):
        TT = np.empty_like(T)
        p = 0
        x = d
        for t in T:
            if (t == 0):
                x = ((3 - x) if x else 0)
                if ((p > 0) and (TT[(p - 1)] == 0)):
                    p -= 1
                else:
                    TT[p] = 0
                    p += 1
            else:
                x = (x + 1)
                if (x == 3):
                    x = 0
                    TT[p] = 1
                    p += 1
        TT = TT[:p]
        A[d::3] = ((3 * solve((dep - 1), TT)) + x)
    return A
N = int(readline())
T = np.frombuffer(read().rstrip(), 'S1')
T = ((T == b'R') * 1).astype(np.int32)
ans = solve(N, T)
print(' '.join(ans.astype(str)))


