#!usr/bin/env pypy3
from collections import defaultdict, deque
from heapq import heappush, heappop
from itertools import permutations, accumulate
import sys
import math
import bisect


def LI(): return [int(x) for x in sys.stdin.readline().split()]


def I(): return int(sys.stdin.readline())


def LS(): return [list(x) for x in sys.stdin.readline().split()]


def S():
    res = list(sys.stdin.readline())
    if res[-1] == "\n":
        return res[:-1]
    return res


def IR(n):
    return [I() for i in range(n)]


def LIR(n):
    return [LI() for i in range(n)]


def SR(n):
    return [S() for i in range(n)]


def LSR(n):
    return [LS() for i in range(n)]


sys.setrecursionlimit(1000000)


@pytest.mark.parametrize("N, X, Y", [
    (5, 1, 4),
    (10, 1, 9),
    (10, 1, 8),
    (10, 1, 7),
    (10, 1, 6),
    (10, 1, 5),
    (10, 1, 4),
    (10, 1, 3),
    (10, 1, 2),
    (10, 1, 1),
    (10, 2, 9),
    (10, 2, 8),
    (10, 2, 7),
    (10, 2, 6),
    (10, 2, 5),
    (10, 2, 4),
    (10, 2, 3),
    (10, 2, 2),
    (10, 2, 1),
    (10, 3, 9),
    (10, 3, 8),
    (10, 3, 7),
    (10, 3, 6),
    (10, 3, 5),
    (10, 3, 4),
    (10, 3, 3),
    (10, 3, 2),
    (10, 3, 1),
    (10, 4, 9),
    (10, 4, 8),
    (10, 4, 7),
    (10, 4, 6),
    (10, 4, 5),
    (10, 4, 4),
    (10, 4, 3),
    (10, 4, 2),
    (10, 4, 1),
    (10, 5, 9),
    (10, 5, 8),
    (10, 5, 7),
    (10, 5, 6),
    (10, 5, 5),
    (10, 5, 4),
    (10, 5, 3),
    (10, 5, 2),
    (10, 5, 1),
    (10, 6, 9),
    (10, 6, 8),
    (10, 6, 7),
    (10, 6, 6),
    (10, 6, 5),
    (10, 6, 4),
    (10, 6, 3),
    (10, 6, 2),
    (10, 6, 1),
    (10, 7, 9),
    (10, 7, 8),
    (10, 7, 7),
    (10, 7, 6),
    (10, 7, 5),
    (10, 7, 4),
    (10, 7, 3),
    (10, 7, 2),
    (10, 7, 1),
    (10, 8, 9),
    (10, 8, 8),
    (10, 8, 7),
    (10, 8, 6),
    (10, 8, 5),
    (10, 8, 4),
    (10, 8, 3),
    (10, 8, 2),
    (10, 8, 1),
    (10, 9, 9),
    (10, 9, 8),
    (10, 9, 7),
    (10, 9, 6),
    (10, 9, 5),
    (10, 9, 4),
    (10, 9, 3),
    (10, 9, 2),
    (10, 9, 1),
])
def test_main(N, X, Y):
    X -= 1
    Y -= 1
    dist = [[N] * N for _ in range(N)]

    q = deque()
    for i in range(N):
        q.append(i)
        dist[i][i] = 0
        while q:
            u = q.popleft()
            t = dist[i][u]