# File changed


class UnionFind():

    def __init__(self, n):
        self.n = n
        self.parents = ([(- 1)] * n)

    def find(self, x):
        if (self.parents[x] < 0):
            return x
        else:
            self.parents[x] = self.find(self.parents[x])
            return self.parents[x]

    def union(self, x, y):
        x = self.find(x)
        y = self.find(y)
        if (x == y):
            return
        if (self.parents[x] > self.parents[y]):
            (x, y) = (y, x)
        self.parents[x] += self.parents[y]
        self.parents[y] = x

    def size(self, x):
        return (- self.parents[self.find(x)])

    def same(self, x, y):
        return (self.find(x) == self.find(y))
import sys
input = sys.stdin.readline
(N, M, K) = map(int, input().split())
uf = UnionFind(N)
lst = ([0] * N)
ans = ([0] * N)
for i in range(M):
    (A, B) = map(int, input().split())
    uf.union((A - 1), (B - 1))
    lst[(A - 1)] += 1
    lst[(B - 1)] += 1
for i in range(K):
    (A, B) = map(int, input().split())
    if uf.same((A - 1), (B - 1)):
        lst[(A - 1)] += 1
        lst[(B - 1)] += 1
for i in range(N):
    ans[i] = ((uf.size(i) - lst[i]) - 1)
L = [str(a) for a in ans]
L = ' '.join(L)
print(L)


