' Calculates the number of ways to get from one point to another
'
# File changed


def modpow(a, n, p):
    'Calculates a^n mod p

    Args:
        a (int): The base.
        n (int): The exponent.
        p (int): The modulus.

    Returns:
        int: The result of a^n mod p.
    '
    if (n == 0):
        return 0
    elif (n == 1):
        return (a % p)
    elif (n % 2):
        return ((a * modpow(a, (n - 1), p)) % p)
    else:
        t = modpow(a, (n // 2), p)
        return ((t * t) % p)

def calc(n, r):
    'Calculates the number of ways to get from one point to another

    Args:
        n (int): The number of points.
        r (int): The number of points to get to.

    Returns:
        int: The number of ways to get from one point to another.
    '
    (p, q) = (1, 1)
    for i in range(r):
        p = ((p * (n - i)) % MOD)
        q = ((q * (i + 1)) % MOD)
    return ((p * modpow(q, (MOD - 2), MOD)) % MOD)
MOD = ((10 ** 9) + 7)
(N, a, b) = map(int, input().split())
s = (modpow(2, N, MOD) - 1)
print(((s - (calc(N, a) + calc(N, b))) % MOD))


