# File changed

import sys
sys.setrecursionlimit(300000)
mod = 1000000007

def get_fraction_mod(numerator, denominator):
    '\n        returns numerator / denominator (mod MOD)\n    '
    inv = pow(denominator, (mod - 2), mod)
    return ((numerator * inv) % mod)

def make_comb(n, k):
    k = min(k, (n - k))
    a = 1
    b = 1
    for i in range(k):
        a = ((a * (n - i)) % mod)
        b = ((b * (i + 1)) % mod)
    ret = get_fraction_mod(a, b)
    return ret

def make_facts(n):
    '\n        make factorials\n        0!(=1), 1!, 2!, 3! .... n!\n    '
    fact = [1]
    for i in range(n):
        fact.append(((fact[i] * (i + 1)) % mod))
    return fact

def make_combs(n, k):
    '\n        make [C(n, 0), C(n, 1), C(n, 2) ..... C(n, k)]\n        n! / (n - k)! k!\n    '
    facts = make_facts(n)
    invs = []
    for fact in facts:
        invs.append(pow(fact, (mod - 2), mod))
    ret = []
    for i in range(0, (n + 1)):
        a = facts[n]
        ret.append((((a * invs[i]) * invs[(n - i)]) % mod))
    return ret

def _solve(n):
    dp = ([0] * (n + 1))

def solve(n: int, k: int):
    ret = make_comb(((n * 2) - 1), n)
    if (k < (n - 1)):
        combs = make_combs((n - 1), (n - 1))
        ncombs = make_combs(n, n)
        for i in range((k + 1), n):
            tmp = ncombs[i]
            t = combs[((n - i) - 1)]
            ret -= (tmp * t)
            ret %= mod
    print(ret)
    return

def main():

    def iterate_tokens():
        for line in sys.stdin:
            for word in line.split():
                (yield word)
    tokens = iterate_tokens()
    n = int(next(tokens))
    k = int(next(tokens))
    solve(n, k)
if (__name__ == '__main__'):
    main()

