# File changed

import sys
sys.setrecursionlimit(300000)
MOD = 1000000007

def get_fraction_mod(numerator, denominator):
    'Calculates the fraction modulus

    Args:
        numerator (int): The numerator of the fraction.
        denominator (int): The denominator of the fraction.

    Returns:
        int: The fraction modulus.
    '
    inv = pow(denominator, (MOD - 2), MOD)
    return ((numerator * inv) % MOD)

def make_comb(n, k):
    'Calculates the combination of n and k

    Args:
        n (int): The number of items.
        k (int): The number of items to choose.

    Returns:
        int: The combination of n and k.
    '
    k = min(k, (n - k))
    a = 1
    b = 1
    for i in range(k):
        a = ((a * (n - i)) % MOD)
        b = ((b * (i + 1)) % MOD)
    ret = get_fraction_mod(a, b)
    return ret

def make_facts(n):
    'Calculates the factorials of n

    Args:
        n (int): The number of items.

    Returns:
        list: The factorials of n.
    '
    fact = [1]
    for i in range(n):
        fact.append(((fact[i] * (i + 1)) % MOD))
    return fact

def make_combs(n, k):
    'Calculates the combinations of n and k

    Args:
        n (int): The number of items.
        k (int): The number of items to choose.

    Returns:
        list: The combinations of n and k.
    '
    facts = make_facts(n)
    invs = []
    for fact in facts:
        invs.append(pow(fact, (MOD - 2), MOD))
    ret = []
    for i in range(0, (n + 1)):
        a = facts[n]
        ret.append((((a * invs[i]) * invs[(n - i)]) % MOD))
    return ret

def _solve(n):
    'Solves the problem

    Args:
        n (int): The number of items.

    Returns:
        int: The solution.
    '
    dp = ([0] * (n + 1))

def solve(n: int, k: int):
    'Solves the problem

    Args:
        n (int): The number of items.
        k (int): The number of items to choose.

    Returns:
        int: The solution.
    '
    ret = make_comb(((n * 2) - 1), n)
    if (k < (n - 1)):
        combs = make_combs((n - 1), (n - 1))
        n_combs = make_combs(n, n)
        for i in range((k + 1), n):
            tmp = n_combs[i]
            t = combs[((n - i) - 1)]
            ret -= (tmp * t)
            ret