

def numba_compile(numba_config):
    import os, sys
    if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
        from numba import njit
        from numba.pycc import CC
        cc = CC('my_module')
        for (func, signature) in numba_config:
            vars()[func.__name__] = njit(signature)(func)
            cc.export(func.__name__, signature)(func)
        cc.compile()
        exit()
    elif (os.name == 'posix'):
        exec(f"from my_module import {','.join((func.__name__ for (func, _) in numba_config))}")
        for (func, _) in numba_config:
            globals()[func.__name__] = vars()[func.__name__]
    else:
        from numba import njit
        for (func, signature) in numba_config:
            globals()[func.__name__] = njit(signature, cache=True)(func)
        print('compiled!', file=sys.stderr)
import sys
import numpy as np

def solve(K, Q, D, NXM):
    Ans = np.empty(Q, dtype=np.int64)
    for q in range(Q):
        (n, x, m) = NXM[q]
        D_mod = (D % m)
        cnt_D0 = (D_mod == 0).sum()
        sum_D = D_mod.sum()
        (t, rem) = divmod((n - 1), K)
        ans = (n - 1)
        ans -= (t * cnt_D0)
        progress = (sum_D * t)
        x1 = ((x % m) + progress)
        for i in range(rem):
            d = D_mod[i]
            if (d == 0):
                ans -= 1
            x1 += d
        ans -= (x1 // m)
        Ans[q] = ans
    return Ans
numba_compile([[solve, 'i8[:](i8,i8,i8[:],i8[:,:])']])

def main():
    (K, Q) = map(int, input().split())
    D = np.array(input().split(), dtype=np.int64)
    NXM = np.array(sys.stdin.read().split(), dtype=np.int64).reshape(Q, 3)
    Ans = solve(K, Q, D, NXM)
    print('\n'.join(map(str, Ans.tolist())))
main()
