import itertools
import math

@pytest.fixture
def n():
    return int(input())

@pytest.fixture
def points(n):
    points = []
    for i in range(n):
        points.append(list(map(int, input().split())))
    return points

@pytest.fixture
def r_min():
    return 1000000

@pytest.mark.asyncio
async def test_get_circle_center_and_radius_two(points):
    x1, y1, x2, y2 = points[0][0], points[0][1], points[1][0], points[1][1]
    x, y, r = get_circle_center_and_radius_two(x1, y1, x2, y2)
    assert (x == 0)
    assert (y == 0)
    assert (r == 0)

@pytest.mark.asyncio
async def test_get_circle_center_and_radius(points):
    x1, y1, x2, y2, x3, y3 = points[0][0], points[0][1], points[1][0], points[1][1], points[2][0], points[2][1]
    x, y, r = get_circle_center_and_radius(x1, y1, x2, y2, x3, y3)
    assert (x == 0)
    assert (y == 0)
    assert (r == 0)

@pytest.mark.asyncio
async def test_check_if_all_included(points):
    x, y, r = 0, 0, 0
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (2, 2)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (2, 2), (3, 3)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (2, 2), (3, 3), (4, 4)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (2, 2), (3, 3), (4, 4), (5, 5)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7), (8, 8)]) == True)
    assert (check_if_all_included(x, y, r, points, [(0, 0), (1, 1), (