# File changed

import itertools
import math

def get_circle_center_and_radius(x1, y1, x2, y2, x3, y3):
    'Calculates the center and radius of a circle given three points

    Args:
        x1 (int): The x coordinate of the first point.
        y1 (int): The y coordinate of the first point.
        x2 (int): The x coordinate of the second point.
        y2 (int): The y coordinate of the second point.
        x3 (int): The x coordinate of the third point.
        y3 (int): The y coordinate of the third point.

    Returns:
        tuple: A tuple containing the x, y, and radius of the circle.
    '
    d = (2 * (((y1 - y3) * (x1 - x2)) - ((y1 - y2) * (x1 - x3))))
    if (d == 0):
        return (0, 0, 0)
    x = ((((y1 - y3) * ((((y1 ** 2) - (y2 ** 2)) + (x1 ** 2)) - (x2 ** 2))) - ((y1 - y2) * ((((y1 ** 2) - (y3 ** 2)) + (x1 ** 2)) - (x3 ** 2)))) / d)
    y = ((((x1 - x3) * ((((x1 ** 2) - (x2 ** 2)) + (y1 ** 2)) - (y2 ** 2))) - ((x1 - x2) * ((((x1 ** 2) - (x3 ** 2)) + (y1 ** 2)) - (y3 ** 2)))) / (- d))
    r = (((x - x1) ** 2) + ((y - y1) ** 2))
    return (x, y, r)

def get_circle_center_and_radius_two(x1, y1, x2, y2):
    'Calculates the center and radius of a circle given two points

    Args:
        x1 (int): The x coordinate of the first point.
        y1 (int): The y coordinate of the first point.
        x2 (int): The x coordinate of the second point.
        y2 (int): The y coordinate of the second point.

    Returns:
        tuple: A tuple containing the x, y, and radius of the circle.
    '
    x = ((x1 + x2) / 2)
    y = ((y1 + y2) / 2)
    r = (((x - x1) ** 2) + ((y - y1) ** 2))
    return (x, y, r)

def check_if_all_included(x, y, r, points, v):
    'Checks if all points are included in the circle

    Args:
        x (int): The x coordinate of the circle center.
        y (int): The y coordinate of the circle center.
        r (int): The radius of the circle.
        points (list): A list of points.
        v (list): A list of points.

    Returns:
        bool: True if all points are included in the circle, False otherwise.
    '
    for point in points:
        if (point in v):
            continue
        dist = (((x -