# File changed


def main():
    'Finds the number of ways to choose M elements from a set of N elements

    Args:
        N (int): The number of elements in the set.
        M (int): The number of elements to choose from the set.
        a (list): The list of elements to choose from.

    Returns:
        int: The number of ways to choose M elements from a set of N elements.
    '
    (N, M) = map(int, input().split())
    (*a,) = map(int, input().split())
    a.sort()

    def count(mid) -> int:
        'Counts the number of ways to choose M elements from a set of N elements

        Args:
            mid (int): The middle value to check.

        Returns:
            int: The number of ways to choose M elements from a set of N elements.
        '
        cnt = 0
        j = N
        for i in range(N):
            while ((j > 0) and ((a[i] + a[(j - 1)]) >= mid)):
                j -= 1
            cnt += (N - j)
        return cnt

    def binary_search(*, ok: int, ng: int, is_ok: 'function') -> int:
        'Performs a binary search

        Args:
            ok (int): The upper bound of the search.
            ng (int): The lower bound of the search.
            is_ok (function): The function to check if the value is ok.

        Returns:
            int: The value found by the binary search.
        '
        while (abs((ok - ng)) > 1):
            mid = ((ok + ng) // 2)
            if is_ok(mid):
                ok = mid
            else:
                ng = mid
        return ok
    ma = binary_search(ok=((2 * (10 ** 5)) + 1), ng=0, is_ok=(lambda mid: (count(mid) < M)))

    def accumulate(a):
        'Accumulates the values in a list

        Args:
            a (list): The list to accumulate.

        Yields:
            int: The accumulated values.
        '
        s = 0
        (yield s)
        for x in a:
            s += x
            (yield s)
    (*acc,) = accumulate(a)
    ans = 0
    j = N
    for i in range(N):
        while ((j > 0) and ((a[i] + a[(j - 1)]) >= ma)):
            j -= 1
        ans += (((a[i] * (N - j)) + acc[N]) - acc[j])
    ans += ((ma - 1) * (M - count(ma)))
    print(ans)
if (__name__ == '__main__'):
    main()


