import pytest

@pytest.mark.parametrize('N, L, expected', [
    (1, [1], 0),
    (2, [1, 2], 2),
    (3, [1, 2, 3], 14),
    (4, [1, 2, 3, 4], 40),
    (5, [1, 2, 3, 4, 5], 95),
    (6, [1, 2, 3, 4, 5, 6], 180),
    (7, [1, 2, 3, 4, 5, 6, 7], 329),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 550),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 819),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 1149),
])
def test_sum_of_products(N, L, expected):
    sum = 0
    for x in range(N):
        for y in range(x+1, N):
            sum += L[x]*L[y]
    assert sum == expected

