from scipy.sparse.csgraph import floyd_warshall
import sys
input = sys.stdin.readline

N, M, L = map(int, input().split())
INF = float('inf')
graph = [[INF] * N for _ in range(N)]

for i in range(N):
    graph[i][i] = 0

for _ in range(M):
    A, B, C = map(int, input().split())
    A, B = A - 1, B - 1
    if C <= L:
        graph[A][B] = C
        graph[B][A] = C

distance = floyd_warshall(graph, directed=False)

graph = [[INF] * N for _ in range(N)]
for i in range(N):
    for j in range(N):
        if distance[i][j] <= L:
            graph[i][j] = 1

supply = floyd_warshall(graph, directed=False)


Q = int(input())
for _ in range(Q):
    s, t = map(int, input().split())
    if distance[s - 1][t - 1] == INF:
        print(-1)
    else:
        print(int(supply[s - 1][t - 1]) - 1)

