def make_divisors(n):

    divisors = []
    for i in range(1, int(n**0.5)+1):
        if n % i == 0:
            divisors.append(i)
            if i != n // i:
                divisors.append(n//i)
    divisors.sort()

    return divisors

def is_remainder(n):
    if n == 1:
        return True

    for i in range(2, int(n**0.5)+1):
        if n % i == 0:
            return False
    
    return True

def test_make_divisors():
    assert make_divisors(1) == [1]
    assert make_divisors(2) == [1, 2]
    assert make_divisors(3) == [1, 3]
    assert make_divisors(4) == [1, 2, 4]
    assert make_divisors(5) == [1, 5]
    assert make_divisors(6) == [1, 2, 3, 6]
    assert make_divisors(7) == [1, 7]
    assert make_divisors(8) == [1, 2, 4, 8]
    assert make_divisors(9) == [1, 3, 9]
    assert make_divisors(10) == [1, 2, 5, 10]

def test_is_remainder():
    assert is_remainder(1) == True
    assert is_remainder(2) == False
    assert is_remainder(3) == True
    assert is_remainder(4) == False
    assert is_remainder(5) == True
    assert is_remainder(6) == False
    assert is_remainder(7) == True
    assert is_remainder(8) == False
    assert is_remainder(9) == True
    assert is_remainder(10) == False

A, B = [int(i) for i in input().split()]

import fractions
n = fractions.gcd(A, B)
divisors = make_divisors(n)
N = len(divisors)

count = 0
flag = [0] * N
for item in divisors:
    if is_remainder(item):
        count += 1

print(count)

