' Bit class
'
class Bit():

    def __init__(self, n):
        ' Initializes the Bit class

        Args:
            n (int): The size of the bit array.
        '
        self.size = n
        self.tree = ([0] * (n + 1))

    def sum(self, i):
        ' Sums the values in the bit array

        Args:
            i (int): The index to sum from.

        Returns:
            int: The sum of the values in the bit array.
        '
        s = 0
        while (i > 0):
            s += self.tree[i]
            i -= (i & (- i))
        return s

    def add(self, i, x):
        ' Adds a value to the bit array

        Args:
            i (int): The index to add to.
            x (int): The value to add.
        '
        while (i <= self.size):
            self.tree[i] += x
            i += (i & (- i))

def inv(X):
    ' Inverts the values in the array

    Args:
        X (list): The array to invert.

    Returns:
        int: The inverted array.
    '
    B = Bit((2000 + 1))
    inv = 0
    for i in range(len(X)):
        inv += (i - B.sum(X[i]))
        B.add(X[i], 1)
    return inv

(N, K) = map(int, input().split())
A = list(map(int, input().split()))
MOD = ((10 ** 9) + 7)
A_inv = (inv(A) % MOD)
A2_inv = (inv((A * 2)) % MOD)
print((((K * A_inv) + (((K * (K - 1)) // 2) * (A2_inv - (2 * A_inv)))) % MOD))


