import pytest

@pytest.mark.parametrize("N, H, expected", [
    (1, [1], "Yes"),
    (2, [1, 2], "Yes"),
    (2, [2, 1], "No"),
    (3, [1, 2, 3], "Yes"),
    (3, [1, 3, 2], "No"),
    (3, [2, 1, 3], "No"),
    (3, [2, 3, 1], "No"),
    (3, [3, 1, 2], "No"),
    (3, [3, 2, 1], "No"),
    (4, [1, 2, 3, 4], "Yes"),
    (4, [1, 2, 4, 3], "Yes"),
    (4, [1, 3, 2, 4], "No"),
    (4, [1, 3, 4, 2], "No"),
    (4, [1, 4, 2, 3], "No"),
    (4, [1, 4, 3, 2], "No"),
    (4, [2, 1, 3, 4], "Yes"),
    (4, [2, 1, 4, 3], "Yes"),
    (4, [2, 3, 1, 4], "No"),
    (4, [2, 3, 4, 1], "No"),
    (4, [2, 4, 1, 3], "No"),
    (4, [2, 4, 3, 1], "No"),
    (4, [3, 1, 2, 4], "No"),
    (4, [3, 1, 4, 2], "No"),
    (4, [3, 2, 1, 4], "No"),
    (4, [3, 2, 4, 1], "No"),
    (4, [3, 4, 1, 2], "No"),
    (4, [3, 4, 2, 1], "No"),
    (4, [4, 1, 2, 3], "No"),
    (4, [4, 1, 3, 2], "No"),
    (4, [4, 2, 1, 3], "No"),
    (4, [4, 2, 3, 1], "No"),
    (4, [4, 3, 1, 2], "No"),
    (4, [4, 3, 2, 1], "No"),
])
def test_that_the_output_is_correct(N, H, expected):
    flag = "Yes"
    for i in range(N-1,0,-1):
      if H[i-1] - H[i] > 1:
        flag = "No"
        break;
      elif H[i-1] - H[i] == 1:
        H[i-1] -= 1
    for i in range(N-1):
      if H[i] - H[i+1] > 0:
        flag = "No"
        break;    
    assert flag == expected

