# File changed

import os
import sys
import numpy as np
if os.getenv('LOCAL'):
    sys.stdin = open('_in.txt', 'r')
sys.setrecursionlimit(2147483647)
inf = float('inf')
iinf = (10 ** 18)
MOD = 998244353
(N, m) = list(map(int, sys.stdin.readline().split()))

def get_factorials(max, mod=None):
    '\n    階乗 0!, 1!, 2!, ..., max!\n    :param int max:\n    :param int mod:\n    :return:\n    '
    ret = np.ones((max + 1), dtype=int)
    n = 1
    for i in range(1, (max + 1)):
        n *= i
        n %= mod
        ret[i] = n
    return ret

def mod_invs(max, mod):
    '\n    逆元のリスト 0 から max まで\n    :param max:\n    :param mod:\n    :return:\n    '
    invs = ([1] * (max + 1))
    for x in range(2, (max + 1)):
        invs[x] = (((- (mod // x)) * invs[(mod % x)]) % mod)
    return invs
factorials = get_factorials((((m * 3) // 2) + N), MOD)
finvs = np.ones(((((m * 3) // 2) + N) + 1), dtype=int)
p = 1
for (i, inv) in enumerate(mod_invs((((m * 3) // 2) + N), MOD)):
    p = ((p * inv) % MOD)
    finvs[i] = p

def ncr(n, r, mod=None):
    '\n    scipy.misc.comb または scipy.special.comb と同じ\n    組み合わせの数 nCr\n    '
    ret = ((((factorials[n] * finvs[r]) % MOD) * finvs[(n - r)]) % mod)
    ret[(n < r)] = 0
    return ret
odds = np.arange((m % 2), (m + 1), 2)
halves1 = (((m * 3) - odds) // 2)
c1 = ((ncr(((halves1 + N) - 1), (N - 1), MOD) * ncr(N, odds, MOD)) % MOD)
halves2 = ((m - odds) // 2)
c2a = ((ncr(((halves2 + N) - 1), (N - 1), MOD) * ncr(N, odds, MOD)) % MOD)
c2b = ((ncr(((halves2 + N) - 2), (N - 2), MOD) * ncr((N - 1), odds, MOD)) % MOD)
c2 = (((c2a - c2b) * N) % MOD)
print(((c1 - c2).sum() % MOD))

