# File changed

import os
import sys
import numpy as np
if os.getenv('LOCAL'):
    sys.stdin = open('_in.txt', 'r')
sys.setrecursionlimit(2147483647)
INF = float('inf')
IINF = (10 ** 18)
MOD = 998244353
(N, M) = list(map(int, sys.stdin.readline().split()))

def get_factorials(max, mod=None):
    'Returns an array of factorials up to max

    Args:
        max (int): The maximum number to calculate the factorial for.
        mod (int, optional): Defaults to None. The modulo to perform the factorials with.

    Returns:
        np.array: An array of factorials up to max.
    '
    ret = np.ones((max + 1), dtype=int)
    n = 1
    for i in range(1, (max + 1)):
        n *= i
        n %= mod
        ret[i] = n
    return ret

def mod_invs(max, mod):
    'Returns an array of modular inverses up to max

    Args:
        max (int): The maximum number to calculate the modular inverse for.
        mod (int): The modulo to perform the modular inverse with.

    Returns:
        np.array: An array of modular inverses up to max.
    '
    invs = ([1] * (max + 1))
    for x in range(2, (max + 1)):
        invs[x] = (((- (mod // x)) * invs[(mod % x)]) % mod)
    return invs
factorials = get_factorials((((M * 3) // 2) + N), MOD)
finvs = np.ones(((((M * 3) // 2) + N) + 1), dtype=int)
p = 1
for (i, inv) in enumerate(mod_invs((((M * 3) // 2) + N), MOD)):
    p = ((p * inv) % MOD)
    finvs[i] = p

def ncr(n, r, mod=None):
    'Returns the number of combinations for n choose r

    Args:
        n (int): The number of items to choose from.
        r (int): The number of items to choose.
        mod (int, optional): Defaults to None. The modulo to perform the combination with.

    Returns:
        int: The number of combinations for n choose r.
    '
    ret = ((((factorials[n] * finvs[r]) % MOD) * finvs[(n - r)]) % mod)
    ret[(n < r)] = 0
    return ret
odds = np.arange((M % 2), (M + 1), 2)
halves1 = (((M * 3) - odds) // 2)
c1 = ((ncr(((halves1 + N) - 1), (N - 