# File changed

r = int(input())
print((3 * (r ** 2)))

"""

import ast
import os
import re
import sys
from pathlib import Path
from typing import List, Tuple

from loguru import logger

from .utils import get_all_files, get_all_files_in_directory, get_all_files_in_directory_with_extension

logger.remove()
logger.add(sys.stderr, level="INFO")


def get_all_files_with_extension(directory: str, extension: str) -> List[str]:
    """
    Returns all files in a directory with a given extension.

    Args:
        directory (str): The directory to search.
        extension (str): The extension to search for.

    Returns:
        List[str]: A list of files with the given extension.
    """
    return [
        file for file in get_all_files_in_directory_with_extension(directory, extension)
    ]


def get_all_python_files(directory: str) -> List[str]:
    """
    Returns all python files in a directory.

    Args:
        directory (str): The directory to search.

    Returns:
        List[str]: A list of python files.
    """
    return get_all_files_with_extension(directory, ".py")


def get_all_python_files_in_directory(directory: str) -> List[str]:
    """
    Returns all python files in a directory.

    Args:
        directory (str): The directory to search.

    Returns:
        List[str]: A list of python files.
    """
    return get_all_files_in_directory(directory)


def get_all_directories(directory: str) -> List[str]:
    """
    Returns all directories in a directory.

    Args:
        directory (str): The directory to search.

    Returns:
        List[str]: A list of directories.
    """
    return [
        file for file in get_all_files_in_directory(directory)
        if os.path.isdir(file)
    ]


def get_all_directories_in_directory(directory: str) -> List[str]:
    """
    Returns all directories in a directory.

    Args:
        directory (str): The directory to search.

    Returns:
        List[str]: A list of directories.
    """
    return [
        file for file in get_all_files_in_directory(directory)
        if os.path.isdir(file)
    ]


def get_all_directories_with_name(directory: str, name: str) -> List[str]:
    """
    Returns all directories in a directory with a given name.

    Args:
        directory (str): The directory to search.
        name (str): The name to search for.

    Returns:
        List[str]: A list of directories with the given name.
    """
    return [
        file for file in get_all_directories(directory)
        if name in file
    ]


def get_all_directories_with_name_in_directory(directory: str, name: str) -> List[str]:
    """
    Returns all directories in a directory with a given name.

    Args:
        directory (str): The directory to search.
        name (str): The name to search for.

    Returns:
        List[str]: A list of directories with the given name.
    """
    return [
        file for file in get_all_directories_in_directory(directory)
        if name in file
    ]


def get_all_directories_with_name_in_directory_with_extension(directory: str, name: str, extension: str) -> List[str]:
    """
    Returns all directories in a directory with a given name and extension.

    Args:
        directory (str): The directory to search.
        name (str): The name to search for.
        extension (str): The extension to search for.

    Returns:
        List[str]: A list of directories with the given name and extension.
    """
    return [
        file for file in get_all_directories_in_directory_with_extension(directory, extension)
        if name in file
    ]


def get_all_directories