import numpy as np


def solve(n, k):
    if k % 2 == 1:
        return 0
    k //= 2

    MOD = 10 ** 9 + 7

    dp = np.zeros((1, k + 1), dtype=np.int64)
    dp[0, 0] = 1
    for i in range(1, n + 1):
        max_d = min(i + 1, n - i + 1, k + 1)
        ndp = np.zeros((max_d, k + 1), dtype=np.int64)
        for d, ks in enumerate(dp):
            base = ks[:k - d + 1]
            if d > 0:
                ndp[d - 1, d:] += base * d ** 2
            if max_d > d:
                ndp[d, d:] += base * (2 * d + 1)
            if max_d > d + 1:
                ndp[d + 1, d:] += base
        dp = ndp % MOD

    return dp[0, k]


def test_solve():
    assert solve(1, 0) == 1
    assert solve(2, 0) == 1
    assert solve(2, 1) == 0
    assert solve(2, 2) == 1
    assert solve(3, 0) == 1
    assert solve(3, 1) == 0
    assert solve(3, 2) == 1
    assert solve(3, 3) == 1
    assert solve(4, 0) == 1
    assert solve(4, 1) == 0
    assert solve(4, 2) == 1
    assert solve(4, 3) == 1
    assert solve(4, 4) == 1
    assert solve(5, 0) == 1
    assert solve(5, 1) == 0
    assert solve(5, 2) == 1
    assert solve(5, 3) == 1
    assert solve(5, 4) == 1
    assert solve(5, 5) == 1
    assert solve(6, 0) == 1
    assert solve(6, 1) == 0
    assert solve(6, 2) == 1
    assert solve(6, 3) == 1
    assert solve(6, 4) == 1
    assert solve(6, 5) == 1
    assert solve(6, 6) == 1
    assert solve(7, 0) == 1
    assert solve(7, 1) == 0
    assert solve(7, 2) == 1
    assert solve(7, 3) == 1
    assert solve(7, 4) == 1
    assert solve(7, 5) == 1
    assert solve(7, 6) == 1
    assert solve(7, 7) == 1
    assert solve(8, 0) == 1
    assert solve(8, 1) == 0
    assert solve(8, 2) == 1
    assert solve(8, 3) == 1
    assert solve(8, 4) == 1
    assert solve(8, 5) == 1
    assert solve(8, 6) == 1
    assert solve(8, 7) == 1
    assert solve(8, 8) ==