import numpy as np


def solve(n, k):
    if k % 2 == 1:
        return 0
    k //= 2

    MOD = 10 ** 9 + 7

    dp = np.zeros((1, k + 1), dtype=np.int64)
    dp[0, 0] = 1
    for i in range(1, n + 1):
        max_d = min(i + 1, n - i + 1, k + 1)
        ndp = np.zeros((max_d, k + 1), dtype=np.int64)
        for d, ks in enumerate(dp):
            base = ks[:k - d + 1]
            if d > 0:
                ndp[d - 1, d:] += base * d ** 2
            if max_d > d:
                ndp[d, d:] += base * (2 * d + 1)
            if max_d > d + 1:
                ndp[d + 1, d:] += base
        dp = ndp % MOD

    return dp[0, k]


@pytest.mark.parametrize('n, k, result', [
    (1, 1, 1),
    (2, 1, 1),
    (2, 2, 2),
    (3, 1, 1),
    (3, 2, 3),
    (3, 3, 6),
    (4, 1, 1),
    (4, 2, 4),
    (4, 3, 10),
    (4, 4, 20),
    (5, 1, 1),
    (5, 2, 5),
    (5, 3, 15),
    (5, 4, 35),
    (5, 5, 70),
    (6, 1, 1),
    (6, 2, 6),
    (6, 3, 21),
    (6, 4, 56),
    (6, 5, 126),
    (6, 6, 252),
    (7, 1, 1),
    (7, 2, 7),
    (7, 3, 28),
    (7, 4, 84),
    (7, 5, 210),
    (7, 6, 462),
    (7, 7, 924),
    (8, 1, 1),
    (8, 2, 8),
    (8, 3, 36),
    (8, 4, 120),
    (8, 5, 330),
    (8, 6, 792),
    (8, 7, 1716),
    (8, 8, 3432),
    (9, 1, 1),
    (9, 2, 9),
    (9, 3, 45),
    (9, 4, 165),
    (9, 5, 441),
    (9, 6, 1140),
    (9, 7, 2520),
    (9, 8, 5544),
    (9, 9, 12035),
    (10, 1, 1),
    (10, 2, 10),
    (10, 3, 55),
    (10, 4, 220),
    (10, 5, 660),
    (10, 6, 1764),
    (10, 7, 