import pytest

@pytest.mark.parametrize('n, pn, expected', [
    (3, [1, 2, 3], 0),
    (4, [1, 2, 3, 4], 1),
    (5, [1, 2, 3, 4, 5], 2),
    (6, [1, 2, 3, 4, 5, 6], 3),
    (7, [1, 2, 3, 4, 5, 6, 7], 4),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 5),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 6),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 7),
])
def test_peaks(n, pn, expected):
    count = 0
    for i in range(1, n - 1):
        if (pn[i] > pn[i - 1] and pn[i] < pn[i + 1]) or (pn[i] < pn[i - 1] and pn[i] > pn[i + 1]):
            count += 1
    assert count == expected

