# File changed


def numba_compile(numba_config):
    import os, sys
    if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
        from numba import njit
        from numba.pycc import CC
        cc = CC('my_module')
        for (func, signature) in numba_config:
            globals()[func.__name__] = njit(signature)(func)
            cc.export(func.__name__, signature)(func)
        cc.compile()
        exit()
    elif (os.name == 'posix'):
        exec(f"from my_module import {','.join((func.__name__ for (func, _) in numba_config))}")
        for (func, _) in numba_config:
            globals()[func.__name__] = vars()[func.__name__]
    else:
        from numba import njit
        for (func, signature) in numba_config:
            globals()[func.__name__] = njit(signature, cache=True)(func)
        print('compiled!', file=sys.stderr)
import numpy as np

def sqrt_case_manager(N):
    'Generates the cases for the sqrt case manager

    Args:
        N (int): The number to find the sqrt of.

    Yields:
        tuple: The case for the sqrt.
    '
    l = 1
    while (l <= N):
        r = ((N // (N // l)) + 1)
        (yield ((N // l), l, r))
        l = r

def solve(N, K, cases):
    'Solves the problem

    Args:
        N (int): The number to find the sqrt of.
        K (int): The number of cases.
        cases (np.array): The cases for the sqrt.
    '
    mod = ((10 ** 9) + 7)
    dp = np.zeros(((K + 1), len(cases)), dtype=np.int64)
    dp[(0, 0)] = 1
    for k in range(1, (K + 1)):
        cum = 0
        for n in range(len(cases)):
            cum = ((cum + dp[((k - 1), n)]) % mod)
            (_, l, r) = cases[((- n) - 1)]
            dp[(k, ((- n) - 1))] = ((cum * (r - l)) % mod)
    print((dp[(- 1)].sum() % mod))
numba_compile([[solve, '(i8,i8,i8[:,:])']])

def main():
    'The main function
    '
    (N, K) = map(int, input().split())
    cases = np.array(list(sqrt_case_manager(N)), dtype=np.int64)
    solve(N, K, cases)
main()


