# File changed

from collections import defaultdict

class UnionFind():
  n = 1
  par = [0]
  rnk = [0]

  def __init__(self, size):
    self.n = size
    self.par = [i for i in range(self.n)]
    self.rnk = [0 for i in range(self.n)]

  def find(self, vertex1):
    if self.par[vertex1] == vertex1:
      return vertex1
    else:
      self.par[vertex1] = self.find(self.par[vertex1])
      return self.par[vertex1]

  def unite(self, vertex1, vertex2):
    vertex1 = self.find(vertex1)
    vertex2 = self.find(vertex2)
    if vertex1 == vertex2:
      return
    if self.rnk[vertex1] < self.rnk[vertex2]:
      self.par[vertex1] = vertex2
    else:
      self.par[vertex2] = vertex1
      if self.rnk[vertex1] == self.rnk[vertex2]:
        self.rnk[vertex1] += 1

  def same(self, vetrex1, vertex2):
    return self.find(vetrex1) == self.find(vertex2)

N = int(input())
p = [((i,) + tuple(map(int, input().split()))) for i in range(N)]
g = UnionFind(N)
p.sort(key=(lambda x: x[1]))
for i in range(N-1):
  if p[i][1] == p[i+1][1]:
    g.unite(p[i][0], p[i+1][0])
p.sort(key=(lambda x: x[2]))
for i in range(N-1):
  if p[i][2] == p[i+1][2]:
    g.unite(p[i][0], p[i+1][0])
p.sort(key=(lambda x: x[0]))
dx = defaultdict(set)
dy = defaultdict(set)
for i in range(N):
  j = g.find(i)
  dx[j].add(p[i][1])
  dy[j].add(p[i][2])
ans = -N
for j in dx:
  ans += len(dx[j])*len(dy[j])
print(ans)

