import pytest

@pytest.mark.parametrize("w,h,x,y,expected", [
    (1, 1, 0, 0, "1 1"),
    (1, 1, 1, 0, "1 0"),
    (1, 1, 0, 1, "1 0"),
    (1, 1, 1, 1, "0 1"),
    (2, 2, 0, 0, "4 1"),
    (2, 2, 1, 0, "4 0"),
    (2, 2, 0, 1, "4 0"),
    (2, 2, 1, 1, "3 1"),
    (3, 3, 0, 0, "9 1"),
    (3, 3, 1, 0, "9 0"),
    (3, 3, 0, 1, "9 0"),
    (3, 3, 1, 1, "6 1"),
    (3, 3, 2, 0, "6 0"),
    (3, 3, 0, 2, "6 0"),
    (3, 3, 2, 1, "5 1"),
    (3, 3, 1, 2, "5 1"),
    (3, 3, 2, 2, "4 1"),
])
def test_that_center_is_passed_through(w, h, x, y, expected):
    output = "{} {}".format(w*h/2, 1 if x == w/2 and y == h/2 else 0)
    assert output == expected

