# File changed

from scipy.optimize import fmin

n = int(input())
inf = 10**18
fixedx = [inf, -inf]
r = [inf, -inf]
l = [inf, -inf]
fixedy = [inf, -inf]
u = [inf, -inf]
D = [inf, -inf]

def update(fixed, li, x, y):
  (li[0], li[1]) = (min(li[0], x), max(li[1], x))
  (fixed[0], fixed[1]) = (min(fixed[0], y), max(fixed[1], y))

for _ in range(n):
  x, y, d = input().split()
  x, y = int(x), int(y)
  if d == 'L':
    update(fixedy, l, x, y)
  elif d == 'R':
    update(fixedy, r, x, y)
  elif d == 'U':
    update(fixedx, u, y, x)
  else:
    update(fixedx, D, y, x)

def calc_x(t, fixed, dec, inc):
  left = inf
  right = -inf
  for li, speed in [(fixed, 0), (dec, -1), (inc, 1)]:
    left = min(left, li[0] + speed * t)
    right = max(right, li[1] + speed * t)
  return right - left

def area(t):
  if t < 0:
    return inf
  return calc_x(t, fixedx, l, r) * calc_x(t, fixedy, D, u)

xopt = fmin(area, x0=10**8, ftol=10**(-9), disp=False)
answer = area(xopt[0])
print(answer)

