import pytest


@pytest.mark.parametrize('n, h, d, expected', [
    (1, 1, 1, 1),
    (2, 2, 1, 2),
    (3, 3, 2, 6),
    (4, 4, 3, 24),
    (5, 5, 4, 120),
    (6, 6, 5, 720),
    (7, 7, 6, 5040),
    (8, 8, 7, 40320),
    (9, 9, 8, 362880),
    (10, 10, 9, 3628800),
])
def test_that_dp_works(n, h, d, expected):
    n, h, d = map(int, input().split())
    MOD = 10 ** 9 + 7

    fact, fact_acc = 1, 1
    for i in range(2, n + 1):
        fact = fact * i % MOD
        fact_acc = (fact_acc + fact) % MOD

    dp = [0] * (h + 1)
    dp[0] = base = fact
    for i in range(1, h):
        dp[i] = base * fact_acc % MOD
        base = (base + dp[i]) % MOD
        if i >= d:
            base = (base - dp[i - d]) % MOD
    assert base == expected

