import sys
sys.setrecursionlimit(10**7)

def LI():
  return list(map(int, input().split()))

def LI_():
  return [int(x) - 1 for x in input().split()]

def LF():
  return list(map(float, input().split()))

def LS():
  return input().split()

def II():
  return int(input())

def SI():
  return input().strip()

mod = 10**9 + 7
inf = 10**18
from collections.abc import Sequence, Set
from bisect import bisect_left
from itertools import chain
from heapq import heappush, heappop

class HeapqSet():

  def __init__(self):
    self._set = set()
    self._list = list()

  def add(self, a):
    if a in self._set:
      return
    else:
      self._set.add(a)
      heappush(self._list, a)

  def remove(self, a):
    if a not in self._set:
      raise ValueError
    else:
      self._set.remove(a)

  def pop_min(self):
    if not self._set:
      self._list = list()
      return None
    while True:
      a = heappop(self._list)
      if a not in self._set:
        continue
      else:
        self._set.remove(a)
        break
    return a

  def peek_min(self):
    if not self._set:
      self._list = list()
      return None
    while True:
      a = self._list[0]
      if a not in self._set:
        heappop(self._list)
        continue
      else:
        break
    return a

  def is_empty(self):
    return not self._set

  def __bool__(self):
    return True if self._set else False

def main():
  n, q = LI()
  events = []
  for _ in range(n):
    stx = LI()
    events.append((stx[0] - stx[2], stx[2], True))
    events.append((stx[1] - stx[2], stx[2], False))
  for _ in range(q):
    events.append((II(), inf, -1))
  events.sort()
  ans = []
  m = HeapqSet()
  changeflag = True
  min = inf
  for txa in events:
    if txa[2] == -1:
      if not m:
        ans.append(-1)
      else:
        if changeflag:
          min = m.peek_min()
          changeflag = False
        ans.append(min)
    elif txa[2]:
      m.add(txa[1])
      if txa[1] < min:
        min = txa[1]
        changeflag = False
    else:
      m.remove(txa[1])
      if txa[1] == min and m:
        min = m.peek_min()
        changeflag = False
      elif not m:
        min = inf
        changeflag = False
  print('\n'.join(map(str, ans)))

main()

