# python 3.4.3
import sys
input = sys.stdin.readline

# -------------------------------------------------------------
# library
# -------------------------------------------------------------

class Heap:
    def __init__(self, L, R):
        self.L = L
        self.R = R
        self.lenL = len(L)
        self.lenR = len(R)
        self.sumL = sum(L)
        self.sumR = sum(R)
        self.y = 0

    def query(self, query):
        if len(query) == 1:
            x = -self.L[0]
            f = self.sumR - self.sumL + self.y
            if self.lenL != self.lenR:
                f += x
            print("{} {}".format(x, f))
        else:
            q,a,b = query
            self.y += b
            if self.lenL > self.lenR:
                self.sumL += a
                a = -self.L.pop()
                self.sumL -= a
                self.L.append(a)
                self.sumR += a
                self.lenR += 1
            else:
                self.sumR += a
                a = self.R.pop()
                self.sumR -= a
                self.R.append(a)
                self.sumL += a
                self.lenL += 1

# -------------------------------------------------------------
# main
# -------------------------------------------------------------
import heapq

L,R = [10**15],[10**15]
lenL,lenR = 1,1
sumL,sumR = 0,0
y = 0

Q = int(input())
for i in range(Q):
    query = list(map(int,input().split()))
    if len(query) == 1:
        x = -L[0]
        f = sumR - sumL + y
        if lenL != lenR:
            f += x
        print("{} {}".format(x, f))
    else:
        q,a,b = query
        y += b
        if lenL > lenR:
            sumL += a
            a = -heapq.heappushpop(L, -a)
            sumL -= a
            heapq.heappush(R, a)
            sumR += a
            lenR += 1
        else:
            sumR += a
            a = heapq.heappushpop(R, a)
            sumR -= a
            heapq.heappush(L, -a)
            sumL += a
            lenL += 1

