' UnionFindTree
'
# File changed


class UnionFindTree():

    def __init__(self, n):
        'Initializes the UnionFindTree

        Args:
            n (int): The number of nodes in the tree.
        '
        self.par = [(- 1) for _ in range(n)]

    def find(self, x):
        'Finds the root node of the tree

        Args:
            x (int): The node to find the root of.

        Returns:
            int: The root node of the tree.
        '
        if (self.par[x] < 0):
            return x
        self.par[x] = self.find(self.par[x])
        return self.par[x]

    def size(self, x):
        'Gets the size of the tree

        Args:
            x (int): The node to get the size of.

        Returns:
            int: The size of the tree.
        '
        return (- self.par[self.find(x)])

    def unite(self, x, y):
        'Unites two trees

        Args:
            x (int): The first tree to unite.
            y (int): The second tree to unite.

        Returns:
            int: 1 if the trees were united, 0 otherwise.
        '
        x = self.find(x)
        y = self.find(y)
        if (x == y):
            return 0
        if (self.size(x) < self.size(y)):
            (x, y) = (y, x)
        self.par[x] += self.par[y]
        self.par[y] = x
        return 1
(n, m) = map(int, input().split())
uf = UnionFindTree(n)
ans = n
for _ in range(m):
    (x, y, z) = map(int, input().split())
    ans -= uf.unite((x - 1), (y - 1))
print(ans)


