import pytest

def solve(m, k):
    if k >= 2**m:
        return -1
    if (m == 1) and (k == 0):
        return "0 0 1 1"
    if (m == 1) and (k == 1):
        return -1
    b = [x for x in range(2**m) if x != k]
    c = b[::-1]
    a = b + [k] + c + [k]
    return " ".join(map(str, a))

@pytest.mark.parametrize("m, k, expected", [
    (1, 0, "0 0 1 1"),
    (1, 1, -1),
    (2, 0, "0 1 2 3 0 1"),
    (2, 1, "0 2 1 3 0 2"),
    (2, 2, "1 0 2 3 1 0"),
    (2, 3, "1 2 0 3 1 2"),
    (3, 0, "0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7"),
    (3, 1, "0 2 1 3 4 5 6 7 0 2 1 3 4 5 6 7"),
    (3, 2, "1 0 2 3 4 5 6 7 1 0 2 3 4 5 6 7"),
    (3, 3, "1 2 0 3 4 5 6 7 1 2 0 3 4 5 6 7"),
    (3, 4, "2 1 0 3 4 5 6 7 2 1 0 3 4 5 6 7"),
    (3, 5, "2 3 1 0 4 5 6 7 2 3 1 0 4 5 6 7"),
    (3, 6, "3 2 1 0 4 5 6 7 3 2 1 0 4 5 6 7"),
    (3, 7, "3 4 2 1 0 5 6 7 3 4 2 1 0 5 6 7"),
])
def test_solve(m, k, expected):
    assert solve(m, k) == expected

