import math

@pytest.mark.parametrize('N, A, expected', [
    (3, [1, 2, 3], 1),
    (5, [1, 2, 3, 4, 5], 1),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 1),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 100], 10),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 1000], 100),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10000], 1000),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 100000], 10000),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 1000000], 100000),
])
def test_gcd(N, A, expected):
    assert expected == gcd(N, A)

def gcd(N, A):
    L = [0] * (N + 1)
    for i in range(N):
        L[i + 1] = math.gcd(L[i], A[i])
    R = [0] * (N + 1)
    for i in range(N - 1, -1, -1):
        R[i] = math.gcd(R[i + 1], A[i])
    M = []
    for i in range(N):
        M.append(math.gcd(L[i], R[i + 1]))
    return max(M)

