import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np

MOD = 998244353

def cumprod(arr, MOD):
  l = len(arr)
  lsq = int(((l ** 0.5) + 1))
  arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
  for n in range(1, lsq):
    arr[:, n] *= arr[:, (n - 1)]
    arr[:, n] %= MOD
  for n in range(1, lsq):
    arr[n] *= arr[((n - 1), (- 1))]
    arr[n] %= MOD
  return arr.ravel()[:l]

def make_fact(U, MOD):
  x = np.arange(U, dtype=np.int64)
  x[0] = 1
  fact = cumprod(x, MOD)
  x = np.arange(U, 0, (- 1), dtype=np.int64)
  x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
  factinv = cumprod(x, MOD)[::(- 1)]
  return (fact, factinv)

U = ((N + N) + 100)
(fact, factinv) = make_fact(U, MOD)
combn = ((((fact[N] * factinv[:(N + 1)]) % MOD) * factinv[N::(- 1)]) % MOD)

def F1(N, X):
  def mult(P, Q):
    dp = (len(P) - 1)
    dq = (len(Q) - 1)
    if (dp < dq):
      (dp, dq) = (dq, dp)
      (P, Q) = (Q, P)
    r = np.zeros(((dp + dq) + 1), np.int64)
    for n in range((dq + 1)):
      r[n:((n + dp) + 1)] += ((Q[n] * P) % MOD)
    r %= MOD
    return r[:X]

  def power(P, n):
    if (n == 0):
      return np.array([1], dtype=np.int64)
    Q = power(P, (n // 2))
    Q = mult(Q, Q)
    return (mult(P, Q) if (n & 1) else Q)
  P = np.array([1, 1, 1], np.int64)
  Q = power(P, N)
  return (Q.sum() % MOD)

def F2(N, X):
  x = np.zeros((N + 1), np.int64)
  for n in range(X):
    m = ((X - 1) - (2 + (2 * n)))
    if (m < 0):
      break
    two = np.arange(((m // 2) + 1), dtype=np.int64)
    one = (m - (2 * two))
    coef = ((((fact[(one + two)] * factinv[one]) % MOD) * factinv[two]) % MOD)
    rest = (((N - one) - two) - ((2 * n) + 2))
    ind = (rest >= 0)
    rest = rest[ind]
    coef = coef[ind]
    x[rest] += coef
  x %= MOD
  return (((x * combn) % MOD).sum() % MOD)

def F3(N, X):
  if ((X % 2) == 0):
    return 0
  if (X > N):
    return 0
  n = ((N - X) + 1)
  return (combn[:n].sum() % MOD)

answer = (((F1(N, X) + F2(N, X)) + F3(N, X)) % MOD)
print(answer)

