def has_circuit(g: list, s: int, ng: int) -> bool:
    stack = []
    stack.append((s, (- 1)))
    while (len(stack) > 0):
        (u, p) = stack.pop()
        if ((u == s) and (p >= 0)):
            return True
        for v in g[u]:
            if (v == ng):
                continue
            if (v == p):
                continue
            stack.append((v, u))
    return False

def three_circuit(N: int, M: int, edges: list) -> bool:
    g = []
    for _ in range(N):
        g.append([])
    for (u, v) in edges:
        g[(u - 1)].append((v - 1))
        g[(v - 1)].append((u - 1))
    dims = []
    for p in g:
        dims.append(len(p))
    if (not all((((d % 2) == 0) for d in dims))):
        return False
    if (max(dims) >= 6):
        return True
    vertexes = []
    for v in range(N):
        if (dims[v] == 4):
            vertexes.append(v)
    if (len(vertexes) >= 3):
        return True
    if (len(vertexes) == 2):
        return has_circuit(g, vertexes[0], vertexes[1])
    return False
if (__name__ == '__main__'):
    M = 0
    (N, M) = map(int, input().split())
    edges = []
    for _ in range(M):
        edges.append(tuple((int(s) for s in input().split())))
    yes = three_circuit(N, M, edges)
    print(('Yes' if yes else 'No'))

