def has_circuit(g: list, s: int, ng: int) -> bool:
    stack = []
    stack.append((s, -1))  # (現在の頂点, 親)

    while len(stack) > 0:
        u, p = stack.pop()

        if u == s and p >= 0:
            return True

        for v in g[u]:
            if v == ng:
                continue
            if v == p:
                continue
            stack.append((v, u))
    return False


@pytest.mark.parametrize('N, M, edges, expected', [
    (4, 3, [(1, 2), (2, 3), (3, 4)], True),
    (4, 3, [(1, 2), (2, 3), (3, 4), (4, 1)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (4, 2)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (4, 3)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (4, 4)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (4, 5)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 6)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 7)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 8)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 9)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 10)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 11)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 12)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 13)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 14)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 15)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 16)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 17)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 18)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 19)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 20)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 21)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 22)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 23)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 24)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 25)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 26)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 27)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 28)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 29)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 30)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 31)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 32)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 33)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 34)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 35)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 36)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 37)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 38)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 39)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4), (5, 40)], False),
    (4, 3, [(1, 2), (2, 3), (3, 4