import pytest

@pytest.mark.parametrize('n, h, ans', [
    (1, [1], 0),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 2),
    (4, [1, 2, 3, 4], 3),
    (5, [1, 2, 3, 4, 5], 4),
    (6, [1, 2, 3, 4, 5, 6], 5),
    (7, [1, 2, 3, 4, 5, 6, 7], 6),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 7),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 8),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 9),
])
def test_that_the_number_of_steps_is_correct(n, h, ans):
    n = int(n)
    h = list(map(int, h))
    hk = 0
    for i in range(n):
        if hk == h[i]:
            continue
        elif hk < h[i]:
            while hk < h[i]:
                hk += 1
        elif hk > h[i]:
            while hk > h[i]:
                hk -= 1
    assert hk == ans

