import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines

import numpy as np

N = int(readline())
A = [0]+list(map(int,readline().split()))

m = map(int,read().split())
UV = zip(m,m)
graph = [[] for _ in range(N+1)]
for u,v in UV:
    graph[u].append(v)
    graph[v].append(u)

root=1
parent = [0] * (N+1)
ts = []
stack = [root]
while stack:
    x = stack.pop()
    ts.append(x)
    for y in graph[x]:
        if y == parent[x]:
            continue
        parent[y] = x
        stack.append(y)

INF = 10**18

"""
各頂点において、
・「根側を全て正にするための切断回数」
・「各切断回数ごとの、根側に残る数の和の最小値」（array）
を持つ
"""

def merge(dp1,dp2):
    # 回数 -> 和の最小値が入っている
    L1,L2 = len(dp1),len(dp2)
    if L1>L2:
        L1,L2=L2,L1
        dp1,dp2=dp2,dp1
    dp = np.full(L1+L2-1,INF)
    for i,x in enumerate(dp1):
        np.minimum(dp[i:L2+i],x+dp2,out=dp[i:L2+i])
    return dp

def v_to_e(cut,arr):
    # 部分木頂点までのdp情報を、辺までのdp情報に変更
    arr = np.append(arr,0)
    negative = np.where(arr<0)[0]
    # 全て正として切る
    if cut != INF:
        if arr[cut+1] > 0:
            arr[cut+1] = 0
    # 全て負として切る
    if len(negative)>0:
        n = negative[0]
        if cut>n+1:
            cut=n+1
    np.minimum(arr[negative+1],0,out=arr[negative+1])
    return cut,arr

positive_cut_cnt = [None]*(N+1)
rest_sum_array = [None]*(N+1)

for x in ts[::-1]:
    a = A[x]
    arr = np.array([a],np.int64)
    cut = 0
    for c in graph[x]:
        if c == parent[x]:
            continue
        c_cut = positive_cut_cnt[c]
        c_arr = rest_sum_array[c]
        c_cut,c_arr = v_to_e(c_cut,c_arr)
        cut += c_cut
        arr = merge(arr,c_arr)
    if a<0:
        cut=INF
    positive_cut_cnt[x]=cut
    rest_sum_array[x] = arr

answer = positive_cut_cnt[1]
negative = np.where(rest_sum_array[1]<0)[0]
if len(negative):
    n = negative[0]
    if answer > n:
        answer = n

print(answer)