import pytest

@pytest.mark.parametrize('N, H, expected', [
    (1, [1], 0),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 2),
    (4, [1, 2, 3, 4], 3),
    (5, [1, 2, 3, 4, 5], 4),
    (6, [1, 2, 3, 4, 5, 6], 5),
    (7, [1, 2, 3, 4, 5, 6, 7], 6),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 7),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 8),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 9),
])
def test_dp_solution(N, H, expected):
    dp = [10**9]*N
    dp[0] = 0
    for i in range(N-2):
        dp[i+1] = min(abs(H[i]-H[i+1])+dp[i], dp[i+1])
        dp[i+2] = abs(H[i]-H[i+2])+dp[i]

    dp[N-1] = min(abs(H[N-1]-H[N-2])+dp[N-2], dp[N-1])

    assert dp[N-1] == expected

