# File changed

import numpy as np
from numba import njit

@njit
def dp(N, K, max_candies, dpt):
    for i in range(1, (N + 1)):
        for j in range(0, (K + 1)):
            dpt[i][j] += dpt[(i - 1)][j]
            t = ((j - max_candies[(i - 1)]) - 1)
            if (t >= 0):
                dpt[i][j] -= dpt[(i - 1)][t]
            if (j > 0):
                dpt[i][j] += dpt[i][(j - 1)]
            dpt[i][j] = (dpt[i][j] % ((10 ** 9) + 7))
    return ((dpt[N][K] - dpt[N][(K - 1)]) % ((10 ** 9) + 7))

@pytest.mark.parametrize('N, K, max_candies, expected', [
    (1, 1, [1], 1),
    (2, 1, [1, 1], 1),
    (2, 1, [1, 2], 1),
    (2, 1, [2, 1], 1),
    (2, 1, [2, 2], 2),
    (2, 2, [1, 1], 1),
    (2, 2, [1, 2], 1),
    (2, 2, [2, 1], 1),
    (2, 2, [2, 2], 2),
    (3, 1, [1, 1, 1], 1),
    (3, 1, [1, 1, 2], 1),
    (3, 1, [1, 2, 1], 1),
    (3, 1, [1, 2, 2], 1),
    (3, 1, [2, 1, 1], 1),
    (3, 1, [2, 1, 2], 1),
    (3, 1, [2, 2, 1], 1),
    (3, 1, [2, 2, 2], 2),
    (3, 2, [1, 1, 1], 1),
    (3