# File changed

import sys
sys.setrecursionlimit((1 << 25))
readline = sys.stdin.buffer.readline
read = sys.stdin.readline
import numpy as np
from functools import partial
array = partial(np.array, dtype=np.int64)
zeros = partial(np.zeros, dtype=np.int64)
full = partial(np.full, dtype=np.int64)
ra = range
enu = enumerate

def exit(*argv, **kwarg):
    print(*argv, **kwarg)
    sys.exit()

def mina(*argv, sub=1):
    return list(map((lambda x: (x - sub)), argv))

def a_int():
    return int(readline())

def read_matrix(H, W):
    lines = []
    for _ in range(H):
        lines.append(read())
    lines = ' '.join(lines)
    return np.fromstring(lines, sep=' ', dtype=np.int64).reshape(H, W)
MOD = ((10 ** 9) + 7)
INF = (2 ** 31)
from collections import defaultdict, Counter, deque
from operator import itemgetter, xor, add
from itertools import product, permutations, combinations
from bisect import bisect_left, bisect_right
from functools import reduce
N = a_int()
A = read_matrix(N, N)
'\n一方の集合を管理してDPというアイデア\n\ndp[i][s] ... 男性を:i人目まで見たときに、マッチングした女性の集合がsであるような通りの総数\n\n更新式\ndp[i+1][s+1<<j] += dp[i][s] for s のjbit目は0 かつ A[i,j]==1\n\nこれでは計算量がO(2^N 2N)なのでTLE\niと|s|は同じなのだから状態をまとめることができる\n(二次元dpでいうとi=|s|のセルでしか状態遷移が発生しない)\n\nよって単純sだけでループしても良さそうだし、()内のアイデアで枝刈りしても良さそう\n'
from numba import njit

@njit('(i8,i8[:,:])', cache=True)
def solve_TLE(N, A):
    dp = np.zeros(((N + 1), (1 << N)), dtype=np.int64)
    dp[(0, 0)] = 1
    for i in range(N):
        for s in range((1 << N)):
            for j in range(N):
                if ((((s >> j) & 1) == 0) and (A[(i, j)] == 1)):
                    dp[((i + 1), (s + (1 << j)))] += dp[(i, s)]
                    dp[((i + 1), (s + (1 << j)))] %= MOD
    print((dp[(N, ((1 << N) - 1))] % MOD))

@njit('i8(i8)', cache=True)
def popcount(x):
    x = (x - ((x >> 1) & 6148914691236517205))
    x = ((x & 3689348814741910323) + ((x >> 2) & 3689348814741910323))
    x = ((x + (x >> 4)) & 1085102592571150095)
    x = (x + (x >> 8))
    x = (x + (x >> 16))
    x = (x + (x >> 32))
    return (x & 127)

@njit('(i8,i8[:,:])', cache=True)
def solve(N, A):
    dp = np.zeros(((N + 1), (1 << N)), dtype=np.int64)
    dp[(0, 0)] = 1
    for i in range(N):
        for s in range((1 << N)):
            if (popcount(s) != i):
                continue
            for j in range(N):
                if ((((s >> j) & 1) == 0) and (A[(i, j)] == 1)):
                    dp[((i + 1), (s + (1 << j)))] += dp[(i, s)]
                    dp[((i + 1), (s + (1 << j)))] %= MOD
    print((dp[(N, ((1 << N) - 1))] % MOD))

@njit('(i8,i8[:,:])', cache=True)
def solve2(N, A):
    dp = np.zeros((1 << N), dtype=np.int64)
    dp[0] = 1
    for s in range((1 << N)):
        for j in range(N):
            if ((((s >> j) & 1) == 0) and (A[(popcount(s), j)] == 1)):
                dp[(s + (1 << j))] += dp[s]
                dp[(s + (1 << j))] %= MOD
    print((dp[((1 << N) - 1)] % MOD))
solve(N, A)
