# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
N = int(readline())
H = list(map(int, readline().split()))
A = list(map(int, readline().split()))
'\n・最後の高さ -> 価値の総和\n・BITでmaxを管理\n'

class BIT():

    def __init__(self, max_n):
        'Initializes the BIT

        Args:
            max_n (int): The maximum number of elements in the BIT.
        '
        self.size = (max_n + 1)
        self.tree = ([0] * self.size)

    def __repr__(self):
        return self.tree.__repr__()

    def get_max(self, i):
        'Gets the maximum value in the BIT

        Args:
            i (int): The index to start at.

        Returns:
            int: The maximum value in the BIT.
        '
        s = 0
        while i:
            t = self.tree[i]
            if (s < t):
                s = t
            i -= (i & (- i))
        return s

    def update(self, i, x):
        'Updates the BIT

        Args:
            i (int): The index to start at.
            x (int): The value to update the BIT with.
        '
        while (i < self.size):
            if (self.tree[i] < x):
                self.tree[i] = x
            i += (i & (- i))
bit = BIT(N)
for (i, (a, h)) in enumerate(zip(A, H), 1):
    x = bit.get_max(h)
    bit.update(h, (x + a))
answer = bit.get_max(N)
print(answer)


