' File changed

MOD = ((10 ** 9) + 7)

def mul(a, b):
    ' Multiplies two matrices together

    Args:
        a (list): The first matrix.
        b (list): The second matrix.

    Returns:
        list: The result of the matrix multiplication.
    '
    return [[(sum(((aij * bij) for (aij, bij) in zip(ai, bi))) % MOD) for bi in zip(*b)] for ai in a]

def pow(b, k):
    ' Raises a matrix to a power

    Args:
        b (list): The matrix to raise to a power.
        k (int): The power to raise the matrix to.

    Returns:
        list: The result of the matrix power.
    '
    r = [[(1 if (i == j) else 0) for i in range(len(b))] for j in range(len(b))]
    while k:
        if (k & 1):
            r = mul(r, b)
        k >>= 1
        b = mul(b, b)
    return r

def main():
    ' Main function

    Returns:
        int: The result of the main function.
    '
    (N, K) = (int(i) for i in input().split())
    A = []
    for i in range(N):
        A.append([int(j) for j in input().split()])
    A = [i for i in zip(*A)]
    v = [([1] * N)]
    return (sum(mul(v, pow(A, K))[0]) % MOD)
print(main())


