#!/usr/bin/env python3
import sys
from itertools import accumulate
import numpy as np
MOD = 1000000007  # type: int


def solve(N: int, s: str):

    # DP[i][j]はi文字目までをみたす順列のうち、最後がjで終わるものの個数
    DP = np.zeros((N, N+1), dtype=np.int64)
    DP[0][1] = 1

    for i in range(1, N):
        acc = np.cumsum(DP[i-1])
        if s[i-1] == "<":
            DP[i][1:i+2] = np.mod(acc[:i+1], MOD)
        else:
            DP[i][1:i+2] = np.mod(acc[i+1]-acc[:i+1], MOD)

    print(np.mod(DP[N-1].sum(), MOD))
    return


def main():

    def iterate_tokens():
        for line in sys.stdin:
            for word in line.split():
                yield word
    tokens = iterate_tokens()
    N = int(next(tokens))  # type: int
    s = next(tokens)  # type: str
    solve(N, s)


if __name__ == '__main__':
    main()

