# File changed

import math

def get_primes(n):
    'Returns a list of primes up to n

    Args:
        n (int): The maximum number to check for primes.

    Returns:
        list: A list of primes.
    '
    primes = []
    checks = [True for _ in range((int(math.sqrt(n)) + 1))]
    checks[0] = checks[1] = False
    for i in range(2, len(checks)):
        if checks[i]:
            primes.append(i)
            tmp = 0
            while ((i + (tmp * i)) < len(checks)):
                checks[(i + (tmp * i))] = False
                tmp += 1
    return primes

def combination(a, b):
    'Returns the combination of a and b

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The combination of a and b.
    '
    i = 1
    for _i in range(((a - b) + 1), (a + 1)):
        i *= _i
    return (i // math.factorial(b))
(n, m) = map(int, input().split())
primes = get_primes(m)
elems = []
m_copy = m
divides = dict()
for _p in primes:
    while ((m_copy % _p) == 0):
        m_copy = (m_copy // _p)
        if (str(_p) in divides.keys()):
            divides[str(_p)] += 1
        else:
            divides[str(_p)] = 1
if (m_copy > 1):
    divides[str(m_copy)] = 1
ans = 1
for i in divides.values():
    ans *= combination(((i + n) - 1), i)
print((ans % 1000000007))


