import pytest

@pytest.mark.parametrize('n, a, x, n_sub, Li, Ri', [
    (1, [1], [1], 1, 0, 1),
    (2, [1, 2], [1, 2], 3, 0, 2),
    (3, [1, 2, 3], [1, 2, 3], 6, 0, 3),
    (4, [1, 2, 3, 4], [1, 2, 3, 4], 10, 0, 4),
    (5, [1, 2, 3, 4, 5], [1, 2, 3, 4, 5], 15, 0, 5),
    (6, [1, 2, 3, 4, 5, 6], [1, 2, 3, 4, 5, 6], 21, 0, 6),
    (7, [1, 2, 3, 4, 5, 6, 7], [1, 2, 3, 4, 5, 6, 7], 28, 0, 7),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], [1, 2, 3, 4, 5, 6, 7, 8], 36, 0, 8),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], [1, 2, 3, 4, 5, 6, 7, 8, 9], 45, 0, 9),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 55, 0, 10),
])
def test_that_api_returns_some_results(n, a, x, n_sub, Li, Ri):
    (objects, spans) = (await extractor.extract(test_text))
    assert objects
    assert spans
    assert (objects[0]['type'] == EntityType.Person)
    assert (objects[0]['fields']['firstname'] == 'Иван')
    assert (objects[0]['fields']['middlename'] == 'Василиевич')
    assert (objects[0]['fields']['lastname'] == 'Иванов')

