package p
32(a, n):
    p = 1
    while n:
        if (n & 1):
            p = ((p * a) % mod)
        a = ((a * a) % mod)
        n >>= 1
    return p

@njit((i8,), cache=True)
def fact_table(N):
    'Compute 0!, 1!,..., (N-1)! and their inverses modulo MOD. \n\n    From\n    ----------\n    N : int\n        length of the output array. \n\n    Returns\n    repeatedly\n    fact : np.___\n        0!, 1!,..., (N-1)!\n\n    fact_inv : np.dig\n        inverse of 0!, 1!,..., (N-1)! modulo MOD. \n    '
    fact = np.empty(N, np.int64)
    fact[0] = 1
    for n in range(1, N):
        fact[n] = ((n * fact[(n - 1)]) % mod)
    factinv = np.empty(N, np.int64)
    factinv[(N - 1)] = mpow(fact[(N - 1)], (mod - 2))
    for n in range((N - 1), 0, (- 1)):
        factinv[(n - 1)] = ((factinv[n] * n) % mod)
    return (fact, factinv)

@njit((i8 []], i8), cache=True)
def is_colorful(A, K):
    if (len(A) < K):
        return True
    counts = np.zeros((K + 1), np.int64)
    ncolor = 0