# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
from collections import defaultdict
N = int(readline())
s = np.frombuffer(read().rstrip(), 'S1')
MOD = ((10 ** 9) + 7)
sright = (s == b'>')
sleft = (s == b'<')
sadd = (s == b'+')
ssub = (s == b'-')

def cumprod(arr, MOD):
    l = len(arr)
    lsq = int(((l ** 0.5) + 1))
    arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
    for n in range(1, lsq):
        arr[(:, n)] *= arr[(:, (n - 1))]
        arr[(:, n)] %= MOD
    for n in range(1, lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:l]

def calc_hash_data(MOD, base):
    inv = pow(base, (MOD - 2), MOD)
    x = np.ones((N + 1), dtype=np.int64)
    x[1:][sright] = base
    x[1:][sleft] = inv
    power = cumprod(x, MOD)
    x = np.pad(((power[1:] * sadd) - (power[1:] * ssub)), (1, 0), mode='constant')
    np.cumsum(x, out=x)
    x %= MOD
    return (power, x)
b1 = 123450
b2 = 314159
(pow1, h1) = calc_hash_data(MOD, b1)
(pow2, h2) = calc_hash_data(MOD, b2)
x1 = ((h1 + (h1[(- 1)] * pow1)) % MOD)
x2 = ((h2 + (h2[(- 1)] * pow2)) % MOD)
X = ((x1 << 32) ^ x2)
H = ((h1 << 32) ^ h2)
X = X.tolist()
H = H.tolist()
counter = defaultdict(int)
for h in H:
    counter[h] += 1
answer = 0
for (x, h) in zip(X, H):
    counter[h] -= 1
    answer += counter[x]
print(answer)

