# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
from collections import defaultdict
N = int(readline())
S = np.frombuffer(read().rstrip(), 'S1')
MOD = ((10 ** 9) + 7)
Sright = (S == b'>')
Sleft = (S == b'<')
Sadd = (S == b'+')
Ssub = (S == b'-')

def cumprod(arr, MOD):
    L = len(arr)
    Lsq = int(((L ** 0.5) + 1))
    arr = np.resize(arr, (Lsq ** 2)).reshape(Lsq, Lsq)
    for n in range(1, Lsq):
        arr[:, n] *= arr[:, (n - 1)]
        arr[:, n] %= MOD
    for n in range(1, Lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:L]

def calc_hash_data(MOD, base):
    inv = pow(base, (MOD - 2), MOD)
    x = np.ones((N + 1), dtype=np.int64)
    x[1:][Sright] = base
    x[1:][Sleft] = inv
    power = cumprod(x, MOD)
    x = np.pad(((power[1:] * Sadd) - (power[1:] * Ssub)), (1, 0), mode='constant')
    np.cumsum(x, out=x)
    x %= MOD
    return (power, x)
b1 = 123450
b2 = 314159
(pow1, H1) = calc_hash_data(MOD, b1)
(pow2, H2) = calc_hash_data(MOD, b2)
X1 = ((H1 + (H1[(- 1)] * pow1)) % MOD)
X2 = ((H2 + (H2[(- 1)] * pow2)) % MOD)
X = ((X1 << 32) ^ X2)
H = ((H1 << 32) ^ H2)
X = X.tolist()
H = H.tolist()
counter = defaultdict(int)
for h in H:
    counter[h] += 1
answer = 0
for (x, h) in zip(X, H):
    counter[h] -= 1
    answer += counter[x]
print(answer)
