import sys
import numpy as np

def offset(length):
  return 1 << length

def solve():
  n, k = map(int, sys.stdin.buffer.readline().split())
  buf = b'0' + sys.stdin.buffer.read().replace(b'\n', b'')
  table = (np.frombuffer(buf, dtype=np.int8).astype(np.int32) - ord(b'0'))
  offsettable = np.ones((len(table)//2), dtype=np.int32)
  for v in range(n-1):
    offsettable[(1<<v):(2<<v)] = 2<<v
  ret = None
  for pos in range(n+1):
    for length in range(pos+1, n+1):
      subtable = table[offset(length):offset(length+1)]
      table[offset(pos):offset(pos+1)] += subtable.reshape((-1), (1<<pos), order='F').sum(axis=0)
    counttable = table[offset(pos):offset(pos+1)]
    index = np.argmax(counttable >= k)
    if counttable[index] >= k:
      ret = (index, pos)
    else:
      return ret
    for length in range(pos+1, n+1):
      size = 1<<length
      rest = length - pos
      halfperiod = 1<<(rest-1)
      transtable = (np.arange(halfperiod+size, halfperiod+(size*2), dtype=np.int32)>>rest)
      transreshaped = transtable.reshape((-1), (halfperiod*2))
      transreshaped *= np.hstack((offsettable[:halfperiod], offsettable[(halfperiod-1)::(-1)]))
      transreshaped += np.roll(np.arange(-halfperiod, halfperiod), halfperiod)
      table[transtable] += table[offset(length):offset(length+1)]
  return ret

index, length = solve()
print(format(index, '020b')[(20-length):])

