import itertools
import os
import sys
import numpy as np
from scipy.sparse.csgraph._shortest_path import floyd_warshall
if os.getenv('LOCAL'):
    sys.stdin = open('_in.txt', 'r')
sys.setrecursionlimit((10 ** 9))
inf = float('inf')
iinf = (10 ** 18)
mod = ((10 ** 9) + 7)
n = int(sys.stdin.buffer.readline())
ab = [list(map(int, sys.stdin.buffer.readline().split())) for _ in range((n - 1))]
graph = [[] for _ in range(n)]
for a, b in ab:
    graph[a].append(b)
    graph[b].append(a)

def test():
  g = [([0] * n) for _ in range(n)]
  for a, b in ab:
    g[a][b] = 1
    g[b][a] = 1
  dist = floyd_warshall(g)
  ret = n
  for choice in itertools.product([True, False], repeat=n):
    k = sum(choice)
    if k == 0:
      continue
    if k >= ret:
      continue
    D = dist[np.array(choice, dtype=bool)]
    s = set()
    for d in D.T:
      s.add(str(d))
    if len(s) == D.shape[1]:
      ret = min(ret, k)
  return ret

def dfs(v, p, forked):
  counts = []
  for u in graph[v]:
    if u == p:
      continue
    cnt = dfs(u, v, (forked or (len(graph[v]) >= 3)))
    counts.append(cnt)
  zeros = (counts.count(0) + (not forked))
  return (sum(counts) + max(0, (zeros - 1)))

leaf = 0
for v in range(n):
  if len(graph[v]) == 1:
    leaf = v
    break
ans = dfs(leaf, None, False)
print(ans)

