from collections import Counter
from functools import reduce
from itertools import combinations
from operator import xor

@pytest.fixture
def n():
    return int(input())

@pytest.fixture
def nodes():
    return [0] * n

@pytest.fixture
def input():
    return lambda: map(int, input().split())

def test_nodes(n, nodes):
    for _ in range(n - 1):
        x, y, a = input()
        nodes[x] ^= a
        nodes[y] ^= a

def test_c(nodes):
    c = Counter(nodes)
    ans = 0
    remains = set()
    for i, v in c.items():
        if i == 0:
            continue
        ans += v // 2
        if v % 2:
            remains.add(i)
    return (ans, remains)

def test_ans(test_c):
    ans, remains = test_c
    for r in (3, 4, 5):
        while True:
            for ns in combinations(remains, r):
                if reduce(xor, ns) == 0:
                    remains.difference_update(ns)
                    ans += r - 1
                    break
            else:
                break
    return ans

def test_print(test_ans):
    print(test_ans)

