# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
sys.setrecursionlimit((10 ** 7))
import numpy as np
from scipy.sparse import csr_matrix
from scipy.sparse.csgraph import depth_first_order
MOD = ((10 ** 9) + 7)
N = int(readline())
xy = list(map(int, read().split()))
graph = csr_matrix((([1] * (N - 1)), (xy[::2], xy[1::2])), ((N + 1), (N + 1)))
(dfsorder, par) = depth_first_order(graph, 1, directed=False)
dfsorder = dfsorder.tolist()
par = par.tolist()
subtreesize = ([1] * (N + 1))
iscent = ([True] * (N + 1))
for v in dfsorder[::(- 1)]:
    if (subtreesize[v] < ((N + 1) // 2)):
        iscent[v] = False
    p = par[v]
    if (p < 0):
        break
    if (subtreesize[v] > (N // 2)):
        iscent[p] = False
    subtreesize[p] += subtreesize[v]
centroid = [v for v in range(1, (N + 1)) if iscent[v]]
ncent = len(centroid)
if (ncent == 1):
    c = centroid[0]
    sizes = ([(N - subtreesize[c])] + [subtreesize[v] for v in range(1, (N + 1)) if (par[v] == c)])
else:
    sizes = [(N // 2), (N // 2)]

def cumprod(arr, MOD):
    l = len(arr)
    lsq = int(((l ** 0.5) + 1))
    arr = np.resize(arr, (lsq ** 2)).reshape(lsq, lsq)
    for n in range(1, lsq):
        arr[(:, n)] *= arr[(:, (n - 1))]
        arr[(:, n)] %= MOD
    for n in range(1, lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:l]

def make_fact(U, MOD):
    x = np.arange(U, dtype=np.int64)
    x[0] = 1
    fact = cumprod(x, MOD)
    x = np.arange(U, 0, (- 1), dtype=np.int64)
    x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
    factinv = cumprod(x, MOD)[::(- 1)]
    return (fact, factinv)
(fact, factinv) = make_fact((N + 100), MOD)

def create_component_arr(n):
    x = np.full((n + 1), fact[n], dtype=np.int64)
    x *= factinv[n::(- 1)]
    x %= MOD
    x *= x
    x %= MOD
    x *= factinv[:(n + 1)]
    x %= MOD
    x[1::2] *= (- 1)
    x %= MOD
    return x

def convolve(x, y):
    lx = len(x)
    ly = len(y)
    if (lx < ly):
        (lx, ly) = (ly, lx)
        (x, y) = (y, x)
    z = np.zeros(((lx + ly) - 1), np.int64)
    for n in range(ly):
        z[n:(n + lx)] += ((x * y[n]) % MOD)
    return (z % MOD)
x = np.array([1], np.int64)
for s in sizes:
    x = convolve(x, create_component_arr(s))
if (ncent == 1):
    answer = (((x * fact[N:0:(- 1)]) % MOD).sum() % MOD)
else:
    answer = (((x * fact[N::(- 1)]) % MOD).sum() % MOD)
print(answer)



