' Find the maximum number of elements that can be removed from a list
'
from collections import Counter

def find_max_removable_elements(N, K, A):
    'Find the maximum number of elements that can be removed from a list

    Args:
        N (int): The number of elements in the list.
        K (int): The number of elements to remove.
        A (list): The list of elements.

    Returns:
        int: The maximum number of elements that can be removed.
    '
    c = Counter(A).most_common()
    c.sort(key=(lambda x: (- x[1])))
    ans = 0
    while (len(c) > K):
        ans += c.pop()[1]
    return ans


