import sys
import numpy as np
import numba
from numba import njit
i8 = numba.int64
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
mod = ((10 ** 9) + 7)

@njit((i8,), cache=True)
def fact_table(N):
  inv = np.empty(N, np.int64)
  inv[0] = 0
  inv[1] = 1
  for n in range(2, N):
    (q, r) = divmod(mod, n)
    inv[n] = ((inv[r] * (- q)) % mod)
  fact = np.empty(N, np.int64)
  fact[0] = 1
  for n in range(1, N):
    fact[n] = ((n * fact[(n - 1)]) % mod)
  factinv = np.empty(N, np.int64)
  factinv[0] = 1
  for n in range(1, N):
    factinv[n] = ((factinv[(n - 1)] * inv[n]) % mod)
  return (fact, factinv, inv)

@njit((i8[::1],), cache=True)
def main(A):
  N = len(A)
  u = (N + 10)
  dp = np.zeros((u, u), np.int64)
  dp[(0, 0)] = 1
  (fact, factinv, inv) = fact_table((10 ** 3))
  if np.all((A == 2)):
    return ((fact[(N - 1)] * inv[2]) % mod)
  for d in A:
    newdp = np.zeros_like(dp)
    newdp += ((dp * factinv[(d - 1)]) % mod)
    if (d >= 2):
      newdp[(1:, (d - 2):u)] += ((dp[(:(- 1), 0:((u + 2) - d))] * factinv[(d - 2)]) % mod)
    dp = (newdp % mod)
  ret = 0
  for n in range(3, (N + 1)):
    for a in range((N + 1)):
      x = ((((a * fact[(n - 1)]) % mod) * fact[((N - n) - 1)]) % mod)
      x = ((((x * inv[2]) % mod) * dp[(n, a)]) % mod)
      ret += x
  return (ret % mod)

A = np.array(read().split(), np.int64)[1:]
print(main(A))

