import sys
from typing import List


def solveequation(edge: List[List[List[int]]], ans: List[int], n: int, m: int) -> List[int]:
    x: List[int] = [0] * m
    used: List[bool] = [False] * n

    def dfs(v: int) -> int:
        used[v] = True
        r: int = ans[v]
        for to, dire, id in edge[v]:
            if used[to]:
                continue
            y: int = dfs(to)
            if dire == -1:
                x[id] = y
            else:
                x[id] = -y
            r += y
            r %= 26
        return r

    for v in range(n):
        if used[v]:
            continue
        y: int = dfs(v)
        if y % 26 != 0:
            return False
    return x


alphabetlist: List[str] = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']
alpha: Dict[str, int] = {i: e for e, i in enumerate(alphabetlist)}


def main():
    S: str = input()
    sys.setrecursionlimit(10 ** 5)
    n: int = len(S)
    N: int = int(input())
    k: int = n // 2

    if n % 2 == 0:
        edge: List[List[List[int]]] = [[[] for i in range(k + 1)]]
        for i in range(N):
            l, r = map(int, input().split())
            l -= 1;
            r -= 1;
            if l > k - 1:
                L: int = n - 1 - r
                R: int = n - 1 - l
                edge[L].append((R + 1, -1, i))
                edge[R + 1].append((L, 1, i))
            elif r > k - 1:
                R: int = n - 1 - r
                if R > l:
                    edge[l].append((R, 1, i))
                    edge[R].append((l, -1, i))
                elif l > R:
                    edge[l].append((R, -1, i))
                    edge[R].append((l, 1, i))
            else:
                edge[l].append((r + 1, 1, i))
                edge[r + 1].append((l, -1, i))
        ans: List[int] = [alpha[S[i]] - alpha[S[-i - 1]] for i in range(k)]
        ans.append(0)
        for i in range(k, 0, -1):
            ans[i] -= ans[i - 1]
        res: List[int] = solveequation(edge, ans, k + 1, N)
        if res:
            print("YES")
        else:
            print("NO")
    else:
        edge: List[List[List[int]]] = [[[] for i in range(k + 1)]]
        for i in range(N):
            l, r = map(int, input().split())
            l -= 1;
            r -= 1;
            if l > k:
                L: int = n - 1 - r
                R: int = n - 1 - l
                edge[L].append((R + 1, -1, i))
                edge[R + 1].append((L, 1, i))
            elif l == k:
                R: int = k - 1
                L: int = n - 1 - r
                edge[L].append((R + 1, -1, i))
                edge[R + 1].append((L, 1, i))
            elif r > k:
                R: int = n - 1 - r
                if R > l:
                    edge[l].append((R, 1, i))
                    edge[R].append((l, -1, i))
                elif l > R:
                    edge[l].append((R, -1, i))
                    edge[R].append((l, 1, i))
            elif r == k:
                edge[l].append((k, 1, i))
                edge[k].append((l, -1, i))
            else:
                edge[l].append((r + 1, 1, i))
                edge[r + 1].append((l, -1, i))
        ans: List[int] = [alpha[S[i]] - alpha[S[-i - 1]] for i in range(k)]
        ans.append(0)
        for i in range(k, 0, -1):
            ans[i] -= ans[i - 1]
        res: List[int] = solveequation(edge, ans, k + 1, N)
        if res:
            print("YES")
        else:
            print("NO")


if __name__ == '__main__':
    main()

