# File changed


def add_edge(adj_l, v_fr, v_to, cap):
    adj_l[v_fr].append([v_to, cap, len(adj_l[v_to])])
    adj_l[v_to].append([v_fr, 0, (len(adj_l[v_fr]) - 1)])

def ford_fulkerson(adj_l, v_st, v_en):

    def dfs(v_now, v_en, f_now):
        if (v_now == v_en):
            return f_now
        used[v_now] = True
        for (i, (v2, cap, i_rev)) in enumerate(adj_l[v_now]):
            if ((not used[v2]) and (cap > 0)):
                df = dfs(v2, v_en, min(f_now, cap))
                if (df > 0):
                    adj_l[v_now][i][1] -= df
                    adj_l[v2][i_rev][1] += df
                    return df
        return 0
    numv = len(adj_l)
    maximumflow = 0
    while True:
        used = ([False] * numv)
        df = dfs(v_st, v_en, float('inf'))
        if (df == 0):
            return maximumflow
        maximumflow += df

n = int(input())
as_ = list(map(int, input().split()))
adjlist = [[] for v in range((n + 2))]
for (i, a) in enumerate(as_, 1):
    if (a <= 0):
        add_edge(adjlist, 0, i, (- a))
    else:
        add_edge(adjlist, i, (n + 1), a)
for i in range(1, (n + 1)):
    for j in range((2 * i), (n + 1), i):
        add_edge(adjlist, i, j, float('inf'))
mf = ford_fulkerson(adjlist, 0, (n + 1))
print((sum([a for a in as_ if (a > 0)]) - mf))



