# File changed


def addEdge(adjL, vFr, vTo, cap):
    adjL[vFr].append([vTo, cap, len(adjL[vTo])])
    adjL[vTo].append([vFr, 0, (len(adjL[vFr]) - 1)])

def Ford_Fulkerson(adjL, vSt, vEn):

    def DFS(vNow, vEn, fNow):
        if (vNow == vEn):
            return fNow
        used[vNow] = True
        for (i, (v2, cap, iRev)) in enumerate(adjL[vNow]):
            if ((not used[v2]) and (cap > 0)):
                df = DFS(v2, vEn, min(fNow, cap))
                if (df > 0):
                    adjL[vNow][i][1] -= df
                    adjL[v2][iRev][1] += df
                    return df
        return 0
    numV = len(adjL)
    MaximumFlow = 0
    while True:
        used = ([False] * numV)
        df = DFS(vSt, vEn, float('inf'))
        if (df == 0):
            return MaximumFlow
        MaximumFlow += df
N = int(input())
As = list(map(int, input().split()))
adjList = []
for v in range((N + 2)):
    adjList.append([])
for (i, A) in enumerate(As, 1):
    if (A <= 0):
        addEdge(adjList, 0, i, (- A))
    else:
        addEdge(adjList, i, (N + 1), A)
for i in range(1, (N + 1)):
    for j in range((2 * i), (N + 1), i):
        addEdge(adjList, i, j, float('inf'))
mf = Ford_Fulkerson(adjList, 0, (N + 1))
print((sum([A for A in As if (A > 0)]) - mf))


