# File changed

import os
import sys
import numpy as np

def solve(inp):

  def bit_add(arr, n, i, x):
    while i <= n:
      arr[i] += x
      i += i & (-i)

  def bit_sum(arr, i):
    result = 0
    while i > 0:
      result += arr[i]
      i ^= i & (-i)
    return result

  n = int(inp[0])
  lim = ((((n * (n - 1)) // 2) + 1) // 2)
  aaa = inp[1::3]
  bbb = inp[2::3]
  ccc = inp[3::3]
  inclinesx = []
  inclinesy = []
  for i in range(n):
    inclinesx.append(((aaa[i] / bbb[i]), i))
    inclinesy.append(((bbb[i] / aaa[i]), i))
  inclinesx.sort()
  inclinesy.sort()
  inclinerankx = np.zeros(n, dtype=np.int64)
  inclineranky = np.zeros(n, dtype=np.int64)
  for k in range(n):
    inclinerankx[inclinesx[k][1]] = (n - k)
    inclineranky[inclinesy[k][1]] = (n - k)

  def check_x(m):
    yyy = []
    for i in range(n):
      yyy.append((((ccc[i] - (aaa[i] * m)) / bbb[i]), i))
    yyy.sort()
    bit = np.zeros((n + 1), dtype=np.int64)
    intersectionleft = 0
    for j in range(n):
      i = yyy[j][1]
      k = inclinerankx[i]
      intersectionleft += bit_sum(bit, k)
      bit_add(bit, n + 1, k, 1)
    return intersectionleft >= lim

  def check_y(m):
    xxx = []
    for i in range(n):
      xxx.append((((ccc[i] - (bbb[i] * m)) / aaa[i]), i))
    xxx.sort()
    bit = np.zeros((n + 1), dtype=np.int64)
    intersectionleft = 0
    for j in range(n):
      i = xxx[j][1]
      k = inclineranky[i]
      intersectionleft += bit_sum(bit, k)
      bit_add(bit, n + 1, k, 1)
    return intersectionleft >= lim

  l = -2 * (10 ** 8)
  r = 2 * (10 ** 8)
  while r - l > 1e-09 and abs((r - l) / l if l != 0 else r) > 1e-09:
    m = (l + r) / 2
    if check_x(m):
      r = m
    else:
      l = m
  x = l
  l = -2 * (10 ** 8)
  r = 2 * (10 ** 8)
  while r - l > 1e-09 and abs((r - l) / l if l != 0 else r) > 1e-09:
    m = (l + r) / 2
    if check_y(m):
      r = m
    else:
      l = m
  y = l
  return x, y

if sys.argv[-1] == 'ONLINE_JUDGE':
  from numba.pycc import CC
  cc = CC('my_module')
  cc.export('solve', '(f8[:],)')(solve)
  cc.compile()
  exit()
if os.name == 'posix':
  from my_module import solve
else:
  from numba import njit
  solve = njit('(f8[:],)', cache=True)(solve)
inp = np.fromstring(sys.stdin.buffer.read(), dtype=np.float64, sep=' ')
try:
  x, y = solve(inp)
  print(x, y)
except ZeroDivisionError:
  print('WA')
  exit()

