def extgcd(a, b):
  if b == 0:
    return 1
  else:
    x, y, u, v, k, l = 1, 0, 0, 1, a, b
    while l != 0:
      x, y, u, v = u, v, x - u * (k // l), y - v * (k // l)
      k, l = l, k % l
    return x
def inved(x, m):
  return x % m
def gcd(x, y):
  while y != 0:
    x, y = y, x % y
  return x
def doubling(n, m, mod):
  y = 1
  base = n
  while m != 0:
    if m % 2 == 1:
      y *= base
      y %= mod
    base *= base
    base %= mod
    m //= 2
  return y
def factorization(n):
  if n == 1:
    return {1: 1}
  else:
    D = {}
    base = n
    p = 2
    while n != 1:
      i = 0
      while n % p == 0:
        i += 1
        n //= p
      if i != 0:
        D[p] = i
      p += 1
      if p * p > base and n != 1:
        D[n] = 1
        break
    return D
def Torshent(n):
  dic = factorization(n)
  S = n
  for i in dic:
    S //= i
    S *= i - 1
  return S
def bin_digits(n):
  cnt = 0
  while n != 0:
    cnt += 1
    n //= 2
  return cnt
def Resque(a, mod):
  if mod == 1:
    return 1
  M = Torshent(mod)
  MM = gcd(M, mod)
  R = Resque(a, MM)
  k = doubling(a, R, mod)
  m, modmod = M // MM, mod // MM
  Tm = Torshent(modmod)
  invm = doubling(m, Tm-1, modmod)
  t = ((k - R) // MM) * invm
  R += t * M
  R %= (mod * M // MM)
  R += (mod * M // MM)
  return R

#---------------------------------------------------------------#

@pytest.mark.parametrize('A, M, R', [
  (1, 1, 1),
  (1, 2, 1),
  (1, 3, 1),
  (1, 4, 1),
  (1, 5, 1),
  (1, 6, 1),
  (1, 7, 1),
  (1, 8, 1),
  (1, 9, 1),
  (1, 10, 1),
  (1, 11, 1),
  (1, 12, 1),
  (1, 13, 1),
  (1, 14, 1),
  (1, 15, 1),
  (1, 16, 1),
  (1, 17, 1),
  (1, 18, 1),
  (1, 19, 1),
  (1, 20, 1),
  (1, 21, 1),
  (1, 22, 1),
  (1, 23, 1),
  (1, 24, 1),
  (1, 25, 1),
  (1, 26, 1),
  (1, 27, 1),
  (1, 28, 1),
  (1, 29, 1),
  (1, 30, 1),
  (1, 31, 1),
  (1, 32, 1),
  (1, 33, 1),
  (1, 34, 1),
  (1, 35, 1),
  (1, 36, 1),
  (1, 37, 1),
  (1, 38, 1),
  (1, 39, 1),
  (1, 40, 1),
  (1, 41, 1),
  (1, 42, 1),
  (1, 43, 1),
 