# File changed


def extgcd(a, b):
    'Finds the greatest common divisor of two numbers

    Args:
        a (int): The first number.
        b (int): The second number.

    Returns:
        int: The greatest common divisor of a and b.
    '
    if (b == 0):
        return 1
    else:
        (x, y, u, v, k, l) = (1, 0, 0, 1, a, b)
        while (l != 0):
            (x, y, u, v) = (u, v, (x - (u * (k // l))), (y - (v * (k // l))))
            (k, l) = (l, (k % l))
        return x

def inved(x, m):
    'Finds the inverse of x mod m

    Args:
        x (int): The number to find the inverse of.
        m (int): The modulus.

    Returns:
        int: The inverse of x mod m.
    '
    return (x % m)

def gcd(x, y):
    'Finds the greatest common divisor of two numbers

    Args:
        x (int): The first number.
        y (int): The second number.

    Returns:
        int: The greatest common divisor of x and y.
    '
    while (y != 0):
        (x, y) = (y, (x % y))
    return x

def doubling(n, m, mod):
    'Finds the value of n^m mod mod

    Args:
        n (int): The number to raise to a power.
        m (int): The power to raise n to.
        mod (int): The modulus.

    Returns:
        int: The value of n^m mod mod.
    '
    y = 1
    base = n
    while (m != 0):
        if ((m % 2) == 1):
            y *= base
            y %= mod
        base *= base
        base %= mod
        m //= 2
    return y

def factorization(n):
    'Finds the prime factorization of n

    Args:
        n (int): The number to factorize.

    Returns:
        dict: The prime factorization of n.
    '
    if (n == 1):
        return {1: 1}
    else:
        D = {}
        base = n
        p = 2
        while (n != 1):
            i = 0
            while ((n % p) == 0):
                i += 1
                n //= p
            if (i != 0):
                D[p] = i
            p += 1
            if (((p * p) > base) and (n != 1)):
                D[n] = 1
                break
        return D

def Torshent(n):
    'Finds the Torshent of n

    Args:
        n (int): The number to find the Torshent of.

    Returns:
        int: The Torshent of n.
    '
    dic = factorization(n)
    S = n
    for i in dic:
        S //= i
        S *= (i - 1)
    return S

def bin_digits(n):
    'Finds the number of binary digits in n

    Args:
        n (int): The number to find the binary digits of.

    Returns:
        int: The number of binary digits in n.
    '
    cnt = 0
    while (n != 0):
        cnt += 1
        n //= 2
    return cnt

def Resque(a, mod):
    'Finds the Resque of a mod mod

    Args:
        a (int): The number to find the Resque of.
        mod (int): The modulus.

    Returns:
        int: The Resque of a mod mod.
    '
    if (mod == 1):
        return 1
    M = Torshent(mod)
    MM = gcd(M, mod)
    R = Resque(a, MM)
    k = doubling(a, R, mod)
    (m, modmod) = ((M // MM), (mod // MM))
    Tm = Torshent(modmod)
    invm = doubling(m, (Tm - 1), modmod)
    t = (((k - R) // MM) * invm)
    R += (t * M)
    R %= ((mod * M) // MM)
    R += ((mod * M) // MM)
    return R
Q = int(input())
for i in range(Q):
    (A, M) = map(int, input().split())
    if (M == 