# File changed

from itertools import permutations

def warshall_floyd(v_count: int, matrix: list) -> list:
    'Performs the Warshall-Floyd algorithm on the given matrix

    Args:
        v_count (int): The number of vertices in the graph.
        matrix (list): The adjacency matrix of the graph.

    Returns:
        list: The shortest path matrix.
    '
    for i in range(v_count):
        for (j, c2) in enumerate((row[i] for row in matrix)):
            for (k, (c1, c3)) in enumerate(zip(matrix[j], matrix[i])):
                if (c1 > (c2 + c3)):
                    matrix[j][k] = (c2 + c3)
    return matrix
INF = (10 ** 9)
(N, M, R) = map(int, input().split())
m = [[INF for i in range(N)] for j in range(N)]
for i in range(N):
    m[i][i] = 0
r = list(map((lambda x: (int(x) - 1)), input().split()))
for i in range(M):
    (a, b, c) = map(int, input().split())
    m[(a - 1)][(b - 1)] = c
    m[(b - 1)][(a - 1)] = c
m = warshall_floyd(N, m)
ans = INF
for path in permutations(r, R):
    tmp = 0
    for i in range((len(path) - 1)):
        tmp += m[path[(i + 1)]][path[i]]
    ans = min(ans, tmp)
print(ans)


