' Find the least common multiple of a list of numbers
'
import fractions
from functools import reduce

def lcm_base(x, y):
    ' Calculate the least common multiple of two numbers

    Args:
        x (int): The first number.
        y (int): The second number.

    Returns:
        int: The least common multiple of x and y.
    '
    return ((x * y) // fractions.gcd(x, y))

def lcm_list(numbers):
    ' Calculate the least common multiple of a list of numbers

    Args:
        numbers (list): The list of numbers.

    Returns:
        int: The least common multiple of the numbers.
    '
    return reduce(lcm_base, numbers, 1)
n = int(input())
t = [int(input()) for i in range(n)]
print(lcm_list(t))


