# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import itertools
import numpy as np
from functools import lru_cache
from operator import itemgetter
X = list(map(int, readline().split()))
Y = list(map(int, readline().split()))
for i in [1, 3, 5]:
    X[i] += 1
    Y[i] += 1
X1 = X[:2]
X2 = X[2:4]
X3 = X[4:]
Y1 = Y[:2]
Y2 = Y[2:4]
Y3 = Y[4:]

def cumprod(arr, MOD):
    'Calculates the cumulative product of an array

    Args:
        arr (np.array): The array to calculate the cumulative product of.
        MOD (int): The modulo to use.

    Returns:
        np.array: The cumulative product of the array.
    '
    L = len(arr)
    Lsq = int(((L ** 0.5) + 1))
    arr = np.resize(arr, (Lsq ** 2)).reshape(Lsq, Lsq)
    for n in range(1, Lsq):
        arr[:, n] *= arr[:, (n - 1)]
        arr[:, n] %= MOD
    for n in range(1, Lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:L]

def make_fact(U, MOD):
    'Calculates the factorial of a number

    Args:
        U (int): The number to calculate the factorial of.
        MOD (int): The modulo to use.

    Returns:
        np.array: The factorial of the number.
    '
    x = np.arange(U, dtype=np.int64)
    x[0] = 1
    fact = cumprod(x, MOD)
    x = np.arange(U, 0, (- 1), dtype=np.int64)
    x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
    fact_inv = cumprod(x, MOD)[::(- 1)]
    return (fact, fact_inv)
U = ((2 * (10 ** 6)) + 10)
MOD = ((10 ** 9) + 7)
(fact, fact_inv) = make_fact(U, MOD)

@lru_cache(8)
def make_comb(n):
    'Calculates the combination of a number

    Args:
        n (int): The number to calculate the combination of.

    Returns:
        np.array: The combination of the number.
    '
    return ((((fact[n] * fact_inv[:(n + 1)]) % MOD) * fact_inv[:(n + 1)][::(- 1)]) % MOD)
answer = 0
tasks = []
for p in itertools.product([0, 1], repeat=6):
    (x1, x2, x3, y1, y2, y3) = [A[i] for (A, i) in zip([X1, X2, X3, Y1, Y2, Y3], p)]
    sgn = ((- 1) ** sum(p))
    (a, b, c, d) = ((x2 - x1), (x3 - x2), (((x2 - x1) + y2) - y1), (((x3 - x2