# File changed

import sys
from collections import Counter

def read_int_list():
  return list(map(int, input().split()))

def read_int():
  return int(input())

def read_str_list():
  return input().split()

def read_str():
  return input()

def solve():
  n, h = read_int_list()
  a, b, c, d = zip(*[read_int_list() for _ in range(n)])
  nnodes = 2*h+1
  nedges = n
  adj = [[] for _ in range(nnodes)]
  radj = [[] for _ in range(nnodes)]
  for i in range(nedges):
    if c[i] == 0:
      l = a[i]
    else:
      l = -c[i]
    if d[i] == 0:
      r = -b[i]
    else:
      r = d[i]
    adj[l+h].append(r+h)
    radj[r+h].append(l+h)
  indegree = Counter()
  outdegree = Counter()
  for i in range(nnodes):
    for j in adj[i]:
      outdegree[i] += 1
      indegree[j] += 1
  for i in range(nnodes):
    if i < h:
      if not (outdegree[i] <= indegree[i]):
        return 'NO'
    if h < i:
      if not (indegree[i] <= outdegree[i]):
        return 'NO'
  state = [0] * nnodes

  def dfs(root):
    res = False
    state[root] = 1
    for i in adj[root]:
      if state[i] == 0:
        res |= dfs(i)
    for i in radj[root]:
      if state[i] == 0:
        res |= dfs(i)
    state[root] = 2
    if (indegree[root], outdegree[root]) == (0, 0):
      return True
    res |= (indegree[root] != outdegree[root])
    return res
  for i in range(nnodes):
    if state[i] == 0:
      if not dfs(i):
        return 'NO'
  return 'YES'

def main():
  res = solve()
  print(res)

if __name__ == '__main__':
  main()

