
class BIT(object):

    def __init__(self, n):
        self.n=n
        self.lst=[0]*(n+1)

    def put(self, i):
        while(i<=self.n):
            self.lst[i]+=1
            i+=(i&-i)

    def get(self, i):
        ret=0
        while(i!=0):
            ret+=self.lst[i]
            i-=(i&-i)
        return ret

@pytest.mark.parametrize('n, k, a, ret', [
    (1, 1, [(0, 1)], 1),
    (2, 1, [(0, 1), (1, 2)], 2),
    (3, 1, [(0, 1), (1, 2), (2, 3)], 3),
    (3, 2, [(0, 1), (1, 2), (2, 3)], 2),
    (3, 3, [(0, 1), (1, 2), (2, 3)], 1),
    (3, 4, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 5, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 6, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 7, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 8, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 9, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 10, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 11, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 12, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 13, [(0, 1), (1, 2), (2, 3)], 0),
    (3, 14, [(0,