# File changed

import sys

def merge_delay_pattern(k, half1, half2):
  len1 = len(half1)
  len2 = len(half2)
  start, delay1next = half1[0]
  start2 = half2[0][0]
  time1 = start - start2
  midstart = (start + time1 + delay1next)
  offset2numperiod = (midstart - start2) // k
  offset2phase = midstart - (offset2numperiod * k)
  for head2 in range(len2):
    if half2[head2][0] >= offset2phase:
      head2 -= 1
      break
  head2 += (offset2numperiod * len2)
  head1 = 0
  ret = []
  prev = ()
  half1.append((start + k, None))
  pos1next = start
  pos2next, delay2next = half2[(head2 % len2)]
  pos2next += ((head2 // len2) * k)
  mid = pos2next
  while True:
    if mid <= pos2next:
      if head1 == len1:
        break
      head1 += 1
      pos1, delay1 = pos1next, delay1next
      pos1next, delay1next = half1[head1]
    if pos2next <= mid:
      head2 += 1
      pos2, delay2 = pos2next, delay2next
      pos2next, delay2next = half2[(head2 % len2)]
      pos2next += ((head2 // len2) * k)
    if delay1 == 0:
      mid = pos1next + time1
      if delay2 == 0:
        if prev is not None:
          ret.append((start, 0))
          prev = None
      else:
        delay = (pos2 + delay2 - time1 - start)
        if prev != (start + delay):
          ret.append((start, delay))
          prev = (start + delay)
      if pos2next <= mid:
        start = pos2next - time1
      else:
        start = pos1next
    else:
      mid = pos1 + time1 + delay1
      if mid <= pos2next:
        if delay2 == 0:
          delay = delay1
        else:
          delay = pos2 + delay2 - time1 - start
        if prev != (start + delay):
          ret.append((start, delay))
          prev = (start + delay)
        start = pos1next
  return ret

def get_delay_pattern(k, data, first, last):
  if last - first == 1:
    return data[first]
  middle = (first + last) // 2
  half1 = get_delay_pattern(k, data, first, middle)
  half2 = get_delay_pattern(k, data, middle, last)
  return merge_delay_pattern(k, half1, half2)

def solve():
  data = []
  intlist = [int(s) for s in sys.stdin.read().split()]
  n = intlist[0]
  k = intlist[1]
  position = 0
  for i in range(2, (n + 1) * 2, 2):
    a = intlist[i]
    b = intlist[(i + 1)]
    if b == 1:
      a2 = a * 2
      if k < a2:
        return -1
      data.append([(position, 0), ((position + k - a2), a2)])
    position += a
  if not data:
    return position * 2
  delaypattern = get_delay_pattern(k, data, 0, len(data))
  patadjpairs = zip(delaypattern, (delaypattern[1:] + [(delaypattern[0][0] + k, None)]))
  delaylist = (pos + delay - next_pos for pos, delay, next_pos in patadjpairs if delay)
  return (position * 2 + min(delaylist, default=0))

print(solve())

