# File changed


def graph(inp):
    nodes = dict()
    N = None
    for line in inp.splitlines():
        if (N is None):
            N = int(line.strip())
            for k in range(1, (N + 1)):
                nodes[k] = set()
            continue
        (i, k) = map(int, line.split())
        nodes[i].add(k)
        nodes[k].add(i)
    return nodes

def trace(nodes, start, exclude=None):
    return ((start,) + max([trace(nodes, n, exclude=start) for n in nodes[start] if (n != exclude)], key=len, default=()))

def tree(nodes, start, exclude=None):
    return tup([tree(nodes, n, exclude=start) for n in nodes[start] if (n != exclude)])

class tup(tuple):

    def __new__(cls, arg=()):
        rv = super().__new__(cls, arg)
        rv.height = ((1 + min((t.height[0] for t in rv), default=(- 1))), (1 + max((t.height[1] for t in rv), default=(- 1))))
        rv.edges = (len(rv) + sum((t.edges for t in rv)))
        return rv

def combinations(nodes):
    path = trace(nodes, trace(nodes, next(iter(nodes)))[(- 1)])
    d = len(path)
    c = (d // 2)
    root = path[(d // 2)]
    if (d % 2):
        thetree = tree(nodes, root)
        return sum((enum(limits, thetree) for limits in zip(range((c + 1)), reversed(range((c + 1))))))
    else:
        left = path[((d // 2) - 1)]
        lefttree = tup([tree(nodes, left, exclude=root)])
        righttree = tree(nodes, root, exclude=left)
        lg = [(i // 2) for i in range(1, ((c * 2) + 2))]
        ll = list(zip(lg, reversed(lg)))
        rg = [(i // 2) for i in range(((c * 2) + 1))]
        rl = list(zip(rg, reversed(rg)))
        tot = 0
        for i in range(len(ll)):
            leftlimits = ll[i]
            rightlimits = rl[i]
            lrv = ((enum(leftlimits, lefttree) - sum((enum(ne, lefttree) for ne in (ll[(i - 1):i] + ll[(i + 1):(i + 2)])))) if (sum(leftlimits) > c) else enum(leftlimits, lefttree))
            rrv = enum(rightlimits, righttree)
            tot += (lrv * rrv)
        return tot

def enum(limits, shape, _cache=dict()):
    limits = tuple(sorted(limits))
    (r, b) = limits
    (low, high) = shape.height
    if (r >= high):
        return (2 ** shape.edges)
    if (0 in limits):
        return 1
    key = hash((r, b, shape))
    if (key not in _cache):
        tot = 1
        for subtree in shape:
            acc = 0
            for sublimit in (((r - 1), b), (r, (b - 1))):
                acc += enum(sublimit, subtree)
            tot *= acc
        _cache[key] = tot
    return _cache[key]
import sys
sys.setrecursionlimit(99999)
g = graph(sys.stdin.read())
rv = combinations(g)
print((rv % ((10 ** 9) + 7)))

