# File changed

from fractions import gcd

def readln(ch):
    'Reads a line from stdin and splits it by the given character

    Args:
        ch (str): The character to split the line by.

    Returns:
        list: A list of integers from the line.
    '
    _res = list(map(int, str(input()).split(ch)))
    return _res

def count(a):
    'Counts the number of odd and even numbers in the given list

    Args:
        a (list): The list to count.

    Returns:
        tuple: A tuple containing the number of odd and even numbers.
    '
    (odd, even) = (0, 0)
    for x in a:
        if ((x % 2) == 1):
            odd = (odd + 1)
        else:
            even = (even + 1)
    return (odd, even)

def deal(n, a):
    'Checks if the given list can be split into two lists with the same sum

    Args:
        n (int): The number of elements in the list.
        a (list): The list to check.

    Returns:
        bool: True if the list can be split into two lists with the same sum, False otherwise.
    '
    (odd, even) = count(a)
    if (even == 0):
        return False
    if ((even % 2) == 1):
        return True
    if (odd > 1):
        return False
    if ((a[0] % 2) == 0):
        res = a[0]
    else:
        res = a[1]
    for i in range(0, n):
        if ((a[i] % 2) == 1):
            if (a[i] == 1):
                return False
            a[i] = (a[i] - 1)
        res = gcd(a[i], res)
    return (not deal(n, list(map((lambda x: (x // res)), a))))
n = int(input())
a = readln(' ')
if deal(n, a):
    print('First')
else:
    print('Second')


