import sys
from bisect import bisect


class BinaryIndexedTree:

    def __init__(self, n, MOD):
        self.size = n + 1
        self.tree = [0] * (n + 2)
        self.MOD = MOD

    def sum(self, i):
        i += 1
        s = 0
        while i > 0:
            s = (s + self.tree[i]) % self.MOD
            i -= i & -i
        return s

    def add(self, i, x):
        i += 1
        while i <= self.size:
            self.tree[i] = (self.tree[i] + x) % self.MOD
            i += i & -i

    def debug_print(self, limit=None):
        if limit is None:
            limit = self.size
        acc = [0] + [self.sum(i) for i in range(limit)]
        aaa = [a1 - a0 for a0, a1 in zip(acc, acc[1:])]
        print(aaa)


@pytest.mark.parametrize('n, a, b, sss, expected', [
    (1, 1, 1, [1], 1),
    (2, 1, 1, [1, 2], 1),
    (2, 1, 1, [1, 1], 0),
    (3, 1, 1, [1, 2, 3], 1),
    (3, 1, 1, [1, 1, 3], 0),
    (3, 1, 1, [1, 2, 2], 0),
    (3, 1, 1, [1, 2, 1], 0),
    (3, 1, 1, [1, 1, 2], 0),
    (3, 1, 1, [1, 1, 1], 0),
    (3, 1, 2, [1, 2, 3], 1),
    (3, 1, 2, [1, 1, 3], 0),
    (3, 1, 2, [1, 2, 2], 0),
    (3, 1, 2, [1, 2, 1], 0),
    (3, 1, 2, [1, 1, 2], 0),
    (3, 1, 2, [1, 1, 1], 0),
    (3, 2, 2, [1, 2, 3], 1),
    (3, 2, 2, [1, 1, 3], 0),
    (3, 2, 2, [1, 2, 2], 0),
    (3, 2, 2, [1, 2, 1], 0),
    (3, 2, 2, [1, 1, 2], 0),
    (3, 2, 2, [1, 1, 1], 0),
    (3, 2, 3, [1, 2, 3], 1),
    (3, 2, 3, [1, 1, 3], 0),
    (3, 2, 3, [1, 2, 2], 0),
    (3, 2, 3, [1, 2, 1], 0),
    (3, 2, 3, [1, 1, 2], 0),
    (3, 2, 3, [1, 1, 1], 0),
    (3, 3, 3, [1, 2, 3], 1),
    (3, 3, 3, [1, 1, 3], 0),
    (