import sys
import json
import itertools
infinity = 100000000

def parse_data(input_string):
  inf = infinity
  firstnl = input_string.index('\n')
  n = int(input_string[:firstnl])
  favpattern = [(int(s) * inf) for s in input_string[((-n) - 1):(-1)]]
  edges = json.loads((('[' + input_string[(firstnl + 1):((-n) - 2)].replace(' ', ',').replace('\n', ',')) + ']'))
  graph = [[] for _ in range(n)]
  graph[0].append(None)
  for i in range(0, ((n - 1) * 2), 2):
    a = (edges[i] - 1)
    b = (edges[(i + 1)] - 1)
    graph[a].append(b)
    graph[b].append(a)
  return (n, favpattern, graph)

def solve():
  inf = infinity
  (n, favcount, graph) = parse_data(sys.stdin.read())
  height1 = ([0] * n)
  height2 = ([0] * n)
  dfsorder = []
  stack = [None, 0, 0]
  while True:
    node = stack[(-1)]
    index = stack[(-2)]
    if (index < len(graph[node])):
      dtr = graph[node][index]
      stack[(-2)] += 1
      if (dtr != stack[(-3)]):
        stack.extend((0, dtr))
        dfsorder.append(dtr)
      else:
        (graph[node][0], graph[node][index]) = (dtr, graph[node][0])
    else:
      del stack[(-2):]
      if (len(stack) <= 1):
        break
      parent = stack[(-1)]
      dtrheight = (height1[node] + 1)
      if (dtrheight >= height1[parent]):
        (height1[parent], height2[parent]) = (dtrheight, height1[parent])
      elif (dtrheight > height2[parent]):
        height2[parent] = dtrheight
      if (favcount[node] != 0):
        favcount[parent] += 1
  answer = 0
  if (favcount[0] >= inf):
    lb = (-1)
  else:
    lb = min((height1[dtr] for dtr in graph[0][1:] if (favcount[dtr] != 0)), default=inf)
  ub = height2[0]
  if (ub > lb):
    answer += (ub - lb)
  for node in dfsorder:
    parent = graph[node][0]
    hasfavbelow = (favcount[node] != 0)
    hasfavabove = (favcount[parent] > hasfavbelow)
    favcount[node] += hasfavabove
    nodeheight = height1[node]
    if ((nodeheight + 1) == height1[parent]):
      lb = height2[parent]
      if ((lb <= nodeheight) and hasfavabove):
        answer += 1
      elif ((lb >= nodeheight) and hasfavbelow):
        answer += 1
      parentheight = (lb + 1)
      if (parentheight >= nodeheight):
        (height1[node], height2[node]) = (parentheight, nodeheight)
      elif (parentheight > height2[node]):
        height2[node] = parentheight
    else:
      answer += hasfavbelow
      lb = height1[parent]
      (height1[node], height2[node]) = ((lb + 1), nodeheight)
    if (favcount[node] >= inf):
      lb = (-1)
    else:
      if (not hasfavabove):
        lb = inf
      for dtr in itertools.islice(graph[node], 1, None):
        if (favcount[dtr] != 0):
          lb = min(height1[dtr], lb)
    ub = height2[node]
    if (ub > lb):
      answer += (ub - lb)
  print(answer)

solve()

