import pytest

@pytest.mark.parametrize('n, a, d, ok, expected', [
    (1, [1], {1: 1}, True, 2),
    (2, [1, 2], {1: 1, 2: 1}, False, 0),
    (3, [1, 2, 3], {1: 1, 2: 1, 3: 1}, True, 8),
    (4, [1, 2, 3, 4], {1: 1, 2: 1, 3: 1, 4: 1}, False, 0),
    (5, [1, 2, 3, 4, 5], {1: 1, 2: 1, 3: 1, 4: 1, 5: 1}, True, 32),
    (6, [1, 2, 3, 4, 5, 6], {1: 1, 2: 1, 3: 1, 4: 1, 5: 1, 6: 1}, False, 0),
    (7, [1, 2, 3, 4, 5, 6, 7], {1: 1, 2: 1, 3: 1, 4: 1, 5: 1, 6: 1, 7: 1}, True, 128),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], {1: 1, 2: 1, 3: 1, 4: 1, 5: 1, 6: 1, 7: 1, 8: 1}, False, 0),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], {1: 1, 2: 1, 3: 1, 4: 1, 5: 1, 6: 1, 7: 1, 8: 1, 9: 1}, True, 512),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], {1: 1, 2: 1, 3: 1, 4: 1, 5: 1, 6: 1, 7: 1, 8: 1, 9: 1, 10: 1}, False, 0),
])
def test_that_api_returns_some_results(n, a, d, ok, expected):
    n = int(n)
    a = [int(x) for x in a]
    d = {}
    for x in a:
        d[x] = d.get(x, 0) + 1
    ok = True
    for i in range(1 + n % 2, n, 2):
        if i not in d or d[i] != 2:
            ok = False
            break
    if ok: assert pow(2, n//2, 10**9+7) == expected
    else: assert 0 == expected

