def solve(n, inp):
    if n == 1:
        return int(inp[0])

    INF = -(10 ** 18)

    dp1, dp2, dp3 = int(inp[0]), INF, INF
    for op, a in zip(inp[1::2], inp[2::2]):
        a = int(a)
        if op == '+':
            dp1, dp2, dp3 = dp1 + a, max(dp2 - a, dp3 + a), dp3 + a
        else:
            dp1, dp2, dp3 = max(dp1 - a, dp2 + a), max(dp1 - a, dp2 + a), max(dp2 + a, dp3 - a)

    return dp1


@pytest.mark.parametrize('n, inp, expected', [
    (1, '1', 1),
    (2, '1 2', 2),
    (3, '1 2 +', 3),
    (4, '1 2 + 3', 4),
    (5, '1 2 + 3 +', 5),
    (6, '1 2 + 3 + 4', 6),
    (7, '1 2 + 3 + 4 +', 7),
    (8, '1 2 + 3 + 4 + 5', 8),
    (9, '1 2 + 3 + 4 + 5 +', 9),
    (10, '1 2 + 3 + 4 + 5 + 6', 10),
    (11, '1 2 + 3 + 4 + 5 + 6 +', 11),
    (12, '1 2 + 3 + 4 + 5 + 6 + 7', 12),
    (13, '1 2 + 3 + 4 + 5 + 6 + 7 +', 13),
    (14, '1 2 + 3 + 4 + 5 + 6 + 7 + 8', 14),
    (15, '1 2 + 3 + 4 + 5 + 6 + 7 + 8 +', 15),
    (16, '1 2 + 3 + 4 + 5 + 6 + 7 + 8 + 9', 16),
    (17, '1 2 + 3 + 4 + 5 + 6 + 7 + 8 + 9 +', 17),
    (18, '1 2 + 3 + 4 + 5 + 6 + 7 + 8 + 9 + 10', 18),
    (19, '