import sys
readline = sys.stdin.readline
readlines = sys.stdin.readlines

import numpy as np

N = int(readline())
LR = [tuple(int(x) for x in line.split()) for line in readlines()]

"""
・奇数個のとき：中央にどれかを固定。
・偶数のとき：原点で左右に分けるとしてよい。
・基本的に長さで内側から昇順（奇数のときの中央は謎）。→ソートしてdpできる。
・左に置いた個数をもってdp更新。また、中央を使ったかも同時に持って。
・偶数のときは、中央に1つ置いた状態から始める。
・大きい区間から外側に入れていく。
"""

LR.sort(key=lambda x: -x[1] - x[0])

INF = 10 ** 18
dp_0 = np.full(N + 1, INF, np.int64)  # 左に置いた個数 → コスト。中央未確定。
dp_1 = np.full(N + 1, INF, np.int64)  # 左に置いた個数 → コスト。中央確定。
if N & 1:
    dp_0[0] = 0
else:
    dp_1[0] = 0
for n, (L, R) in enumerate(LR):
    length = R + L
    prev_0 = dp_0
    prev_1 = dp_1
    dp_0 = np.full(N + 1, INF, np.int64)
    dp_1 = np.full(N + 1, INF, np.int64)
    x = np.arange(n + 1, dtype=np.int64)