class BisectSearch:
    def __init__(self, f, l=0, r=10**9):
        self.f = f
        self.l = l
        self.r = r
    def __call__(self, dist):
        f = self.f
        l = self.l
        r = self.r
        if dist <= f(l):
            return l
        if f(r) <= dist:
            return r
        while r-l > 1:
            n = (r+l) // 2
            if f(n) <= dist:
                l = n
            else:
                r = n
        return l

@pytest.mark.parametrize('n, m', [(1, 1), (2, 1), (3, 2), (4, 2), (5, 3), (6, 3), (7, 4), (8, 4), (9, 5), (10, 5), (11, 6), (12, 6), (13, 7), (14, 7), (15, 8), (16, 8), (17, 9), (18, 9), (19, 10), (20, 10), (21, 11), (22, 11), (23, 12), (24, 12), (25, 13), (26, 13), (27, 14), (28, 14), (29, 15), (30, 15), (31, 16), (32, 16), (33, 17), (34, 17), (35, 18), (36, 18), (37, 19), (38, 19), (39, 20), (40, 20), (41, 21), (42, 21), (43, 22), (44, 22), (45, 23), (46, 23), (47, 24), (48, 24), (49, 25), (50, 25), (51, 26), (52, 26), (53, 27), (54, 27), (55, 28), (56, 28), (57, 29), (58, 29), (59, 30), (60, 30), (61, 31), (62, 31), (63, 32), (64, 32), (65, 33), (66, 33), (67, 34), (68, 34), (69, 35), (70, 35), (71, 36), (72, 36), (73, 37), (74, 37), (75, 38), (76, 38), (77, 39), (78, 39), (79,