# File changed


class BisectSearch():

    def __init__(self, f, l=0, r=(10 ** 9)):
        'Initializes the BisectSearch class

        Args:
            f (function): The function to perform the search on.
            l (int, optional): Defaults to 0. The left bound of the search.
            r (int, optional): Defaults to (10 ** 9). The right bound of the search.
        '
        self.f = f
        self.l = l
        self.r = r

    def __call__(self, dist):
        'Performs the search

        Args:
            dist (int): The distance to search for.

        Returns:
            int: The result of the search.
        '
        f = self.f
        l = self.l
        r = self.r
        if (dist <= f(l)):
            return l
        if (f(r) <= dist):
            return r
        while ((r - l) > 1):
            n = ((r + l) // 2)
            if (f(n) <= dist):
                l = n
            else:
                r = n
        return l
n = int(input())

def f(n):
    'The function to perform the search on

    Args:
        n (int): The input to the function.

    Returns:
        int: The result of the function.
    '
    return (((n + 1) * n) // 2)
m = BisectSearch(f, l=1, r=(10 ** 7))(n)
m += (f(m) != n)
A = set()
for i in range(m, 0, (- 1)):
    if ((n - i) >= 0):
        A.add(i)
        n -= i
print(*A, sep='\n')


