# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
(N, A) = map(int, read().split())
'\nPerforms an analysis on the historical data

Args:
    historical_data (list): A matrix of historical OHCLV data.
    period_count (int, optional): Defaults to 14. The number of data points to consider for
        our RSI.
    signal (list, optional): Defaults to rsi. The indicator line to check hot/cold
        against.
    hot_thresh (float, optional): Defaults to None. The threshold at which this might be
        good to purchase.
    cold_thresh (float, optional): Defaults to None. The threshold at which this might be
        good to sell.

Returns:
    pandas.DataFrame: A dataframe containing the indicators and hot/cold values.
'

def F(K):
    n = int((N ** (1 / K)))
    while (((n - 1) * (n ** (K - 1))) > N):
        n -= 1
    while ((n * ((n + 1) ** (K - 1))) < N):
        n += 1
    for y in range(K):
        x = (K - y)
        if (((n ** x) * ((n + 1) ** y)) >= N):
            break
    cost = (((A * (K - 1)) + (n * x)) + ((n + 1) * y))
    return cost
answer = min((F(K) for K in range(1, 50)))
print(answer)


