import pytest

def solve(n, d, x):
    ans = 0
    while n:
        ans += d + (2 * n - 1) * x / 2
        d = ((n + 1) * d + 5 * x / 2) / n
        x *= (n + 2) / n
        n -= 1
    return ans

@pytest.mark.parametrize('n, d, x, expected', [
    (1, 1, 1, 1.0),
    (2, 1, 1, 1.5),
    (3, 1, 1, 1.8333333333),
    (4, 1, 1, 2.0833333333),
    (5, 1, 1, 2.25),
    (6, 1, 1, 2.3571428571),
    (7, 1, 1, 2.4411764706),
    (8, 1, 1, 2.4970588235),
    (9, 1, 1, 2.5396825397),
    (10, 1, 1, 2.5747126436),
])
def test_solve(n, d, x, expected):
    assert solve(n, d, x) == pytest.approx(expected, abs=1e-10)

