import pytest

@pytest.mark.parametrize('N, A, expected', [
    (1, [1], 0),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 3),
    (4, [1, 2, 3, 4], 6),
    (5, [1, 2, 3, 4, 5], 10),
    (6, [1, 2, 3, 4, 5, 6], 15),
    (7, [1, 2, 3, 4, 5, 6, 7], 21),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 28),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 36),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 45),
])
def test_count_divisors(N, A, expected):
    count = A[0] - 1
    tmp = 2

    for a in A[1:]:
        count += (a - 1) // tmp
        if tmp == a:
            tmp += 1

    assert count == expected

