# File changed


class TrieNode():

    def __init__(self):
        self.child = {}
        self.count = 0

class Trie():

    def __init__(self):
        self.root = TrieNode()

    def add(self, s):
        node = self.root
        node.count += 1
        for c in s:
            c = (ord(c) - 97)
            if (c not in node.child):
                node.child[c] = TrieNode()
            node = node.child[c]
            node.count += 1
        node.child[26] = TrieNode()
        node.child[26].count += 1

    def query(self, s):
        res = [([0] * 27) for _ in range(26)]
        node = self.root
        for c in s:
            c = (ord(c) - 97)
            resc = res[c]
            for (i, child) in node.child.items():
                resc[i] += child.count
            node = node.child[c]
        return res
from itertools import groupby
import sys

def main():
    input = sys.stdin.readline
    n = int(input())
    S = [input()[:(- 1)] for _ in range(n)]
    trie = Trie()
    for s in S:
        trie.add(s)
    q = int(input())
    kp = [input().split() for _ in range(q)]
    Ans = ([(- 1)] * q)
    idxq = sorted(range(q), key=(lambda x: kp[x][0]))
    for (v, g) in groupby(idxq, key=(lambda x: kp[x][0])):
        k = (int(v) - 1)
        lk = trie.query(S[k])
        for idx in g:
            (_, p) = kp[idx]
            p = [(ord(c) - 97) for c in p]
            ans = 1
            for (i, pi) in enumerate(p):
                for pj in p[:i]:
                    ans += lk[pi][pj]
                ans += lk[pi][26]
            Ans[idx] = ans
    print('\n'.join(map(str, Ans)))
main()

