# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
sys.setrecursionlimit((10 ** 7))
import numpy as np
MOD = 924844033

def cumprod(arr, MOD):
    'Calculates the cumulative product of an array

    Args:
        arr (numpy.ndarray): The array to calculate the cumulative product of.
        MOD (int): The modulo to use.

    Returns:
        numpy.ndarray: The cumulative product of the array.
    '
    L = len(arr)
    Lsq = int(((L ** 0.5) + 1))
    arr = np.resize(arr, (Lsq ** 2)).reshape(Lsq, Lsq)
    for n in range(1, Lsq):
        arr[:, n] *= arr[:, (n - 1)]
        arr[:, n] %= MOD
    for n in range(1, Lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:L]

def make_fact(U, MOD):
    'Calculates the factorial and inverse factorial of a number

    Args:
        U (int): The number to calculate the factorial and inverse factorial of.
        MOD (int): The modulo to use.

    Returns:
        tuple: The factorial and inverse factorial of the number.
    '
    x = np.arange(U, dtype=np.int64)
    x[0] = 1
    fact = cumprod(x, MOD)
    x = np.arange(U, 0, (- 1), dtype=np.int64)
    x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
    fact_inv = cumprod(x, MOD)[::(- 1)]
    return (fact, fact_inv)
(N, K) = map(int, readline().split())
dp_0 = np.zeros(((N + 1), (N + 1)), np.int64)
dp_1 = np.zeros(((N + 1), (N + 1)), np.int64)
dp_2 = np.zeros(((N + 1), (N + 1)), np.int64)
dp_0[(0, 0)] = 1
dp_1[(0, 0)] = 1
dp_2[(0, 0)] = 1
for n in range(1, (N + 1)):
    dp_1[n, 1:] += dp_1[(n - 1), :(- 1)]
    dp_2[n, 1:] += dp_2[(n - 1), :(- 1)]
    if (n >= 2):
        dp_0[n, 1:] += dp_0[(n - 1), :(- 1)]
        dp_1[n, 1:] += dp_0[(n - 1), :(- 1)]
    dp_2[n, 1:] += dp_1[(n - 1), :(- 1)]
    dp_0[n] += dp_1[(n - 1)]
    dp_1[n] += dp_1[(n - 1)]
    dp_2[n] += dp_2[(n - 1)]
    dp_0[n] %= MOD
    dp_1[n] %= MOD
    dp_2[n] %= MOD

def F(N, K, n):
    'Calculates the F(N, K, n) function

    Args:
        N (int): The N value.
        K (int): The K value.
        n (int): The n value.

    Returns:
