import pytest

@pytest.mark.parametrize('N, a, expected', [
    (1, [1], 0),
    (2, [1, 2], 1),
    (3, [1, 2, 3], 2),
    (4, [1, 2, 3, 4], 2),
    (5, [1, 2, 3, 4, 5], 3),
    (6, [1, 2, 3, 4, 5, 6], 3),
    (7, [1, 2, 3, 4, 5, 6, 7], 4),
    (8, [1, 2, 3, 4, 5, 6, 7, 8], 4),
    (9, [1, 2, 3, 4, 5, 6, 7, 8, 9], 5),
    (10, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 5),
])
def test_that_the_number_of_inversions_is_correct(N, a, expected):
    b = [0]
    b += a
    cnt = 0
    for i in range(1, N + 1):
        if i == b[b[i]]:
            cnt += 1
    assert cnt // 2 == expected

