# File changed

import sys
read = sys.stdin.buffer.read
readline = sys.stdin.buffer.readline
readlines = sys.stdin.buffer.readlines
import numpy as np
(N, M, K) = map(int, read().split())
MOD = ((10 ** 9) + 7)

def cumprod(arr, MOD):
    'Calculates the cumulative product of the array

    Args:
        arr (np.array): The array to calculate the cumulative product of.
        MOD (int): The modulo to use.

    Returns:
        np.array: The cumulative product of the array.
    '
    L = len(arr)
    Lsq = int(((L ** 0.5) + 1))
    arr = np.resize(arr, (Lsq ** 2)).reshape(Lsq, Lsq)
    for n in range(1, Lsq):
        arr[:, n] *= arr[:, (n - 1)]
        arr[:, n] %= MOD
    for n in range(1, Lsq):
        arr[n] *= arr[((n - 1), (- 1))]
        arr[n] %= MOD
    return arr.ravel()[:L]

def make_fact(U, MOD):
    'Calculates the factorials of the numbers up to U

    Args:
        U (int): The maximum number to calculate the factorial of.
        MOD (int): The modulo to use.

    Returns:
        np.array: The factorials of the numbers up to U.
    '
    x = np.arange(U, dtype=np.int64)
    x[0] = 1
    fact = cumprod(x, MOD)
    x = np.arange(U, 0, (- 1), dtype=np.int64)
    x[0] = pow(int(fact[(- 1)]), (MOD - 2), MOD)
    fact_inv = cumprod(x, MOD)[::(- 1)]
    return (fact, fact_inv)

def make_power(a, L, MOD):
    'Calculates the powers of a up to L

    Args:
        a (int): The number to calculate the powers of.
        L (int): The maximum power to calculate.
        MOD (int): The modulo to use.

    Returns:
        np.array: The powers of a up to L.
    '
    B = L.bit_length()
    x = np.empty((1 + (1 << B)), np.int64)
    x[0] = 1
    x[1] = a
    for n in range(B):
        x[(1 << n):(1 << (n + 1))] = ((x[:(1 << n)] * ((a * x[((1 << n) - 1)]) % MOD)) % MOD)
    return x[:L]
U = (10 ** 6)
power2 = make_power(2, U, MOD)
power2_inv = make_power(pow(2, (MOD - 2), MOD), U, MOD)
power3 = make_power(3, U, MOD)
power3_