# File changed

import sys
from collections import Counter

def make_prime_checker(n):
  isprime = [False, True, False, False, False, True] * ((n // 6) + 1)
  del isprime[(n + 1):]
  isprime[1:4] = (False, True, True)
  for i in range(5, (int((n ** 0.5)) + 1)):
    if isprime[i]:
      isprime[(i * i)::i] = [False] * (((n // i) - i) + 1)
  return isprime

def main():
  primes = [p for (p, is_p) in enumerate(make_prime_checker(2200)) if is_p]

  def decomp(n):
    res1 = res2 = 1
    for p in primes:
      cnt = 0
      while ((n % p) == 0):
        n //= p
        cnt += 1
      cnt %= 3
      if (cnt == 1):
        res1 *= p
      elif (cnt == 2):
        res2 *= p
    if ((int((n ** 0.5)) ** 2) == n):
      res2 *= int((n ** 0.5))
    else:
      res1 *= n
    return (((res1 * res2) * res2), ((res1 * res1) * res2))
  (N, *S) = map(int, sys.stdin.buffer.read().split())
  T = []
  invdict = {}
  for s in S:
    (t, tinv) = decomp(s)
    T.append(t)
    invdict[t] = tinv
  countert = Counter(T)
  ans = 0
  for t, t_cnt in countert.items():
    if (t == 1):
      ans += 1
      continue
    tinv = invdict[t]
    tinvcnt = countert[tinv]
    if ((t_cnt > tinvcnt) or ((t_cnt == tinvcnt) and (t > tinv))):
      ans += t_cnt
  print(ans)

main()

