# File changed


def pow_mod(MOD, a, n):
    'Calculates a^n mod MOD

    Args:
        MOD (int): The modulus to use.
        a (int): The base.
        n (int): The exponent.

    Returns:
        int: a^n mod MOD
    '
    ret = 1
    while (n != 0):
        if ((n % 2) == 1):
            ret = ((ret * a) % MOD)
        a = ((a * a) % MOD)
        n //= 2
    return ret

def fac(n):
    'Calculates n!

    Args:
        n (int): The number to calculate the factorial of.

    Returns:
        int: n!
    '
    MOD = 1000000007
    ret = 1
    for i in range(1, (n + 1)):
        ret = ((ret * i) % MOD)
    return ret

def fac_gen(first, last):
    'Generates a list of factorials

    Args:
        first (int): The first number to calculate the factorial of.
        last (int): The last number to calculate the factorial of.

    Yields:
        int: The factorial of the current number.
    '
    MOD = 1000000007
    ret = fac(first)
    (yield ret)
    for i in range((first + 1), last):
        ret = ((ret * i) % MOD)
        (yield ret)

def build_comb_list(f, m, K):
    'Builds a list of combinations

    Args:
        f (list): The list of factorials.
        m (int): The number of combinations to calculate.
        K (int): The number of combinations to calculate.

    Returns:
        list: The list of combinations.
    '
    MOD = 1000000007
    v = pow_mod(MOD, (f[(m - (K * 2))] * f[0]), (MOD - 2))
    for i in range((m - K), (- 1), (- 1)):
        f[i] *= v
        v = ((v * i) % MOD)

def solve_dp(n, k, comb):
    'Solves the problem using dynamic programming

    Args:
        n (int): The number of balls.
        k (int): The number of boxes.
        comb (list): The list of combinations.

    Returns:
        int: The number of ways to distribute the balls.
    '
    MOD = 1000000007
    dp = ([1] * (n + 1))
    for i in range(2, (n + 1)):
        ci = ((i - 1) * (k - 1))
        v = 0
        for (j, c) in zip(range(i), comb[ci:(ci + i)]):
            v = ((v + (dp[j] * c)) % MOD)
            dp[j] = v
        dp[i] = v
    return ((dp[n] * fac(n)) % MOD)

def solve