# File changed

headercode = '\n\n\n\n\n\n\n\n\n\n\n\n\n\n#include "/opt/atcoder-stl/atcoder/internal_bit.hpp"\n#include "/opt/atcoder-stl/atcoder/lazysegtree.hpp"\n#include "/opt/atcoder-stl/atcoder/modint.hpp"\n#include <vector>\n#include <algorithm>\n#include <cassert>\n\nnamespace aclython {\n\ntemplate <class S, S (*op)(S, S), S (*e)()> struct segtree {\n  public:\n    segtree() : segtree(0) {}\n    segtree(int n) : segtree(std::vector<S>(n, e())) {}\n    segtree(const std::vector<S>& v) : _n(int(v.size())) {\n        log = atcoder::internal::ceil_pow2(_n);\n        size = 1 << log;\n        d = std::vector<S>(2 * size, e());\n        for (int i = 0; i < _n; i++) d[size + i] = v[i];\n        for (int i = size - 1; i >= 1; i--) {\n            update(i);\n        }\n    }\n\n    void set(int p, S x) {\n        assert(0 <= p && p < _n);\n        p += size;\n        d[p] = x;\n        for (int i = 1; i <= log; i++) update(p >> i);\n    }\n\n    S get(int p) {\n        assert(0 <= p && p < _n);\n        return d[p + size];\n    }\n\n    S prod(int l, int r) {\n        assert(0 <= l && l <= r && r <= _n);\n        S sml = e(), smr = e();\n        l += size;\n        r += size;\n\n        while (l < r) {\n            if (l & 1) sml = op(sml, d[l++]);\n            if (r & 1) smr = op(d[--r], smr);\n            l >>= 1;\n            r >>= 1;\n        }\n        return op(sml, smr);\n    }\n\n    S all_prod() { return d[1]; }\n\n    template <bool (*f)(S)> int max_right(int l, S b) {\n        return max_right(l, b, [](S x, S y) { return f(x, y); });\n    }\n    template <class F> int max_right(int l, S b, F f) {\n        assert(0 <= l && l <= _n);\n        assert(f(e()));\n        if (l == _n) return _n;\n        l += size;\n        S sm = e();\n        do {\n            while (l % 2 == 0) l >>= 1;\n            if (!f(op(sm, d[l]), b)) {\n                while (l < size) {\n                    l = (2 * l);\n                    if (f(op(sm, d[l]), b)) {\n                        sm = op(sm, d[l]);\n                        l++;\n                    }\n                }\n                return l - size;\n            }\n            sm = op(sm, d[l]);\n            l++;\n        } while ((l & -l) != l);\n        return _n;\n    }\n\n    template <bool (*f)(S)> int min_left(int r, S b) {\n        return min_left(r, b, [](S x, S y) { return f(x, y); });\n    }\n    template <class F> int min_left(int r, S b, F f) {\n        assert(0 <= r && r <= _n);\n        assert(f(e()));\n        if (r == 0) return 0;\n        r += size;\n        S sm = e();\n        do {\n            r--;\n            while (r > 1 && (r % 2)) r >>= 1;\n            if (!f(op(d[r], sm), b)) {\n                while (r < size) {\n                    r = (2 * r + 1);\n                    if (f(op(d[r], sm), b)) {\n                        sm = op(d[r], sm);\n                        r--;\n                    }\n                }\n                return r + 1 - size;\n            }\n            sm = op(d[r], sm);\n        } while ((r & -r) != r);\n        return 0;\n    }\n\n  private:\n    int _n, size, log;\n    std::vector<S> d;\n\n    void update(int k) { d[k] = op(d[2 * k], d[2 * k + 1]); }\n};\n\n\n\nint min_op(int n, int m){\n    return std::min(n, m);\n}\n\nint min_e(){\n    return (int)1e9;\n}\n\nstruct segtree_min {\n    public:\n        segtree_min() : segtree_min(0) {}\n        segtree_min(int n) : segtree_min(std::vector<int>(n, min_e())) {}\n        segtree_min(const std::vector<int>& vec) : seg(vec) {}\n\n        void set(int p, int x) {seg.set(p, x);}\n        int get(int p) {return seg.get(p);}\n        int prod(int l, int r) {return seg.prod(l, r);}\n        int all_prod() {return seg.all_prod();}\n\n        int max_right(int l, int v) {return seg.max_right(l, v, [](int x, int y) { return x<y; });}\n        int min_left(int r, int v) {return seg.min_left(r, v, [](int x, int y) { return x