# File changed

header_code = '\n\n\n\n\n\n\n\n\n\n\n\n\n\n#include "/opt/atcoder-stl/atcoder/internal_bit.hpp"\n#include "/opt/atcoder-stl/atcoder/lazysegtree.hpp"\n#include "/opt/atcoder-stl/atcoder/modint.hpp"\n#include <vector>\n#include <algorithm>\n#include <cassert>\n\nnamespace aclython {\n\ntemplate <class S, S (*op)(S, S), S (*e)()> struct segtree {\n  public:\n    segtree() : segtree(0) {}\n    segtree(int n) : segtree(std::vector<S>(n, e())) {}\n    segtree(const std::vector<S>& v) : _n(int(v.size())) {\n        log = atcoder::internal::ceil_pow2(_n);\n        size = 1 << log;\n        d = std::vector<S>(2 * size, e());\n        for (int i = 0; i < _n; i++) d[size + i] = v[i];\n        for (int i = size - 1; i >= 1; i--) {\n            update(i);\n        }\n    }\n\n    void set(int p, S x) {\n        assert(0 <= p && p < _n);\n        p += size;\n        d[p] = x;\n        for (int i = 1; i <= log; i++) update(p >> i);\n    }\n\n    S get(int p) {\n        assert(0 <= p && p < _n);\n        return d[p + size];\n    }\n\n    S prod(int l, int r) {\n        assert(0 <= l && l <= r && r <= _n);\n        S sml = e(), smr = e();\n        l += size;\n        r += size;\n\n        while (l < r) {\n            if (l & 1) sml = op(sml, d[l++]);\n            if (r & 1) smr = op(d[--r], smr);\n            l >>= 1;\n            r >>= 1;\n        }\n        return op(sml, smr);\n    }\n\n    S all_prod() { return d[1]; }\n\n    template <bool (*f)(S)> int max_right(int l, S b) {\n        return max_right(l, b, [](S x, S y) { return f(x, y); });\n    }\n    template <class F> int max_right(int l, S b, F f) {\n        assert(0 <= l && l <= _n);\n        assert(f(e()));\n        if (l == _n) return _n;\n        l += size;\n        S sm = e();\n        do {\n            while (l % 2 == 0) l >>= 1;\n            if (!f(op(sm, d[l]), b)) {\n                while (l < size) {\n                    l = (2 * l);\n                    if (f(op(sm, d[l]), b)) {\n                        sm = op(sm, d[l]);\n                        l++;\n                    }\n                }\n                return l - size;\n            }\n            sm = op(sm, d[l]);\n            l++;\n        } while ((l & -l) != l);\n        return _n;\n    }\n\n    template <bool (*f)(S)> int min_left(int r, S b) {\n        return min_left(r, b, [](S x, S y) { return f(x, y); });\n    }\n    template <class F> int min_left(int r, S b, F f) {\n        assert(0 <= r && r <= _n);\n        assert(f(e()));\n        if (r == 0) return 0;\n        r += size;\n        S sm = e();\n        do {\n            r--;\n            while (r > 1 && (r % 2)) r >>= 1;\n            if (!f(op(d[r], sm), b)) {\n                while (r < size) {\n                    r = (2 * r + 1);\n                    if (f(op(d[r], sm), b)) {\n                        sm = op(d[r], sm);\n                        r--;\n                    }\n                }\n                return r + 1 - size;\n            }\n            sm = op(d[r], sm);\n        } while ((r & -r) != r);\n        return 0;\n    }\n\n  private:\n    int _n, size, log;\n    std::vector<S> d;\n\n    void update(int k) { d[k] = op(d[2 * k], d[2 * k + 1]); }\n};\n\n\n\nint min_op(int n, int m){\n    return std::min(n, m);\n}\n\nint min_e(){\n    return (int)1e9;\n}\n\nstruct segtree_min {\n    public:\n        segtree_min() : segtree_min(0) {}\n        segtree_min(int n) : segtree_min(std::vector<int>(n, min_e())) {}\n        segtree_min(const std::vector<int>& vec) : seg(vec) {}\n\n        void set(int p, int x) {seg.set(p, x);}\n        int get(int p) {return seg.get(p);}\n        int prod(int l, int r) {return seg.prod(l, r);}\n        int all_prod() {return seg.all_prod();}\n\n        int max_right(int l, int v) {return seg.max_right(l, v, [](int x, int y) { return x<y; });}\n        int min_left(int r, int v) {return seg.min_left(r, v, [](int x, int y) { return x<y; });}\n\n    private:\n        segtree<int, min_op, min_e> seg;\n};\n\nint max_op(int n, int m){\n    return std::max(n, m);\n}\n\nint max_e(){\n    return 0;\n}\n\nstruct segtree_max {\n    public:\n        segtree_max() : segtree_max(0) {}\n        segtree_max(int n) : segtree_max(std::vector<int>(n, max_e())) {}\n        segtree_max(const std::vector<int>& vec) : seg(vec) {}\n\n        void set(int p, int x) {seg.set(p, x);}\n        int get(int p) {return seg.get(p);}\n        int prod(int l, int r) {return seg.prod(l, r);}\n        int all_prod() {return seg.all_prod();}\n\n        int max_right(int l, int v) {return seg.max_right(l, v, [](int x, int y) { return x<y; });}\n        int min_left(int r, int v) {return seg.min_left(r, v, [](int x, int y) { return x<y; });}\n\n    private:\n        segtree<int, max_op, max_e> seg;\n};\n\nusing mint = atcoder::modint998244353;\n\nstruct S {\n    mint a;\n    int size;\n    S(mint _a, int _size) : a(_a) ,size(_size) {}\n    S(int _a, int _size) : a(_a) ,size(_size) {}\n    S(const S &s) : a(s.a), size(s.size) {}\n    int get_a() { return (int)a.val(); }\n};\n\nstruct F {\n    mint a, b;\n    F(mint _a, mint _b) : a(_a), b(_b) {}\n    F(int _a, int _b) : a(_a), b(_b) {}\n    F(const F &f) : a(f.a), b(f.b) {}\n    int get_a() { return (int)a.val(); }\n    int get_b() { return (int)b.val(); }\n};\n\nS op(S l, S r) { return S{l.a + r.a, l.size + r.size}; }\n\nS e() { return S{0, 0}; }\n\nS mapping(F l, S r) { return S{r.a * l.a + r.size * l.b, r.size}; }\n\nF composition(F l, F r) { return F{r.a * l.a, r.b * l.a + l.b}; }\n\nF id() { return F{1, 0}; }\n\nstruct lazy_segtree{\n    lazy_segtree() : lazy_segtree(0) {}\n    lazy_segtree(int n) : lazy_segtree(std::vector<S>(n, e())) {}\n    lazy_segtree(const std::vector<S>& vec) : seg(vec) {}\n    void set(int p, S x) { seg.set(p, x); }\n    S get(int p) { return seg.get(p); }\n    S prod(int l, int r) { return seg.prod(l, r); }\n    S all_prod() { return seg.all_prod(); }\n    void apply(int p, F f) { seg.apply(p, f); }\n    void apply(int l, int r, F f) { seg.apply(l, r, f); }\n    private:\n        atcoder::lazy_segtree<S, op, e, F, mapping, composition, id> seg;\n};\n\n}\n'
code = '\n\n# distutils: language=c++\n# distutils: include_dirs=[/home/USERNAME/.local/lib/python3.8/site-packages/numpy/core/include, /opt/atcoder-stl]\n# cython: boundscheck=False\n# cython: wraparound=False\n\nfrom libcpp cimport bool\nfrom libcpp.string cimport string\nfrom libcpp.vector cimport vector\nfrom libc.stdio cimport getchar, printf\ncpdef inline vector[int] ReadInt(int n):\n    cdef int b, c\n    cdef vector[int] *v = new vector[int]()\n    for i in range(n):\n        c = 0\n        while 1:\n            b = getchar() - 48\n            if b < 0: break\n            c = c * 10 + b\n        v.push_back(c)\n    return v[0]\n\ncpdef inline vector[string] Read(int n):\n    cdef char c\n    cdef vector[string] *vs = new vector[string]()\n    cdef string *s\n    for i in range(n):\n        s = new string()\n        while 1:\n            c = getchar()\n            if c<=32: break\n            s.push_back(c)\n        vs.push_back(s[0])\n    return vs[0]\n\ncpdef inline void PrintLongN(vector[long] l, int n):\n    for i in range(n): printf("%ld\\n", l[i])\n\ncpdef inline void PrintLong(vector[long] l, int n):\n    for i in range(n): printf("%ld ", l[i])\ncdef extern from "./intermediate.hpp" namespace "aclython" nogil:\n    cdef cppclass segtree_min:\n        segtree_min(vector[int] v)\n        void set(int p, int x)\n        int get(int p)\n        int prod(int l, int r)\n        int all_prod()\n        int max_right(int l, int v)\n        int min_left(int r, int v)\n\ncdef class SegTreeMin:\n    cdef segtree_min *_thisptr\n    def __cinit__(self, vector[int] v):\n        self._thisptr = new segtree_min(v)\n    cpdef void set(self, int p, int x):\n        self._thisptr.set(p, x)\n    cpdef int get(self, int p):\n        return self._thisptr.get(p)\n    cpdef int prod(self, int l, int r):\n        return self._thisptr.prod(l, r)\n    cpdef int all_prod(self):\n        return self._thisptr.all_prod()\n    cpdef int max_right(self, int l, int v):\n        return self._thisptr.max_right(l, v)\n    cpdef int min_left(self, int r, int v):\n        self._thisptr.min_left(r, v)\n\ncdef extern from "./intermediate.hpp" namespace "aclython" nogil:\n    cdef cppclass segtree_max:\n        segtree_max(vector[int] v)\n        void set(int p, int x)\n        int get(int p)\n        int prod(int l, int r)\n        int all_prod()\n        int max_right(int l, int v)\n        int min_left(int r, int v)\n\ncdef class SegTreeMax:\n    cdef segtree_max *_thisptr\n    def __cinit__(self, vector[int] v):\n        self._thisptr = new segtree_max(v)\n    cpdef void set(self, int p, int x):\n        self._thisptr.set(p, x)\n    cpdef int get(self, int p):\n        return self._thisptr.get(p)\n    cpdef int prod(self, int l, int r):\n        return self._thisptr.prod(l, r)\n    cpdef int all_prod(self):\n        return self._thisptr.all_prod()\n    cpdef int max_right(self, int l, int v):\n        return self._thisptr.max_right(l, v)\n    cpdef int min_left(self, int r, int v):\n        self._thisptr.min_left(r, v)\n\n\ndef SegTree(v, op):\n    if op=="min":\n        return SegTreeMin(v)\n    elif op=="max":\n        return SegTreeMax(v)\n\ncdef extern from *:\n    ctypedef long long ll "long long"\n\ncdef extern from "./intermediate.hpp" namespace "aclython" nogil:\n    cdef cppclass S:\n        S(int, int)\n        S(S &)\n        int get_a()\n        int size\n    cdef cppclass F:\n        F(int, int)\n        F(F &)\n        int get_a()\n        int get_b()\n    cdef cppclass lazy_segtree:\n        lazy_segtree(vector[S] v)\n        void set(int p, S x)\n        S get(int p)\n        S prod(int l, int r)\n        S all_prod()\n        void apply(int p, F f)\n        void apply(int l, int r, F f)\n\ncdef class LazySegTree:\n    cdef lazy_segtree *_thisptr\n    def __cinit__(self, vector[vector[int]] v):\n        cdef int n = v.size()\n        cdef vector[S] *sv = new vector[S]()\n        cdef S *s\n        for i in range(n):\n            s = new S(v.at(i).at(0), v.at(i).at(1))\n            sv.push_back(s[0])\n        self._thisptr = new lazy_segtree(sv[0])\n    cpdef void set(self, int p, vector[int] v):\n        cdef S *s = new S(v.at(0), v.at(1))\n        self._thisptr.set(p, s[0])\n    cpdef vector[int] get(self, int p):\n        cdef S *s = new S(self._thisptr.get(p))\n        cdef vector[int] *v = new vector[int]()\n        v.push_back(s.get_a())\n        v.push_back(s.size)\n        return v[0]\n    cpdef vector[int] prod(self, int l, int r):\n        cdef S *s = new S(self._thisptr.prod(l, r))\n        cdef vector[int] *v = new vector[int]()\n        v.push_back(s.get_a())\n        v.push_back(s.size)\n        return v[0]\n    cpdef vector[int] all_prod(self):\n        cdef S *s = new S(self._thisptr.all_prod())\n        cdef vector[int] *v = new vector[int]()\n        v.push_back(s.get_a())\n        v.push_back(s.size)\n        return v[0]\n    cpdef void apply(self, int p, vector[int] v):\n        cdef F *f = new F(v.at(0), v.at(1))\n        self._thisptr.apply(p, f[0])\n    cpdef void apply_range(self, int l, int r, vector[int] v):\n        cdef F *f = new F(v.at(0), v.at(1))\n        self._thisptr.apply(l, r, f[0])\n'
import os, sys, getpass
if (sys.argv[(- 1)] == 'ONLINE_JUDGE'):
    code = code.replace('USERNAME', getpass.getuser())
    open('intermediate.hpp', 'w').write(header_code)
    open('atcoder.pyx', 'w').write(code)
    os.system('cythonize -i -3 -b atcoder.pyx')
    sys.exit(0)
from atcoder import ReadInt, LazySegTree, PrintLongN

def main():
    (N, Q) = ReadInt(2)
    A = ReadInt(N)
    ans = []
    AS = [[a, 1] for a in A]
    ST = LazySegTree(AS)
    for i in range(Q):
        t = ReadInt(1)[0]
        if (t == 0):
            (l, r, c, d) = ReadInt(4)
            ST.apply_range(l, r, [c, d])
        else:
            (l, r) = ReadInt(2)
            ans.append(ST.prod(l, r)[0])
    PrintLongN(ans, len(ans))
if (__name__ == '__main__'):
    main()
